//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bb401KDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.5 com/java/src/com/ibm/beans/demos/a401k/PercentEvent.java, bb401KDemo, bb97c, bb97c9750e 12/9/97 18:29:58 [12/11/97 17:02:14]

package com.ibm.beans.demos.a401k;

/**
 * <p>
 * This class describes the event that gets generated back to
 * the b401k data access bean after a user has changed the
 * percentage allocated to a particular investment choice.
 *
 * @see com.ibm.beans.demos.a401k.PercentListener
 */
public class PercentEvent extends java.util.EventObject
{
  /**
   * Constructs a PercentEvent.
   *
   * @param src <dl><dd>The object that is creating this
   * event.</dd></dl>
   * @param indx <dl><dd>The index into the list
   * of investment choices.</dd></dl>
   * @param name <dl><dd>The name of the investment
   * choice.</dd></dl>
   * @param percent <dl><dd>The new percentage amount
   * for the investment choice.</dd></dl>
   */
  public PercentEvent(Object src, int indx, String name, int percent)
  {
    super(src);
    this.index      = indx;
    this.investName = name;
    this.newPercent = percent;
  }

  /**
   * The accessor for the index into the investment choices list.
   * @return The index for the investment choice that changed.
   */
  public int getIndex()
  {
    return index;
  }

  /**
   * The accessor for the new percent value of the investment choice.
   * @return The new percent value for the investment choice that changed.
   */
  public int getNewPercent()
  {
    return newPercent;
  }

  /**
   * The accessor for the name of the investment choice.
   * @return The name of the investment choice that changed.
   */
  public String getInvestName()
  {
    return investName;
  }


  /** The index into the list of investment choices. */
  protected int    index;
  /** The name of the investment choice.             */
  protected String investName;
  /** The new percentage amount of the investment choice.   */
  protected int    newPercent;

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

