//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bb401KDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.6 com/java/src/com/ibm/beans/demos/a401k/acctid/AccountID.java, bb401KDemo, bb97c, bb97c9750e 12/9/97 18:33:45 [12/11/97 17:02:18]

package com.ibm.beans.demos.a401k.acctid;

import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent; //jwa
import java.awt.event.ActionListener; //jwa
import java.io.Serializable; //jwa
import java.util.Vector; //kdj

/**
 * <p>
 * This bean is a simple account id bean which consists of an entry field and a submit
 * button.  The bean is wired to the b401kDap bean so that when a user enters an account id
 * and presses the submit button, that information is forwarded so that the b401kDap bean
 * can look up the corresponding account information.
 * @see com.ibm.beans.demos.a401k.b401kDap
 */
public class AccountID extends Panel implements Serializable, ActionListener { //jwa: added Serializable, ActionListener

   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
   private final static long serialVersionUID = 2000L; // serial version unique ID

/*-----------------------------------------------------------------------------+
|  Instance data:                                                              |
+-----------------------------------------------------------------------------*/

   private TextField     accountID; // Account ID entry field
   private Button        ok;        // 'OK' button
//kdj   private AccountIDPart part;      // Part object
   private Vector listeners = new Vector(); //kdj, list of listeners


/*-----------------------------------------------------------------------------+
|  Methods:                                                                    |
+-----------------------------------------------------------------------------*/

//kdj   public AccountID ( AccountIDPart part ) {
  /**
   * Constructs an instance of the account id bean.  The constructor
   * initializes instance data and builds the graphical user interface.
   */
    public AccountID ( ) { //kdj

//@X1 setBackground( Color.white );
      setBackground(new Color(255,255,204));                    //@X1 - CREME
//kdj      this.part = part;
      setLayout( new GridBagLayout() );
      GridBagConstraints c = new GridBagConstraints();
//@X1 Label label          = new Label( "Account ID:", Label.RIGHT );
      Label label = new Label("ACCOUNT ID",Label.RIGHT );       //@X1
      label.setFont(new Font("Helvetica",Font.BOLD,11) );       //@X1
      label.setForeground( new Color(204,0,0) );                //@X1 - RED
      constrain( c, label, 0, 0, 1, 1,
                 GridBagConstraints.NONE, GridBagConstraints.CENTER,
                 0.0, 0.0, 0, 2, 0, 2 );

      accountID = new TextField( "", 64 );
//@X1 accountID.setBackground( Color.black );
      accountID.setBackground(new Color(68,68,68) );            //@X1, GREY
//@X1 accountID.setForeground( Color.green );
      accountID.setForeground( Color.white );                   //@X1
      accountID.setFont( new Font("Helvetica",Font.PLAIN,12) ); //@X1
      constrain( c, accountID, 1, 0, 1, 1,
                 GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER,
                 1.0, 0.0, 0, 2, 0, 2 );

      ok = new Button( "Submit" );
      constrain( c, ok, 2, 0, 1, 1,
                 GridBagConstraints.NONE, GridBagConstraints.CENTER,
                 0.0, 0.0, 0, 2, 0, 2 );

      add( label );
      add( accountID );
      add( ok );

      ok.addActionListener( this ); //jwa: updated to 1.1 event model
   }

   /**
    * Allows other beans to listen to the AccountIDInformationChanged events this bean generates.
    * This is the addListener method for all listeners that want to be notified
    * when an AccountIDInformationChanged event occurs.  In the demo, the b401kDap
    * bean is wired to the AccountID bean and is notified when the AccountIDInformationChanged event happens.
    * @param  aIDChanged The registering listener.
    * @see #removeAccountIDChangedListener
    */
   public synchronized void addAccountIDChangedListener(AccountIDChangedListener aIDChanged) {
       listeners.addElement(aIDChanged);
   }

   /**
    * Allows beans to remove themselves from the listener list for this bean's
    * AccountIDInformationChanged event.
    * This is the removeListener method for all listeners that want to be notified
    * when an AccountIDInformationChanged event occurs.  In the demo, the b401kDap
    * bean is wired to the AccountID bean and is notified when the AccountIDInformationChanged event
    * happens.
    * @param  aIDChanged The unregistering listener.
    * @see #addAccountIDChangedListener
    */
   public synchronized void removeAccountIDChangedListener(AccountIDChangedListener aIDChanged) {
       listeners.removeElement(aIDChanged);
   }

   /**
   * Notifies all registered listeners that an AccountIDInformationChanged event has
   * occurred.  In the demo, this event fires in response to a users
   * entering an account number and hitting the submit button.
   * @param  accountID  The account id entered by the user.
   *
   */
   protected void fireAccountIDChanged(String accountID) {
       Vector l;
       AccountIDChangedEvent aIDChanged = new AccountIDChangedEvent(this,accountID);

       synchronized(this) {l = (Vector)listeners.clone(); }

       for (int i = 0; i < l.size(); i++) {
          ((AccountIDChangedListener)l.elementAt(i)).AccountIDInformationChanged(aIDChanged);
       }

   }

   // Return the preferred size of the panel:
   public Dimension getpreferredSize ( ) {
      Dimension d = accountID.getPreferredSize();
      return new Dimension( Integer.MAX_VALUE, d.height + 12 );
   }

   //april21
   public Dimension getminimumSize() {
      return getpreferredSize();
   }

   // Handle a button click:
   public void actionPerformed ( ActionEvent event ) { //jwa: changed action() to actionPerformed()
      if ( event.getSource().equals( ok ) ) { //jwa: updated to 1.1 event model
//kdj         part.setAccountID( accountID.getText() );

      //kdj start

         fireAccountIDChanged(accountID.getText());
      //kdj end

      }
   }



   // Handle a paint request:
   public void paint ( Graphics g ) {


      super.paint( g );
      g.setColor( Color.black );
      Dimension d = getSize();

      //@X1 - could add these if we want to add extra emphasis to the line at the top
      //of the entry field - however, this causes the border to be very narrow - so,
      //decided not to use this
//    Rectangle r = accountID.bounds();                      //@X1
//    g.drawLine(r.x, r.y - 1,r.width + r.x - 2, r.y - 1);   //@X1

      g.drawLine( 0, 0, d.width - 1, 0 );
      g.drawLine( 0, d.height - 1, d.width - 1, d.height - 1 );
   }

/*-----------------------------------------------------------------------------+
|  Private methods:                                                            |
+-----------------------------------------------------------------------------*/

   private void constrain ( GridBagConstraints c, Component component,
                            int grid_x,           int grid_y,
                            int grid_width,       int grid_height,
                            int fill,             int anchor,
                            double weight_x,      double weight_y,
                            int top,              int left,
                            int bottom,           int right ) {
      c.gridx      = grid_x;
      c.gridy      = grid_y;
      c.gridwidth  = grid_width;
      c.gridheight = grid_height;
      c.fill       = fill;
      c.anchor     = anchor;
      c.weightx    = weight_x;
      c.weighty    = weight_y;
      if ( top + bottom + left + right > 0 )
         c.insets = new Insets( top, left, bottom, right );
      ((GridBagLayout) getLayout()).setConstraints( component, c );
   }
}
