//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bb401KDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.5 com/java/src/com/ibm/beans/demos/a401k/b401kEvent.java, bb401KDemo, bb97c, bb97c9750e 12/9/97 18:30:36 [12/11/97 17:02:10]

package com.ibm.beans.demos.a401k;

/**
 * <p>
 * This class describes the event that gets generated by the
 * b401kDap bean when a users investment portfolio is selected
 * by entering an account id and hitting the submit button, or when a
 * users investment portfolio is modified by using the viewer to change
 * a percentage allocation on an investment choice.
 *
 * @see com.ibm.beans.demos.a401k.b401kListener
 */
public class b401kEvent extends java.util.EventObject
{
  /**
   * Constructs a b401kEvent.
   *
   * @param src <dl><dd>The object that is creating this
   * event.</dd></dl>
   * @param ics <dl><dd>The array of strings which
   * contain the names of the investment choices.</dd></dl>
   * @param icps <dl><dd>The array of integers which
   * contain the percentages of each investment choice.</dd></dl>
   * @param totp <dl><dd>The total percentage amount
   * for all of the investment choices.</dd></dl>
   */
  public b401kEvent(Object src, String[] ics, int[] icps, int totp)
  {
    super(src);
    this.investmentChoices           = ics;
    this.investmentChoicePercentages = icps;
    this.totalPercentage             = totp;
  }

  /**
   * The accessor for the investment choices list.
   * @return An array containing the names of all of the investment choices.
   */
  public String[] getInvestmentChoices()
  {
    return investmentChoices;
  }

  /**
   * The accessor for the investment choices percentages list.
   * @return An array containing the percentages of all of the investment choices.
   */
  public int[] getInvestmentChoicePercentages()
  {
    return investmentChoicePercentages;
  }

  /**
   * The accessor for the total percentage of all of the investment choices.
   * @return The total percentage of all of the investment choices.
   */
  public int getTotalPercentage()
  {
    return totalPercentage;
  }

  /** The array of strings which contain the names of the investment choices */
  protected String[] investmentChoices;
  /** The array of integers which contain the percentages of the investment choices */
  protected int[]    investmentChoicePercentages;
  /** The total percentage amount for all of the investment choices */
  protected int      totalPercentage;

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

