//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//   @(#) 1.22 com/java/src/com/ibm/beans/demos/travel/ItineraryFlightSubInfo.java, bbTravelDemo, bb97c, bb97c9750e 10/28/97 14:42:20 [12/11/97 17:03:00]
//
package com.ibm.beans.demos.travel;

import java.awt.TextField;
import java.awt.Label;
import java.awt.Window;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Container;
import java.awt.Component;
import java.awt.Color;
import java.awt.Insets;
import java.awt.Point;

import java.awt.event.TextListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseAdapter;
import java.awt.event.TextEvent;
import java.awt.event.MouseEvent;

import java.io.Serializable;
import java.io.ObjectInputStream;
import java.io.IOException;

import java.util.Vector;
import java.util.ResourceBundle;
import java.text.DateFormat;

import com.ibm.beans.demos.travel.flight.FlightInformation;

import tisl.jeans.calendar.Calendar;                // calendar.jar
import tisl.jeans.calendar.CalendarEvent;           // calendar.jar
import tisl.jeans.calendar.CalendarEventListener;   // calendar.jar

/**
 * The ItineraryFlightSubInfo class displays a leg of a flight
 * with "clickable" text.
 * <p>
 * The ItineraryFlightSubInfo contains:
 * <ol>
 * <li>Date
 * <li>Airline and flight number
 * <li>Departure info  (city, airport code, time)
 * <li>Arrival info    (city, airport code, time)
 * <li>Class
 * <li>Cost
 * </ol>
 */
public class ItineraryFlightSubInfo extends Panel implements Serializable
{
  /**
   * Constructs an ItineraryFlightSubInfo object.
   *
   * @param itin Indicates the Itinerary object
   * that called the constructor (the container object).
   *
   */
  public ItineraryFlightSubInfo(Itinerary itin)
  {
    super();

    itinerary = itin;

    GridBagLayout gridbag = new GridBagLayout();
    this.setLayout(gridbag);

    //    --------
    //    | date |
    //    --------
    //           ------------------
    //           | departure info |
    //           ------------------
    //           | arrival info   |
    //           -----------------------------------
    //           | airline flight # | class | cost |
    //           -----------------------------------
    //           <previous three lines repeated for a two-leg flight>


    // DateLabel            ===================
    dateLabel = new Label();
    dateLabel.setBackground(Color.white);
    dateLabel.setForeground(Color.blue);
    flightDate = new java.util.Date();   // Defaults to today's date
    dateLabel.setText(DateFormat.getDateInstance().format(flightDate));
    constrain(this, dateLabel,
              0, 0, 1, 1,               // grid x, grid y, gridwidth, gridheight
              GridBagConstraints.NONE,  // Grow in both directions
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);              // above, left, bottom, right


    // reservedLabel      =====================
    reservedLabel = new Label();
    reservedLabel.setBackground(Color.white);
    reservedLabel.setForeground(Color.red);
    reservedLabel.setText(getMsg("reserved"));
    reservedLabel.setVisible(false);
    constrain(this, reservedLabel,
                 1, 0, 1, 1,
                 GridBagConstraints.NONE,
                 GridBagConstraints.NORTHWEST,
                 0, 0,
                 0, 0, 0, 0);

    // deptLabel           ===================
    deptLabel = new Label();
    deptLabel.setBackground(Color.white);
    deptLabel.setText(getMsg("depart"));
    constrain(this, deptLabel,
              1, 1, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


    // deptTextField ===================
    deptTextField = new TextField(10);
    deptTextField.setForeground(Color.blue);
    constrain(this, deptTextField,
              2, 1, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    // deptLabel2           ===================
    deptLabel2 = new Label();
    deptLabel2.setBackground(Color.white);
    constrain(this, deptLabel2,
              3, 1, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


    // arriveLabel         ===================
    arriveLabel = new Label();
    arriveLabel.setBackground(Color.white);
    arriveLabel.setText(getMsg("arrive"));
    constrain(this, arriveLabel,
              1, 2, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    // arriveTextField ===================
    arriveTextField = new TextField(10);
    arriveTextField.setForeground(Color.blue);
    constrain(this, arriveTextField,
              2, 2, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    // arriveLabel3           ===================
    arriveLabel3 = new Label();
    arriveLabel3.setBackground(Color.white);
    constrain(this, arriveLabel3,
              3, 2, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


    // airlineFlightLabel   ===================
    airlineFlightLabel = new Label();
    airlineFlightLabel.setBackground(Color.white);
    airlineFlightLabel.setForeground(Color.blue);
    constrain(this, airlineFlightLabel,
              1, 3, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    // classLabel           ===================
    classLabel = new Label();
    classLabel.setBackground(Color.white);
    constrain(this, classLabel,
              2, 3, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    // costLabel           ===================
    costLabel = new Label();
    costLabel.setBackground(Color.white);
    constrain(this, costLabel,
              3, 3, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

    resetFlightSelected();  // init text in labels

    // Set up all the actions to flow to the listener
    itineraryFlightSubInfoListener =
	new ItineraryFlightSubInfoListener(this, dateLabel, airlineFlightLabel,
		deptTextField, arriveTextField);
    dateLabel.addMouseListener(itineraryFlightSubInfoListener);
    airlineFlightLabel.addMouseListener(itineraryFlightSubInfoListener);
    deptTextField.addTextListener(itineraryFlightSubInfoListener);
    arriveTextField.addTextListener(itineraryFlightSubInfoListener);

  }

  /**
   * Sets the flightDate property.
   *
   * @param flghtDte The new value of the flightDate property.
   */
  public void setFlightDate(java.util.Date flghtDte)
  {
    flightDate = flghtDte;
  }

  /**
   *  Retrives the value of the flightDate property.
   *
   *  @return The current value of the flightDate property is returned.
   */
  public java.util.Date getFlightDate()
  {
    return flightDate;
  }

  /**
   *  Retrives the value of the originCity property.
   *
   *  @return The current value of the originCity property is returned.
   */
  public String getOriginCity()
  {
    return originCity;
  }

  /**
   * Sets the originCity property.
   *
   * @param city The new value of the originCity property.
   */
  public void setOriginCity(String city)
  {
    originCity = city.trim();
  }

  /**
   *  Gets the value of the destinationCity property.
   *
   *  @return The current value of the destinationCity property is returned.
   */
  public String getDestinationCity()
  {
    return destinationCity;
  }

  /**
   * Sets the destinationCity property.
   *
   * @param city This parameter is the new value of the destinationCity property.
   */
  public void setDestinationCity(String city)
  {
    destinationCity = city.trim();
  }

  /**
   *  Gets the value of the flightInformation property.
   *
   *  @return The current value of the flightInformation property is returned.
   */
  public FlightInformation getFlightInformation()
  {
     return flightInformation;
  }

  // Tell the Itinerary to send a TravelInfoChangedEvent and
  // remember who we are.
  void fireTravelInfoChanged()
  {
    itinerary.fireTravelInfoChanged(this);
  }

  /**
   * Responds to the Itinerary container by updating the flight information,
   * and its display, when a flight has been selected from the FlightInfoViewer.
   *
   * @param fi The FlightInformation object that encapsulates the
   * details of the selected flight.
   */
  public void setFlightInformation(FlightInformation fi)
  {
    if (flightInformation != null)
       resetFlightSelected();  // remove any previously displayed flight
    flightInformation = fi;
    airlineFlightLabel.setText( fi.getAirline() + " " +
		getMsg("flight_num") + fi.getFlightNum() );
    airlineFlightLabel.invalidate();  // force a resize
    classLabel.setText(         fi.getWhichClass() + "  " +
			getMsg("seat_num") + fi.getSeatNum() );
    classLabel.invalidate();  // force a resize
    costLabel.setText(          java.text.NumberFormat.
		getCurrencyInstance().format(fi.getPrice()));
    costLabel.invalidate();  // force a resize
    deptLabel2.setText(          " (" + fi.getAirportCodeStartCity() + ")   "
					+ fi.getDepartTime() );
    deptLabel2.invalidate();  // force a resize
    arriveLabel3.setText(        " (" + fi.getAirportCodeEndCity()   + ")   "
					+ fi.getArriveTime() );
    arriveLabel3.invalidate();  // force a resize

    // Special handling for a flight with two segments:
    if (fi.getbHasConnection()) {
	// move the arrival city text field down to make more room:
	remove(arriveTextField);
        constrain(this, arriveTextField,
              2, 5, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);
	arriveTextField.invalidate();

	// put in a label to replace the moved TextField:

        // arriveLabel2           ===================
        arriveLabel2 = new Label();
        arriveLabel2.setBackground(Color.white);
        arriveLabel2.setText(fi.getEndCity());
        constrain(this, arriveLabel2,
              2, 2, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

        // dept2Label           ===================
        dept2Label = new Label();
        dept2Label.setBackground(Color.white);
        dept2Label.setText(getMsg("depart"));
        constrain(this, dept2Label,
              1, 4, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


        // dept2Label2           ===================
        dept2Label2 = new Label();
        dept2Label2.setBackground(Color.white);
        dept2Label2.setText(fi.getEndCity());
        constrain(this, dept2Label2,
              2, 4, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

        // dept2Label3           ===================
        dept2Label3 = new Label();
        dept2Label3.setBackground(Color.white);
        dept2Label3.setText(" (" + fi.getAirportCodeEndCity() + ")   "
					+ fi.getDepartTime2() );
        constrain(this, dept2Label3,
              3, 4, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


        // arrive2Label         ===================
        arrive2Label = new Label();
        arrive2Label.setBackground(Color.white);
        arrive2Label.setText(getMsg("arrive"));
        constrain(this, arrive2Label,
              1, 5, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


        // arrive2Label3           ===================
        arrive2Label3 = new Label();
        arrive2Label3.setBackground(Color.white);
        arrive2Label3.setText(" (" + fi.getAirportCodeEndCity2() + ")   "
					+ fi.getArriveTime2() );
        constrain(this, arrive2Label3,
              3, 5, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);


        // airlineFlightLabel2   ===================
        airlineFlightLabel2 = new Label();
        airlineFlightLabel2.setBackground(Color.white);
        airlineFlightLabel2.setText( fi.getAirline2() + " " +
		getMsg("flight_num") + fi.getFlightNum2() );
        constrain(this, airlineFlightLabel2,
              1, 6, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

        // classLabel2           ===================
        classLabel2 = new Label();
        classLabel2.setBackground(Color.white);
        classLabel2.setText(fi.getWhichClass2() + "  " +
			getMsg("seat_num") + fi.getSeatNum2() );
        constrain(this, classLabel2,
              2, 6, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

        // costLabel2           ===================
        costLabel2 = new Label();
        costLabel2.setBackground(Color.white);
        costLabel2.setText(java.text.NumberFormat.
		getCurrencyInstance().format(fi.getPrice2()));
        constrain(this, costLabel2,
              3, 6, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);

	invalidate();
    }
  }

  /**
   *  Responds to the Itinerary when it receives a
   *  FlightReservedEvent, by  updating the display
   *  to indicate that the displayed flight
   *  has been reserved.  This is done by making the "RESERVED" label
   *  visible.
   */
  public void markFlightReserved()
  {
    if (flightInformation != null) {
       reservedLabel.setVisible(true);
       reservedLabel.invalidate();
    }
  }

  // Tell our container Itinerary that we should now be the "current"
  // ItineraryFlightSubInfo (the one currently in focus, last clicked on).
  void setCurrent()
  {
    itinerary.setCurrentItineraryFlightSubInfo(this);
  }


  // Indicates that we no longer have a selected flight.
  void resetFlightSelected()
  {
    if ((flightInformation != null) && flightInformation.getbHasConnection()) {

        // We were previously displaying a flight with two legs, so
        // now we need to remove some of the labels and move the
        // arriveTextField back to its former position.
	remove(arriveTextField);
        constrain(this, arriveTextField,
              2, 2, 1, 1,
              GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0, 0,
              0, 0, 0, 0);
	arriveTextField.invalidate();
	remove(arriveLabel2);
	arriveLabel2 = null;
	remove(dept2Label);
	dept2Label = null;
	remove(dept2Label2);
	dept2Label2 = null;
	remove(dept2Label3);
	dept2Label3 = null;
	remove(arrive2Label);
	arrive2Label = null;
	remove(arrive2Label3);
	arrive2Label3 = null;
	remove(airlineFlightLabel2);
	airlineFlightLabel2 = null;
	remove(classLabel2);
	classLabel2 = null;
	remove(costLabel2);
	costLabel2 = null;
	invalidate();
    }
    flightInformation = null;
    // If the user erased one of the cities, he can't select a flight yet:
    if ((originCity != null) && (destinationCity != null) &&
		!originCity.equals("") && !destinationCity.equals(""))
       airlineFlightLabel.setText(getMsg("select_flight"));
    else
       airlineFlightLabel.setText("");
    airlineFlightLabel.invalidate();  // force a resize

    classLabel.setText("");
    costLabel.setText("");
    deptLabel2.setText("");
    arriveLabel3.setText("");

    // The flight has been removed and so is no longer reserved:
    if (reservedLabel != null) {
       reservedLabel.setVisible(false);
       reservedLabel.invalidate();
    }
    itinerary.validate();  // Force a repaint!
  }

  // position and add a component in a GridBagLayout
  void constrain(Container container, Component component,
                 int grid_x, int grid_y, int grid_width, int grid_height,
                 int fill, int anchor, double weight_x, double weight_y,
                 int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx      = grid_x;
    c.gridy      = grid_y;
    c.gridwidth  = grid_width;
    c.gridheight = grid_height;
    c.fill       = fill;
    c.anchor     = anchor;
    c.weightx    = weight_x;
    c.weighty    = weight_y;

    if (top+bottom+left+right>0)
      c.insets = new Insets(top,left,bottom,right);

    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }


  /**
   * This method is called whenever the FlightInfoViewer bean is instantiated
   * from serialized data (such as a .ser file).  It is overridden so that
   * transient data (that is, data not serialized) can be initialized (then
   * it just calls defaultReadObject on the ObjectInputStream to let it take
   * care of initializing all of the non-transient data).
   */
  private void readObject(ObjectInputStream in)
			throws IOException, ClassNotFoundException
  {
    // Initialize transient data
    msgs = null;

    in.defaultReadObject();

    itineraryFlightSubInfoListener =
	new ItineraryFlightSubInfoListener(this, dateLabel, airlineFlightLabel,
		deptTextField, arriveTextField);
    dateLabel.addMouseListener(itineraryFlightSubInfoListener);
    airlineFlightLabel.addMouseListener(itineraryFlightSubInfoListener);
    deptTextField.addTextListener(itineraryFlightSubInfoListener);
    arriveTextField.addTextListener(itineraryFlightSubInfoListener);
  }

  // Get text from a ResourceBundle
  String getMsg(String key)
  {
    if (msgs == null)
      msgs = (TravelResourceBundle)ResourceBundle.getBundle(
        "com.ibm.beans.demos.travel.TravelResourceBundle");

    return (String)msgs.handleGetObject(key);
  }

  private Itinerary itinerary;			// the containing Itinerary
  private java.util.Date flightDate;    	// user's preferred date
  private String         originCity;		// user input city
  private String         destinationCity;       // user input city
  private FlightInformation  flightInformation; // selected flight

  private Label          dateLabel;		// date of travel
  private Label          airlineFlightLabel;    // airline name, leg 1
  private Label          airlineFlightLabel2;   // airline name, leg 2
  private Label          classLabel;		// economy/1st, leg 1
  private Label          classLabel2;		// economy/1st, leg 2
  private Label          costLabel;		// flight cost, leg 1
  private Label          costLabel2;		// flight cost, leg 1
  private Label          deptLabel;		// "Depart from" label, leg 1
  private Label          dept2Label; 		// "Depart from" label, leg 2
  private Label          arriveLabel;		// "Arrive at" label, leg 1
  private Label          arrive2Label;		// "Arrive at" label, leg 2
  private Label          deptLabel2;		// time of departure, leg 1
  private Label          dept2Label2;		// connecting city
  private Label          dept2Label3;		// time of departure, leg 2
  private Label          arriveLabel2;		// connecting city
  private Label          arriveLabel3;		// time of arrival, leg 1
  private Label          arrive2Label3;		// time of arrival, leg 2
  private Label          reservedLabel;		// "RESERVED" label
  private TextField      deptTextField;		// Text field for city input
  private TextField      arriveTextField;	// Text field for city input

  private transient ItineraryFlightSubInfoListener itineraryFlightSubInfoListener;
  private transient TravelResourceBundle      msgs = null;
  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
  private static final long serialVersionUID = 2000L;  // serial version unique ID
}

class ItineraryFlightSubInfoListener extends MouseAdapter
			     implements CalendarEventListener, TextListener
{
  ItineraryFlightSubInfoListener(ItineraryFlightSubInfo itin,
	Label datel,  Label airlineFlightl,
 	TextField deptTextField, TextField arriveTextField)
  {
    itineraryFlightSubInfo = itin;
    dateLabel              = datel;
    airlineFlightLabel     = airlineFlightl;
    textField1		   = deptTextField;
    textField2 	           = arriveTextField;

    cal       = new Calendar();
    calFrame  = new Frame();
    calWindow = new Window(calFrame);
    calWindow.add(cal);
    calWindow.pack();
    cal.addCalendarEventListener(this);
  }

  /**
   * This method handles mouse entry events on the ItineraryFlightSubInfo.
   * <p>
   * @param me This parameter is the mouse entry event to be handled.
   */
  public void mouseEntered(MouseEvent me)
  {
    Component c = me.getComponent();

    if(c.equals(dateLabel))
    {
      dateLabel.setBackground(Color.yellow);
    }
    else if(c.equals(airlineFlightLabel))
    {
      airlineFlightLabel.setBackground(Color.yellow);
    }
  }

  /**
   * This method handles mouse exit events on the ItineraryFlightSubInfo.
   * <p>
   * @param me This parameter is the mouse exit event to be handled.
   */
  public void mouseExited(MouseEvent me)
  {
    Component c = me.getComponent();

    if(c.equals(dateLabel))
    {
      dateLabel.setBackground(Color.white);
    }
    else if(c.equals(airlineFlightLabel))
    {
      airlineFlightLabel.setBackground(Color.white);
    }
  }

  /**
   * This method handles mouse clicks on the ItineraryFlightSubInfo.
   * <p>
   * @param me This parameter is the mouse clikc event to be handled.
   */
  public void mouseClicked(MouseEvent me)
  {
    Component c = me.getComponent();

    // One of this subinfo's labels was clicked on,
    // so make this the currentSubInfo:
    itineraryFlightSubInfo.setCurrent();

    if(c.equals(dateLabel))
    {
      cal.setVisible(true);  // No way to initialize the Calendar date,
			     //each subinfo has it's own calendar instance
                             // that hides and shows and thereby
			     // remembers the last date picked.
      Point locPt = dateLabel.getLocationOnScreen();
      calWindow.setLocation(locPt);
      calWindow.setVisible(true);
    }
    else if(c.equals(airlineFlightLabel))
    {
      // Tell the Itinerary to send an ItinerarySelectFlightEvent
      // and remember who we are:
      itineraryFlightSubInfo.fireTravelInfoChanged();
    }
  }

  /**
   *  This method handles changes to the contents of TextFields in the
   *  ItineraryFlightSubInfo.
   *
   *  @param te This parameter is the TextEvent to be handled.
   */
  public void textValueChanged (TextEvent te) {
    TextField tf = (TextField) te.getSource();
    if (tf.equals(textField1))
       itineraryFlightSubInfo.setOriginCity(tf.getText());
    else
       itineraryFlightSubInfo.setDestinationCity(tf.getText());
    itineraryFlightSubInfo.resetFlightSelected();
  }

  /**
   * This method receives a CalendarEvent date from the Calendar bean
   * when the user selects a date.
   *
   * @param ce This parameter is the CalendarEvent, containing the chosen date.
   */
  public void receiveDate(CalendarEvent ce)
  {
    tisl.jeans.calendar.Date tislDate = ce.getDate();

    java.util.Date              awtDate = new java.util.Date();
    java.util.GregorianCalendar awtCal  = new java.util.GregorianCalendar();

    awtCal.set(tislDate.getYear(),tislDate.getMonth(),tislDate.getDate()+1);

    awtDate = awtCal.getTime();
    itineraryFlightSubInfo.setFlightDate(awtDate);  // Always track flight date

    dateLabel.setText(DateFormat.getDateInstance().format(awtDate));

    // Make sure it says, "click to select flight":
    itineraryFlightSubInfo.resetFlightSelected();

    calWindow.setVisible(false);
  }


  String getMsg(String key)
  {
    if (msgs == null)
      msgs = (TravelResourceBundle)ResourceBundle.getBundle(
        "com.ibm.beans.demos.travel.TravelResourceBundle");

    return (String)msgs.handleGetObject(key);
  }

  private Frame                    calFrame;
  private Window                   calWindow;
  private Calendar                 cal;
  private ItineraryFlightSubInfo   itineraryFlightSubInfo;
  private Label                    dateLabel          = null;
  private Label                    airlineFlightLabel = null;
  private TextField		   textField1  	      = null;
  private TextField		   textField2  	      = null;
  private TravelResourceBundle     msgs               = null;
  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
  private static final long serialVersionUID = 2000L;  // serial version unique ID
}
