//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/demos/travel/TravelInfoChangedEvent.java, bbTravelDemo, bb97c, bb97c9750e 10/28/97 14:48:22 [12/11/97 17:03:06]

package com.ibm.beans.demos.travel;

/**
 * <p>
 * This class describes the event that gets generated by
 * the Itinerary bean when the user submits all travel selections.
 *
 * @see com.ibm.beans.demos.travel.TravelInfoChangedListener
 */
public class TravelInfoChangedEvent extends java.util.EventObject implements java.io.Serializable {

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
  private static final long serialVersionUID = 2000L;  // serial version unique ID

  // ..................protected data members:...................
  protected String originCity;
  protected String destinationCity;
  protected java.util.Date departDate;  		// lea, 7/14
  // protected String returnDate;
  // ............................................................

  /**
   * Constructs a TravelInfoChangedEvent.
   *
   * @param source <dl><dd>The object that is creating this
   * event.</dd></dl>
   * @param originCity <dl><dd>The city that the traveler
   * is starting from.</dd></dl>
   * @param destinationCity <dl><dd>The city to which
   * the user is travelling.</dd></dl>
   * @param departDate <dl><dd>The date
   * on which travel will commence.</dd></dl>
   */
  public TravelInfoChangedEvent(Object source, String originCity,
				String destinationCity,
				java.util.Date departDate) {
    super(source);
    this.originCity = originCity;
    this.destinationCity = destinationCity;
    this.departDate = departDate;
    // this.returnDate = returnDate;
  }

  /**
   * Responds to garbage collection to do uninitialization.
   *
   * @exception Throwable Contains information regarding any error conditions
   * that may occur during finalization.
   */
  protected void finalize() throws Throwable {
     super.finalize();
  }

  // ............Public read-only access to data members:.........
  // These are not synchronized because this object is immutable.

  /**
   * The accessor for the city of origin enterred by the user.
   * @return The city of origin specified by the user is returned.
   */
  public String getOriginCity() {return originCity;}
  /**
   * The accessor for the desination city enterred by the user.
   * @return The destination city specified by the user is returned.
   */
  public String getDestinationCity() {return destinationCity;}
  /**
   * The accessor for the departure date enterred by the user.
   * @return The departure date specified by the user is returned.
   */
  public java.util.Date getDepartDate() {return departDate;}

  // public String getReturnDate() {return returnDate;}


  // ............equals and hashCode implementations:.........
  /**
   * Determines whether two TravelInfoChangedEvent objects
   * are equivalent.
   *
   * @param o The reference object with which to compare.
   * @return Returns <tt>true</tt> if the reference object is the
   * same as this object, <tt>false</tt> otherwise.
   */
  public boolean equals (Object o) {
     if (o == this)
	return true;
     if (getClass() != o.getClass())
	return false;
     TravelInfoChangedEvent other = (TravelInfoChangedEvent) o;
     if (getOriginCity() == null) {
	if (other.getOriginCity() != null)
	   return false;
	else
	   return true;
     }
     if (!(getOriginCity().equals(other.getOriginCity())))
	return false;
     if (getDestinationCity() == null) {
	if (other.getDestinationCity() != null)
	   return false;
	else
	   return true;
     }
     if (!(getDestinationCity().equals(other.getDestinationCity())))
	return false;
     if (getDepartDate() == null) {
	if (other.getDepartDate() != null)
	   return false;
	else
	   return true;
     }
     if (!(getDepartDate().equals(other.getDepartDate())))
	return false;
     /*
     if (getReturnDate() == null) {
	if (other.getReturnDate() != null)
	   return false;
	else
	   return true;
     }
     if (!(getReturnDate().equals(other.getReturnDate())))
	return false;
     */
     return true;
  }

  /**
   * Returns a hash code value for the object.
   * @return The hash code value is returned.
   */
  public int hashCode() {
     int result = super.hashCode();
     int PRIME = 37;
     result =  PRIME * result +
	    ((getOriginCity() != null) ? (getOriginCity().hashCode()) : 0);
     result =  PRIME * result +
            ((getDestinationCity() != null) ?
				(getDestinationCity().hashCode()) : 0);
     result =  PRIME * result +
	    ((getDepartDate() != null) ? (getDepartDate().hashCode()) : 0);
     /*
     result =  PRIME * result +
	    ((getReturnDate() != null) ? (getReturnDate().hashCode()) : 0);
     */
     return result;
  }
}
