//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.7 com/java/src/com/ibm/beans/demos/travel/flight/FlightInfoDapClientCustomizer.java, bbTravelDemo, bb97c, bb97c9750e 11/6/97 17:16:29 [12/11/97 17:03:09]
package com.ibm.beans.demos.travel.flight;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

import java.awt.event.TextEvent;
import java.awt.event.TextListener;

import java.beans.Customizer;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.util.ResourceBundle;

/**
 * This class defines a FlightInfoDapClientCustomizer instance that is the
 * customizer for an instance of the FlightInfoDapClient class.  The
 * customizer is used to modify the <i>serverAddress</i> property value of
 * the FlightInfoDapClient instance.
 */
public class FlightInfoDapClientCustomizer extends Panel implements Customizer, TextListener {

   /**
    * Constructs a FlightInfoDapClientCustomizer instance, and creates
    * controls used in customizing the properties of the FlightInfoDapClient.
    */
   public FlightInfoDapClientCustomizer() {
      support = new PropertyChangeSupport(this);
      setLayout(new FlowLayout());
      Label label1 = new Label(getMsg("FIDCC_msg1"));
      add(label1);
      serverAddressTextField = new TextField(20);
      serverAddressTextField.addTextListener(this);
      add(serverAddressTextField);
      Label label2 = new Label(getMsg("FIDCC_msg2"));
      add(label2);
   }


   /**
    * Sets the object instance with which this customizer interacts.
    * Controls are initialized to contain the current value of
    * properties being customized.
    *
    * @param obj A FlightInfoDapClient instance to be customized.
    */
   public void setObject(Object obj) {
      if ((obj!=null) && (obj instanceof FlightInfoDapClient)) {
         target = (FlightInfoDapClient) obj;
      } else {
         return; // nothing we can do - caller isn't expecting any exceptions
      } /* endif */

      serverAddressTextField.setText(target.getServerAddress());
   }


   /**
    * Returns the preferred size for this customizer panel.
    * @return The dimensions of the customizer.
    */
   public Dimension getPreferredSize() {
      return new Dimension(400, 100);
   }


   /**
    * Updates the <i>serverAddress</i> property of the FlightInfoDapClient
    */
   public void textValueChanged(TextEvent evt) {
     /* serverAddress text changed */
     if (evt.getSource()==serverAddressTextField) {
        String newAddress = serverAddressTextField.getText();
        String oldAddress = target.getServerAddress();
        target.setServerAddress(newAddress);
        support.firePropertyChange("serverAddress", oldAddress, newAddress);
     } /* endif */
   }


   //----------------------------------------------------------------------
   /**
    * Adds a listener to the property-change notification list.
    * @param l The listener to add.
    */
   public void addPropertyChangeListener(PropertyChangeListener l) {
      support.addPropertyChangeListener(l);
   }

   /**
    * Removes a listener from the property-change notification list.
    * @param l The listener to remove.
    */
   public void removePropertyChangeListener(PropertyChangeListener l) {
      support.removePropertyChangeListener(l);
   }

   /**
   * Given a key, get a message from the FlightResourceBundle
   * @param key The key for the message
   * @return The message retrieved from the resource bundle
   */
   private String getMsg(String key)
   {
        if (msgs == null)
          msgs = (FlightResourceBundle)ResourceBundle.getBundle(
            "com.ibm.beans.demos.travel.flight.FlightResourceBundle");

        return (String)msgs.handleGetObject(key);
   }

   private PropertyChangeSupport support = null;

   //----------------------------------------------------------------------

   private FlightInfoDapClient target;
   private TextField serverAddressTextField;
   private transient FlightResourceBundle   msgs                      = null;

   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

