//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/demos/travel/flight/FlightInfoDapServerExports.java, bbTravelDemo, bb97c, bb97c9750e 10/22/97 16:35:35 [12/11/97 17:03:08]

package com.ibm.beans.demos.travel.flight;

import com.ibm.beans.demos.travel.TravelInfoChangedEvent;

/**
 * This interface contains the methods that are called on the
 * FlightInfoDapServer from the FlightInfoDapClient to query the database for
 * matching flights and to reserve a particular flight schedule.  Any
 * future versions of a server-side version of the FlightInfoDap (such as a
 * CORBA version) will also need to implement this interface.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 * @see com.ibm.beans.demos.travel.flight.FlightInfoDapServer
 * @see com.ibm.beans.demos.travel.flight.FlightInfoDapClient
 */
public interface FlightInfoDapServerExports extends java.rmi.Remote {
  /**
   * Queries the database to find all of the possible flight
   * choices that match the user request of origin city, destination
   * city, departure date, and return date.
   * @param travelInfoChange The TravelInfoChanged event containing the travel info
   * @return The FlightInfoEvent containing the flight info
   * @exception java.rmi.RemoteException
   *            Thrown if registry could not be contacted
   */
   public FlightInfoEvent queryDataBase(TravelInfoChangedEvent travelInfoChange) throws java.rmi.RemoteException;

  /**
   * Attempts to reserve the specified flight(s).  This method is invoked by the FlightInfoDapClient
   * when the Itinerary bean has been wired to the FlightInfoDapClient bean and the user has selected
   * a preferred itinerary.
   * @param  flightRequestedEvent The FlightRequestedEvent containing the preferred flight itinerary.
   * @return The FlightReservedEvent containing the reserved flight itinerary.
   */
   public FlightReservedEvent reserveFlight(FlightRequestedEvent flightRequested) throws java.rmi.RemoteException;
}

