//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.6 com/java/src/COM/ibm/beans/samples/travel/flight/FlightInformation.java, bbDemo, bb97a, bb97a9732f 8/6/97 09:44:54 [8/8/97 04:08:44]


package com.ibm.beans.demos.travel.flight;

/**
 * <p>
 * This class contains flight information.  Vectors
 * of this class are used in the following
 * events: FlightInfoEvent, FlightReservedEvent,
 * and FlightRequestedEvent.
 * @author K. David Johnson (kdjohn@us.ibm.com)
 * @see com.ibm.beans.demos.travel.flight.FlightInfoEvent
 * @see com.ibm.beans.demos.travel.flight.FlightReservedEvent
 * @see com.ibm.beans.demos.travel.flight.FlightRequestedEvent
*/
public class FlightInformation implements java.io.Serializable
{

       /**
        * Constructs a new instance containing Flight Information.
        * Note that only one instance of the class is used in the
        * Vectors of the FlightReservedEvent and the
        * FlightRequestedEvent. Descriptions of each field are found in
        * the accessor method for that field.
        */
       public FlightInformation(String airline, String flightNum, String startCity, String airportCodeStartCity,
                                String endCity, String airportCodeEndCity,
                                String whichClass, String departTime, String arriveTime, double price,
                                String seatNum, boolean bHasConnection, String airline2, String flightNum2,
                                String endCity2, String airportCodeEndCity2, String whichClass2,
                                String departTime2, String arriveTime2, double price2, String seatNum2,
                                String firstName, String lastName, String street, String city,
                                String state, String zip, String phone, String frequentFlyerNum,
                                String imageLocation, String imageCaption
                                ) {

            this.airline                = airline;
            this.flightNum              = flightNum;
            this.startCity              = startCity;
            this.airportCodeStartCity   = airportCodeStartCity;
            this.endCity                = endCity;
            this.airportCodeEndCity     = airportCodeEndCity;
            this.whichClass             = whichClass;
            this.departTime             = departTime;
            this.arriveTime             = arriveTime;
            this.price                  = price;
            this.seatNum                = seatNum;
            this.bHasConnection         = bHasConnection;
            if (bHasConnection) {
               this.airline2            = airline2;
               this.flightNum2          = flightNum2;
               this.endCity2            = endCity2;
               this.airportCodeEndCity2 = airportCodeEndCity2;
               this.whichClass2         = whichClass2;
               this.departTime2         = departTime2;
               this.arriveTime2         = arriveTime2;
               this.price2              = price2;
               this.seatNum2            = seatNum2;
            }

            // note the following fields will only be used for the FlightRequested and FlightReserved events.
            // These events will only contain one instance of the FlightInformation class in the vector
            this.firstName        = firstName;
            this.lastName         = lastName;
            this.street           = street;
            this.city             = city;
            this.state            = state;
            this.zip              = zip;
            this.phone            = phone;
            this.frequentFlyerNum = frequentFlyerNum;

            // pointer to the image to be used when displaying detailed information
            this.imageLocation    = imageLocation;
            this.imageCaption     = imageCaption;


       }

       /**
        * Accessor (get) method for the airline.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the airline property.
        */
       public String getAirline () {
          return airline;
       }

       /**
        * Accessor (get) method for the flight number.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the flight number.
        */
       public String getFlightNum () {
          return flightNum;
       }

       /**
        * Accessor (get) method for the origin city of the entire trip.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the starting city.
        */
       public String getStartCity () {
          return startCity;
       }

       /**
        * Accessor (get) method for the
        * the airport code of the origin city of the entire trip.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the airport code of the starting city.
        */
       public String getAirportCodeStartCity () {
          return airportCodeStartCity;
       }

       /**
        * Accessor (get) method for the city where the flight ends.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the city where the flight ends.
        */
       public String getEndCity () {
          return endCity;
       }

       /**
        * Accessor (get) method for the
        * the airport code for the city where the flight ends.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>airportCodeEndCity</i> property.
        */
       public String getAirportCodeEndCity () {
          return airportCodeEndCity;
       }

       /**
        * Accessor (get) method for the seating class
        * (Business Class, First Class, or Economy Class).
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>whichClass</i> property.
        */
       public String getWhichClass () {
          return whichClass;
       }

       /**
        * Accessor (get) method for the departure time of the flight.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>departTime</i> property.
        */
       public String getDepartTime () {
          return departTime;
       }

       /**
        * Accessor (get) method for the arrival time of the flight.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>arriveTime</i> property.
        */
       public String getArriveTime () {
          return arriveTime;
       }

       /**
        * Accessor (get) method for the price of the flight.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>price</i> property.
        */
       public double getPrice () {
          return price;
       }

       /**
        * Accessor (get) method for the assigned seat number for the flight.
        * Note that if the <i>bHasConnection</i> property is <tt>true</tt>,
        * this property refers to the first leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>seatNum</i> property.
        */
       public String getSeatNum () {
          return seatNum;
       }

       /**
        * Accessor (get) method for the property that describes whether this
        * itinerary calls for a connecting flight.
        *
        * @return <tt>true</tt> if the itinerary calls for a connecting flight;
        * <tt>false</tt> otherwise.
        */
       public boolean getbHasConnection () {
          return bHasConnection;
       }


       /**
        * Accessor (get) method for the connecting airline.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>airline2</i> property.
        */
       public String getAirline2 () {
          return airline2;
       }

       /**
        * Accessor (get) method for the connecting flight number.
        * Note that this property is valid only if the
        * bHasConnection property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>flightNum2</i> property.
        */
       public String getFlightNum2 () {
          return flightNum2;
       }

       /**
        * Accessor (get) method for the city where the connecting flight ends.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>endCity2</i> property.
        */
       public String getEndCity2 () {
          return endCity2;
       }

       /**
        * Accessor (get) method for the airport code for the city
        * where the connecting flight ends.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>airportCodeEndCity2</i> property.
        */
       public String getAirportCodeEndCity2 () {
          return airportCodeEndCity2;
       }

       /**
        * Accessor (get) method for the seating class for the connecting flight
        * (Business Class, First Class, or Economy Class).
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>whichClass2</i> property.
        */
       public String getWhichClass2 () {
          return whichClass2;
       }

       /**
        * Accessor (get) method for the departure time of the connecting flight
        * if one exists.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>departTime2</i> property.
        */
       public String getDepartTime2 () {
          return departTime2;
       }

       /**
        * Accessor (get) method for the arrival time of the final connecting flight if one exists.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>arriveTime2</i> property.
        */
       public String getArriveTime2 () {
          return arriveTime2;
       }

       /**
        * Accessor (get) method for the price of the connecting flight.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>price2</i> property.
        */
       public double getPrice2 () {
          return price2;
       }

       /**
        * Accessor (get) method for the assigned seat number for the connecting flight.
        * Note that this property is valid only if the
        * <i>bHasConnection</i> property is <tt>true</tt>.  This property
        * refers to the second leg of a two-leg
        * connecting flight scenario.
        * @return The current value of the <i>seatNum2</i> property.
        */
       public String getSeatNum2 () {
          return seatNum2;
       }

       /**
        * Accessor (get) method for the first name of the passenger.
        * @return The current value of the <i>firstName</i> property.
        */
       public String getFirstName () {
          return firstName;
       }

       /**
        * Accessor (get) method for the last name of the passenger.
        * @return The current value of the <i>lastName</i> property.
        */
       public String getLastName () {
          return lastName;
       }

       /**
        * Accessor (get) method for the street address of the passenger.
        * @return The current value of the <i>street</i> property.
        */
       public String getStreet () {
          return street;
       }

       /**
        * Accessor (get) method for the city where the passenger lives.
        * @return The current value of the <i>city</i> property.
        */
       public String getCity () {
          return city;
       }

       /**
        * Accessor (get) method for the state where the passenger lives.
        * @return The current value of the <i>state</i> property.
        */
       public String getState () {
          return state;
       }

       /**
        * Accessor (get) method for the zip code where the passenger lives.
        * @return The current value of the <i>zip</i> property.
        */
       public String getZip () {
          return zip;
       }

       /**
        * Accessor (get) method for the home phone number of the passenger.
        * @return The current value of the <i>phone</i> property.
        */
       public String getPhone () {
          return phone;
       }

       /**
        * Accessor (get) method for the frequent flyer number of the passenger.
        * @return The current value of the <i>frequentFlyerNum</i> property.
        */
       public String getFrequentFlyerNum () {
          return frequentFlyerNum;
       }

       /**
        * Accessor (get) method for the location of the image that will be used
        * for display by the DetailInfo bean.
        * @return The current value of the <i>imageLocation</i> property.
        */
       public String getImageLocation () {
          return imageLocation;
       }

       /**
        * Accessor (get) method for the location of the image caption that will be used
        * for display by the DetailInfo bean.
        * @return The current value of the <i>imageCaption</i> property.
        */
       public String getImageCaption () {
          return imageCaption;
       }

       private String  airline;

       private String  flightNum;

       private String  startCity;

       private String  airportCodeStartCity;

       private String  endCity;

       private String  airportCodeEndCity;

       private String  whichClass;

       private String  departTime;

       private String  arriveTime;

       private double  price;

       private String  seatNum             = "None";

       private boolean bHasConnection;

       private String  airline2            = "None";

       private String  flightNum2          = "None";

       private String  endCity2            = "None";

       private String  airportCodeEndCity2 = "None";

       private String  whichClass2         = "None";

       private String  departTime2         = "None";

       private String  arriveTime2         = "None";

       private double  price2              = 0;

       private String  seatNum2            = "None";

       private String  firstName           = "None";

       private String  lastName            = "None";

       private String  street              = "None";

       private String  city                = "None";

       private String  state               = "None";

       private String  zip                 = "None";

       private String  phone               = "None";

       private String  frequentFlyerNum    = "None";

       private String  imageLocation       = "None";

       private String  imageCaption        = "None";

       private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

       private static final long serialVersionUID = 2000L;  // serial version unique ID
}


