//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/demos/travel/flight/FlightRequestedEvent.java, bbTravelDemo, bb97c, bb97c9750e 10/28/97 15:04:04 [12/11/97 17:02:57]
package com.ibm.beans.demos.travel.flight;
import java.util.Vector;

/**
 * <p>
 * This event is sent as a parameter in the FlightRequested()
 * method of the FlightRequestedListener interface.  In the demo this
 * interface is implemented by the flight information data access part (DAP) bean
 * and the itinerary bean.  The flight selector bean is wired to the itinerary
 * bean and the itinerary bean is wired to the flight information DAP bean.
 * The user uses the flight selector bean to select a flight by highlighting the
 * desired flight and then pushing the "OK" button.  That action fires this event
 * to the itinerary bean.  When the user is satisfied with the selected itinerary,
 * the user presses the "Ticket It" button which fires this event to the flight
 * information DAP bean.
 * @author K. David Johnson (kdjohn@us.ibm.com)
 * @see com.ibm.beans.demos.travel.flight.FlightRequestedListener
*/
public class FlightRequestedEvent extends java.util.EventObject implements java.io.Serializable {

  /**
  * Builds the event object that is
  * sent as a parameter in the FlightRequested() method
  * of the FlightRequestedListener interface.
  *
  * @param source An object that is the source for the event.
  * @param flightInfo <dl><dd>A Vector containing a FlightInformation
  *                   object as defined in the
  *                   FlightInformation class.</dd></dl>
  * @see com.ibm.beans.demos.travel.flight.FlightInformation
  */
  public FlightRequestedEvent(Object source, Vector flightInfo) {
    super(source);
    this.flightInfo = flightInfo;
  }
  /**
   * Gets the FlightInfo Vector.
   * @return Vector of flight informatation
   */
  public    Vector      getFlightInfo()        {return flightInfo;}
  /**
   * A Vector of flightInfo including city of origin, destination, travel times,
   * and so forth.
   */
  protected Vector      flightInfo;

  // note that the vector contains a FlightInformation object as defined in the FlightInformation class

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
  private static final long serialVersionUID = 2000L;  // serial version unique ID

}
