//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTravelDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.7 com/java/src/com/ibm/beans/demos/travel/flight/FlightReservedEvent.java, bbTravelDemo, bb97c, bb97c9750e 10/28/97 15:19:51 [12/11/97 17:03:01]

package com.ibm.beans.demos.travel.flight;
import java.util.Vector;

/**
 * <p>
 * This event is sent as a parameter in the FlightReserved()
 * method of the FlightReservedListener interface.  In the demo this
 * interface is implemented by the initerary bean.  The itinerary
 * bean is wired to the flight information data access part (DAP)
 * bean and the information DAP fires this event when a flight
 * reservation has been approved.
 * @author K. David Johnson (kdjohn@us.ibm.com)
 * @see com.ibm.beans.demos.travel.flight.FlightReservedListener
*/
public class FlightReservedEvent extends java.util.EventObject implements java.io.Serializable {

  /**
  * Builds the event object that is
  * sent as a parameter in the FlightReserved method
  * of the FlightReservedListener interface.
  *
  * @param source An object that is the source for the event.
  * @param flightInfo <dl><dd>A vector containing a FlightInformation
  *                   object as defined in the
  *                   FlightInformation class.</dd></dl>
  * @see COM.ibm.beans.samples.trave.flight.FlightInformation
  */
  public FlightReservedEvent(Object source, Vector flightInfo) {
    super(source);
    this.flightInfo = flightInfo;
  }
    /**
     * Gets the FlightInfo vector.
     * @return Vector of flight informatation
     */
  public    Vector      getFlightInfo()        {return flightInfo;}
    /**
     * A Vector of flightInfo including city of origin, destination, travel times,
     * and so forth.
     */
  protected Vector      flightInfo;

  // note that the vector contains a FlightInformation object as defined in the FlightInformation class

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

  private static final long serialVersionUID = 2000L;  // serial version unique ID
}
