//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.5 com/java/src/com/ibm/beans/demos/travel/flight/rules/ConnectingFlightDipCustomizer.java, bbTravelDemo, bb97c, bb97c9750e 9/25/97 14:14:48 [12/11/97 17:03:05]

package com.ibm.beans.demos.travel.flight.rules;

import java.awt.Button;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.Customizer;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.lang.Double;
import com.ibm.beans.util.MessageFormatter;

/**
 * The ConnectingFlightDipCustomizer sets the priceDifferential property
 * in the ConnectingFlightDip.
 */
public class ConnectingFlightDipCustomizer extends Panel implements Customizer {

  /**
   * Constructs a ConnectingFlightDipCustomizer.  This customizer
   * presents a text field to enter the price differential into.
   */
  public ConnectingFlightDipCustomizer() {

    // change the layout policy
    setLayout(new GridLayout(0, 1));

    MessageFormatter mf = new MessageFormatter("com.ibm.beans.demos.travel.flight.rules.Messages");

    add(new Label(""));         // vertical space
    add(new Label(mf.format("con_txt1")));
    add(new Label(mf.format("con_txt2")));
    add(new Label(""));         // vertical space

    Panel prompt = new Panel();
    prompt.add(new Label(mf.format("con_prompt")));
    pricePropertyText = new TextField(kPriceFieldWidth);
    prompt.add(pricePropertyText);
    add(prompt);

    add(new Label(""));         // vertical space

    Panel control = new Panel();
    Button applyButton = new Button(mf.format("con_apply"));
    applyButton.addActionListener(new ApplyListener());
    control.add(applyButton);
    add(control);

    // spec says we should do this, but why?
    support = new PropertyChangeSupport(this);
  }

  // Panel overrides

  /**
   * Gets the preferred size of the customizer.
   * This method performs a passthru to the policy's customizer because it
   * is the only thing presented by this customizer.
   *
   * @return The preferred width and height of the customizer.
   */
  public Dimension getPreferredSize() {
    Dimension x = new Dimension(300,100);
    return x;
  }

  // Customizer interface

  /**
   * Sets the object instance with which this customizer is to interact.
   * Once the object is set, the customizer for the license
   * policy can be set.
   *
   * @param bean        The bean instance to customize.
   */
  public void setObject(Object bean) {
    // If someone gives us a bean that's not what we expect, we're in trouble.
    // Make the text field set the price differential property in the dip.
    dip = (ConnectingFlightDip)bean;

    // need to update the customizer now
    pricePropertyText.setText(Double.toString(dip.getPriceDifferential()));
  }

  /**
   * Adds a listener to get notified when the customizer changes the
   * bean in a significant manner.  There are no significant changes
   * that can be made to the dip itself.  This method does nothing.
   *
   * @param listener    The object to be notified of changes.
   */
  public void addPropertyChangeListener(PropertyChangeListener listener) {
    support.addPropertyChangeListener(listener);
  }

  /**
   * Removes a listener from the notification list.
   *
   * @param listener    The object to be removed from the notification list.
   */
  public void removePropertyChangeListener(PropertyChangeListener listener) {
    support.removePropertyChangeListener(listener);
  }

  // GUI items
  private TextField pricePropertyText;
  private int kPriceFieldWidth = 10; // width of text field

  // customizer items
  private ConnectingFlightDip dip;
  private PropertyChangeSupport support;

  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

  // internal classes used by the customizer to set property
  // in the dip
  class ApplyListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      // set the dip's price differential property
      if (dip != null) {
        dip.setPriceDifferential(Double.valueOf(pricePropertyText.getText()).doubleValue());
      }
    }
  }
}

