//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbBOI
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/daps/sql/ConnectionBeanInfo.java, bbDaps, bb97c, bb97c9750e 9/29/97 16:27:37 [12/11/97 17:01:21]
package com.ibm.beans.samples.daps.sql;

import java.lang.reflect.Method;
import java.awt.Image;
import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.IntrospectionException;
import java.beans.MethodDescriptor;
import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;

/**
 * The ConnectionBeanInfo class supports beaninfo for the Connection class.
 *
 * @see com.ibm.beans.samples.daps.sql.Connection
 *
 * @version 1.0  March 24, 1997
 * @author J. Russell Boykin
 */
public class ConnectionBeanInfo extends SimpleBeanInfo
{
   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

   /**
    * Private instance variable to contain the related Connection class.
    */
   private transient final static Class beanClass = Connection.class;

   /**
    * Default constructor.
    */
   public ConnectionBeanInfo()
   {
       // Invoke the constructor of the superclass
       super();
   }

   /**
    * Finalize this object.
    * @exception java.lang.Throwable Possibly thrown by the superclass
    */
   protected void finalize() throws Throwable
   {
       // Invoke finalize method of superclass
       super.finalize();
   }

   /**
    * Get the property descriptors for the Connection class.
    * @return The property descriptors for the Connection class.
    */
   public PropertyDescriptor[] getPropertyDescriptors()
   {
       try
       {
           // Set up read/write bound property for the JDBCDriverName property
           PropertyDescriptor JDBCDriverName =
                              new PropertyDescriptor("JDBCDriverName",
                                                     beanClass);
           JDBCDriverName.setBound(true);

           // Set up read/write bound property for the JDBCURL property
           PropertyDescriptor JDBCURL =
                              new PropertyDescriptor("JDBCURL",
                                                     beanClass);
           JDBCURL.setBound(true);

           // Set up read/write bound property for the userid property
           PropertyDescriptor userid =
                              new PropertyDescriptor("userid",
                                                     beanClass);
           userid.setBound(true);

           // Set up read/write bound property for the password property
           PropertyDescriptor password =
                              new PropertyDescriptor("password",
                                                     beanClass);
           password.setBound(true);

           // Set up read-only bound property for the JDBCConnection property
           PropertyDescriptor JDBCConnection =
                              new PropertyDescriptor("JDBCConnection",
                                                     beanClass,
                                                     "getJDBCConnection",
                                                     null);
           JDBCConnection.setBound(true);

           // Set up read/write bound property for the autoCommit property
           PropertyDescriptor autoCommit =
                              new PropertyDescriptor("autoCommit",
                                                     beanClass);
           autoCommit.setBound(true);

           // Set up read/write bound property for the readOnly property
           PropertyDescriptor readOnly =
                              new PropertyDescriptor("readOnly",
                                                     beanClass);
           readOnly.setBound(true);

           // Set up read/write bound property for the transactionIsolation
           // property.
           // This includes setting a special editor
           PropertyDescriptor transactionIsolation =
                              new PropertyDescriptor("transactionIsolation",
                                                     beanClass);
           transactionIsolation.setPropertyEditorClass
                                (IsolationEditor.class);
           transactionIsolation.setBound(true);

           // Set up the array of property descriptors
           PropertyDescriptor rv[] = {JDBCDriverName,
                                      JDBCURL,
                                      userid,
                                      password,
                                      JDBCConnection,
                                      autoCommit,
                                      readOnly,
                                      transactionIsolation};
           return rv;
       }

       // catch Introspection Exceptions
       catch (IntrospectionException e)
       {
           // Throw the error
           throw new Error(e.toString());
       }
   }

   /**
    * Get the method descriptors for the Connection class.
    * @return The method descriptors for the Connection class.
    */
   public MethodDescriptor[] getMethodDescriptors()
   {
       // First find the "method" objects.
       Method m1, m2, m3, m4;
       try
       {
           m1 = beanClass.getMethod("connect", null);
           m2 = beanClass.getMethod("disconnect", null);
           m3 = beanClass.getMethod("commit", null);
           m4 = beanClass.getMethod("rollback", null);
       }
       catch (Exception ex)
       {
           // "should never happen"
           throw new Error(ex.toString());
       }

       // Now create the MethodDescriptor array:
       MethodDescriptor result[] = {new MethodDescriptor(m1),
                                    new MethodDescriptor(m2),
                                    new MethodDescriptor(m3),
                                    new MethodDescriptor(m4)};
       return result;
   }

   /**
    * This method returns an image object that can be used to
    * represent the bean in toolboxes, toolbars, and so forth.   Icon images
    * will typically be GIFs, but may in future include other formats.
    * <p>
    * Beans aren't required to provide icons and may return null from
    * this method.
    * <p>
    * There are four possible flavors of icons (16x16 color,
    * 32x32 color, 16x16 mono, 32x32 mono).  If a bean chooses to only
    * support a single icon we recommend supporting 16x16 color.
    * <p>
    * We recommend that icons have a "transparent" background
    * so they can be rendered onto an existing background.
    *
    * @param  iconKind  The kind of icon requested.  This should be
    *    one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32,
    *    ICON_MONO_16x16, or ICON_MONO_32x32.
    * @return  An image object representing the requested icon.  May
    *    return null if no suitable icon is available.
    */
   public Image getIcon(int iconKind)
   {
      return null;
   }

   /**
    * This method returns the BeanInfo of the corresponding parent class.
    * This is the BeanInfo method of supporting subclassing.
    * @return The BeanInfo of the parent class.
    */
   public BeanInfo[] getAdditionalBeanInfo()
   {
       BeanInfo ret[] = new BeanInfo[1];

       try
       {
           // Get the beaninfo for the parent class
           ret[0] = Introspector.getBeanInfo(beanClass.getSuperclass(),
                                             beanClass.getSuperclass().getSuperclass());
       }

       // catch Introspection Exceptions
       catch (IntrospectionException e)
       {
           // Throw the error
           throw new Error(e.toString());
       }

       return ret;
   }
}
