//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbBOI
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/samples/daps/sql/DDL.java, bbDaps, bb97c, bb97c9750e 9/29/97 16:27:48 [12/11/97 17:01:22]
package com.ibm.beans.samples.daps.sql;

/**
 * The DDL class is instantiated to represent a single SQL DDL statement.
 *
 * <p>To use the DDL bean, do the following:
 * <ol>
 * <li>Create an instance of the bean.
 * <li>Fill in the bean's properties (described below or in superclass):
 * <ul>
 * <li>executeInBackground
 * <li>SQLText
 * </ul>
 * <li>Bind an existing Connection bean's JDBCConnection property
 * to this bean's JDBCConnection property.  This will cause execution of the
 * connect() method on the Connection bean to also set the JDBCConnection
 * property on this bean.
 * <li>Use the execute() method to execute the statement.
 * The execute() method uses all the above properties to perform execution of
 * the DDL statement.  The execute() method sets values and fires property
 * change events for the following properties on completion:
 * <ul>
 * <li>exception
 * <li>successful
 * </ul>
 * <li>Use the close() method to relinquish the statement's resources.
 * The close() method sets values and fires property
 * change events for the following properties on completion:
 * <ul>
 * <li>exception
 * <li>successful
 * </ul>
 * </ol>
 *
 * @see com.ibm.beans.samples.daps.sql.DDLBeanInfo
 *
 * @version 1.0  March 24, 1997
 * @author J. Russell Boykin
 */
public class DDL extends Statement
{
   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

   /**
    * Default constructor.
    */
   public DDL()
   {
       // Invoke the constructor of the superclass
       super();
   }

   /**
    * Finalize this object.
    * @exception java.lang.Throwable Possibly thrown by the superclass.
    */
   protected void finalize() throws Throwable
   {
       // Invoke finalize method of superclass
       super.finalize();
   }
}
