//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbBOI
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/daps/sql/DDLBeanInfo.java, bbDaps, bb97c, bb97c9750e 9/29/97 16:27:52 [12/11/97 17:01:22]
package com.ibm.beans.samples.daps.sql;

import java.awt.Image;
import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.IntrospectionException;
import java.beans.MethodDescriptor;
import java.beans.SimpleBeanInfo;

/**
 * The DDLBeanInfo class supports beaninfo for the DDL class.
 *
 * @see com.ibm.beans.samples.daps.sql.DDL
 *
 * @version 1.0  March 24, 1997
 * @author J. Russell Boykin
 */
public class DDLBeanInfo extends SimpleBeanInfo
{
   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

   /**
    * Private instance variable to contain the related DDL class.
    */
   private transient final static Class beanClass = DDL.class;

   /**
    * Default constructor.
    */
   public DDLBeanInfo()
   {
       // Invoke the constructor of the superclass
       super();
   }

   /**
    * Finalize this object.
    * @exception java.lang.Throwable Possibly thrown by the superclass.
    */
   protected void finalize() throws Throwable
   {
       // Invoke finalize method of superclass
       super.finalize();
   }

   /**
    * Get the method descriptors for the DDL class.
    * @return The method descriptors for the DDL class.
    */
   public MethodDescriptor[] getMethodDescriptors()
   {
       // Create an empty MethodDescriptor array
       MethodDescriptor result[] = {};
       return result;
   }

   /**
    * This method returns an image object that can be used to
    * represent the bean in toolboxes, toolbars, and so forth.   Icon images
    * will typically be GIFs, but may in future include other formats.
    * <p>
    * Beans aren't required to provide icons and may return null from
    * this method.
    * <p>
    * There are four possible flavors of icons (16x16 color,
    * 32x32 color, 16x16 mono, 32x32 mono).  If a bean chooses to only
    * support a single icon we recommend supporting 16x16 color.
    * <p>
    * We recommend that icons have a "transparent" background
    * so they can be rendered onto an existing background.
    *
    * @param  iconKind  The kind of icon requested.  This should be
    *    one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32,
    *    ICON_MONO_16x16, or ICON_MONO_32x32.
    * @return  An image object representing the requested icon.  May
    *    return null if no suitable icon is available.
    */
   public Image getIcon(int iconKind)
   {
      return null;
   }

   /**
    * This method returns the BeanInfo of the corresponding parent class.
    * This is the BeanInfo method of supporting subclassing.
    * @return The BeanInfo of the parent class.
    */
   public BeanInfo[] getAdditionalBeanInfo()
   {
       BeanInfo ret[] = new BeanInfo[1];

       try
       {
           // Get the beaninfo for the parent class
           ret[0] = Introspector.getBeanInfo(beanClass.getSuperclass(),
                                             beanClass.getSuperclass().getSuperclass());
       }

       // catch Introspection Exceptions
       catch (IntrospectionException e)
       {
           // Throw the error
           throw new Error(e.toString());
       }

       return ret;
   }
}
