//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbBOI
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.7 com/java/src/com/ibm/beans/samples/daps/sql/DMLBeanInfo.java, bbDaps, bb97c, bb97c9750e 9/29/97 16:27:44 [12/11/97 17:01:22]
package com.ibm.beans.samples.daps.sql;

import java.awt.Image;
import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.IntrospectionException;
import java.beans.MethodDescriptor;
import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;

/**
 * The DMLBeanInfo class supports beaninfo for the DML class.
 *
 * @see com.ibm.beans.samples.daps.sql.DML
 *
 * @version 1.0  March 24, 1997
 * @author J. Russell Boykin
 */
public class DMLBeanInfo extends SimpleBeanInfo
{
   private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";

   /**
    * Private instance variable to contain the related DML class.
    */
   private transient final static Class beanClass = DML.class;

   /**
    * Default constructor.
    */
   public DMLBeanInfo()
   {
       // Invoke the constructor of the superclass
       super();
   }

   /**
    * Finalize this object.
    * @exception java.lang.Throwable Possibly thrown by the superclass.
    */
   protected void finalize() throws Throwable
   {
       // Invoke finalize method of superclass
       super.finalize();
   }

   /**
    * Get the property descriptors for the DML class.
    * @return The property descriptors for the DML class.
    */
   public PropertyDescriptor[] getPropertyDescriptors()
   {
       try
       {
           // Set up read/write bound property for the inputs property
           PropertyDescriptor inputs =
                              new PropertyDescriptor("inputs",
                                                     beanClass);
           inputs.setBound(true);

           // Set up the array of property descriptors
           PropertyDescriptor rv[] = {inputs};
           return rv;
       }

       // catch Introspection Exceptions
       catch (IntrospectionException e)
       {
           // Throw the error
           throw new Error(e.toString());
       }
   }

   /**
    * Get the method descriptors for the DML class.
    * @return The method descriptors for the DML class.
    */
   public MethodDescriptor[] getMethodDescriptors()
   {
       // Create an empty MethodDescriptor array
       MethodDescriptor result[] = {};
       return result;
   }

   /**
    * This method returns the BeanInfo of the corresponding parent class.
    * This is the BeanInfo method of supporting subclassing.
    * @return The BeanInfo of the parent class.
    */
   public BeanInfo[] getAdditionalBeanInfo()
   {
       BeanInfo ret[] = new BeanInfo[1];

       try
       {
           // Get the beaninfo for the parent class
           ret[0] = Introspector.getBeanInfo(beanClass.getSuperclass(),
                                             beanClass.getSuperclass().getSuperclass());
       }

       // catch Introspection Exceptions
       catch (IntrospectionException e)
       {
           // Throw the error
           throw new Error(e.toString());
       }

       return ret;
   }
}
