//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/com/ibm/beans/samples/dips/context/AnnotationContextCustomizer.java, bbContextDip, bb97c, bb97c9750e 10/2/97 09:02:12 [12/11/97 17:01:29]
package com.ibm.beans.samples.dips.context;

import java.awt.Panel;
import java.beans.Customizer;
import java.beans.BeanInfo;
import java.beans.PropertyChangeListener;
import java.beans.IntrospectionException;
import java.util.ResourceBundle;
import java.util.MissingResourceException;
import java.util.Vector;
import java.awt.Panel;
import java.awt.Button;
import java.awt.List;
import java.awt.Label;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.lang.reflect.Method;
import java.beans.PropertyChangeSupport;


/**
 * The AnnotationContextCustomizer customizes an annotation context object.
 * This customization provides a facility for changing the update policy 
 * which the dip uses to determine when the annotation changes. 
 * 
 */
public class AnnotationContextCustomizer extends Panel implements Customizer, ActionListener {

    // Panel overrides

    /**
     * Construct a customizer for the Annotation context.
     */
    public AnnotationContextCustomizer () {
	
	try {
	    myContextResourceBundle=(ContextResourceBundle)
		ResourceBundle.getBundle("com.ibm.beans.samples.dips.context.ContextResourceBundle");
	} catch (MissingResourceException x) {
	    System.err.println("*** Fatal Error for Annotation Context Dip - No Resource Bundle ***");
	    System.exit(fileNotFoundError);
	}

	myPolicyOptionsList= new List(linesVisible,true);

	myApplyButton= new Button((String)
		myContextResourceBundle.getString("ApplyButtonLabel"));
	myApplyButton.setActionCommand("ApplyButton");
	myApplyButton.addActionListener(this);
    }


    // Customizer interface
    
    /**
     * Sets the object instance with which the annotation customizer interacts.
     * Once the object is set, the proper GUI is determined and created.
     *
     * @param bean	The bean instance to customize
     */
    public void setObject(Object bean) {
	
	myDip = (AnnotationContextDip) bean;      
        setLayout( new BorderLayout() );
	
	
	Label l=new Label((String)
		myContextResourceBundle.getString("AnnotationPolicyOptionLabel"));
	
	add("North", l);
	
	//Build the List entries from the Dip's Policy object. 
	
	String[] opts=myDip.getUpdatePolicy().getUpdatePolicyOptions();
	String[] selectedOpts=myDip.getUpdatePolicy().getUpdatePolicy();
	int i=0; //i is used as an index into the selectedOpts array.


	if (opts.length>0) {
	    myReadyFlag=true;
	    for (int j=0;j<opts.length;j++) {
		myPolicyOptionsList.addItem(opts[j]);
		if (selectedOpts.length>i) {
		    if (opts[j].equals(selectedOpts[i])) {
			myPolicyOptionsList.select(j);
			i++;
		    }
		}
	    }
	} else {
	    myPolicyOptionsList.addItem(
			myContextResourceBundle.getString("NoProperties"));
	}

	add("Center",myPolicyOptionsList);

	Panel soPanel=new Panel();
	soPanel.setLayout( new FlowLayout(java.awt.FlowLayout.CENTER) );
	soPanel.add(myApplyButton);
	add("South",soPanel);
	
    }



    /**
     * Adds a listener to be notified whenever the customizer changes the
     * bean in a significant manner. A significant change is a policy update.
     *
     * @param listener	Object to be notified of changes.
     */
    public void addPropertyChangeListener( PropertyChangeListener listener ) {
	    propertyChangeSupport.addPropertyChangeListener( listener );
    }
    
    /**
     * Removes a listener from the notification list.
     *
     * @param listener	Object to be removed from the notification list.
     */
   
    public void removePropertyChangeListener(PropertyChangeListener listener) {
	propertyChangeSupport.removePropertyChangeListener( listener );
    }


    /**
     * Responds to the buttons which the user may press in the dialog. 
     *
     * @param event The event which will provide information on which,
     *              if any, button was pressed.
     */
    public void actionPerformed( ActionEvent event ) {

        String actionCommand = event.getActionCommand();

        if ( myApplyButton.getActionCommand().equals(actionCommand)) {
	    if (myReadyFlag) {
		//get the selections from the list box
		String[] names= myPolicyOptionsList.getSelectedItems();
		
		//Set the updatePolicy for the dip
		myDip.getUpdatePolicy().setUpdatePolicy(names);
	    }
        }
    }

    private boolean myReadyFlag=false;
    private List   myPolicyOptionsList;
    private Button myApplyButton;
    private AnnotationContextDip myDip;
    private ContextResourceBundle myContextResourceBundle;
    private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);
    private static final int linesVisible=4;
    private static final int prfVGap=5;
    private static final int prfHGap=15;
    private static final int fileNotFoundError=28;

    private static final String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}


