//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/dips/context/AnnotationDialog.java, bbContextDip, bb97c, bb97c9750e 11/6/97 10:12:55 [12/11/97 17:01:31]
package com.ibm.beans.samples.dips.context;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/**
 * The AnnotationDialog class provides the user interface to set and view annotation information
 * attached to a bean by dipping. 
 */
public class AnnotationDialog extends Dialog implements WindowListener, ActionListener {
    /**
     * Constructs an AnnotationDialog. Creates and positions the various controls
     * in this dialog.
     */
    public AnnotationDialog (AnnotationContextDip dip,Frame parent, String title) {
	super(parent,title,true);

	myParent= parent;
	myAnnotationContextDip=dip;

	try {
	    myContextResourceBundle=(ContextResourceBundle)
		ResourceBundle.getBundle("com.ibm.beans.samples.dips.context.ContextResourceBundle");
	} catch (MissingResourceException x) {
	    System.err.println("*** Fatal Error for Annotation Context Dip - No Resource Bundle ***");
	    System.exit(fileNotFoundError);
	}
	

	Label dialogCaption=new Label((String)
	     myContextResourceBundle.getString("AnnotationDialogCaption"));

	add("North",dialogCaption);
	

	annotationText = new TextArea();
	
	add("Center",annotationText);

     
	Panel d=new Panel();
	d.setLayout(new FlowLayout());
	

	okButton = new Button((String)
	     myContextResourceBundle.getString("OKButtonLabel"));
	okButton.addActionListener(this);
	d.add(okButton);


	viewButton = new Button((String)
             myContextResourceBundle.getString("ViewButtonLabel"));
	viewButton.setActionCommand("ViewButton");
        viewButton.addActionListener(this);
	d.add(viewButton);
	
	cancelButton = new Button((String)
		  myContextResourceBundle.getString("CancelButtonLabel"));
	cancelButton.setActionCommand("cancelButton");
        cancelButton.addActionListener(this);
	d.add(cancelButton);

	add("South",d);
	setSize(preferedWidth, preferedHeight);
	addWindowListener(this);
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosed(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeiconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowIconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowActivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeactivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowOpened(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosing(WindowEvent event) {
            //exit here.
	dispose();
    }


   /**
     * Handles the actionPerformed event
     * when the user presses the <b>OK</b> or <b>Cancel</b> buttons. 
     * @param event provides information on which button was pressed.
     *              
     */
    public void actionPerformed(ActionEvent event) {
        String arg = event.getActionCommand();
        if (viewButton.getActionCommand().equals(arg)) {
            ViewAnnotationDialog v = new ViewAnnotationDialog(myParent,
		myContextResourceBundle.getString("ViewAnnotationDialogTitle"), 
		myAnnotationContextDip);
	    v.show();
        } else if (okButton.getActionCommand().equals(arg)) {
	    //add the annotation to the annotation vector.
	    String s=annotationText.getText();
	    myAnnotationContextDip.addAnnotation(s);
	    dispose();
	} else if (cancelButton.getActionCommand().equals(arg)) {
	    dispose();
	}    
    }
    
    private Frame myParent;
    private Button okButton;
    private Button viewButton;
    private Button cancelButton;
    private TextArea annotationText;
    private ViewAnnotationDialog viewAnnDlg;
    private ContextResourceBundle myContextResourceBundle;
    private AnnotationContextDip myAnnotationContextDip;

    private static final int fileNotFoundError=28;
    private static final int preferedWidth=260;
    private static final int preferedHeight=260;

    private static final String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
