//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/dips/context/AuthorDialog.java, bbContextDip, bb97c, bb97c9750e 11/4/97 15:53:27 [12/11/97 17:01:29]
package com.ibm.beans.samples.dips.context;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/**
 * The AuthorDialog class provides the user interface to set and view author information
 * attached to a bean by dipping. 
 */
public class AuthorDialog extends Dialog implements WindowListener, ActionListener {
    /**
     * Construct an AuthorDialog.
     */
    public AuthorDialog (AuthorContextDip dip, Frame parent, String title) {
	super(parent,title,true);
	
	myParent= parent;
	myAuthorContextDip=dip;
	try {
	    myContextResourceBundle=(ContextResourceBundle)
		ResourceBundle.getBundle("com.ibm.beans.samples.dips.context.ContextResourceBundle");
	} catch (MissingResourceException x) {
	    System.err.println("*** Fatal Error for Annotation Context Dip - No Resource Bundle ***");
	    System.exit(fileNotFoundError);
	}
	
	Panel topPanel=new Panel();
	topPanel.setLayout(new FlowLayout());
	
	Label currentAuthorLabel=new Label(
		   myContextResourceBundle.getString("CurrentAuthorLabel"));
	topPanel.add(currentAuthorLabel);
	
	
	currentAuthor = new TextField(30);
	
	
	topPanel.add(currentAuthor);
	add("North",topPanel);
	
	authorHistoryList = new List();
	add("Center",authorHistoryList);
	
	Vector authors=myAuthorContextDip.getAuthors();
	if (authors.isEmpty()) {
	    currentAuthor.setText(myContextResourceBundle.getString("Anonymous")); 
	} else {
	    for (int i=0; i<authors.size(); i++) {
		authorHistoryList.addItem((String)authors.elementAt(i));
	    }
	}

	Panel bottomPanel=new Panel();
	bottomPanel.setLayout(new FlowLayout());

	okButton = new Button(
		myContextResourceBundle.getString("OKButtonLabel"));
	okButton.setActionCommand("okButton");
        okButton.addActionListener(this);
	bottomPanel.add(okButton);
	

	cancelButton = new Button(
	     myContextResourceBundle.getString("CancelButtonLabel"));
	cancelButton.setActionCommand("cancelButton");
        cancelButton.addActionListener(this);
	bottomPanel.add(cancelButton);

	add("South",bottomPanel);

	setSize(350, 150);
	addWindowListener(this);
    }


    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosed(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeiconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowIconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowActivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeactivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowOpened(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosing(WindowEvent event) {
            //exit here.
	dispose();
    }

    /**
     * Handles the actionPerformed event
     * when the user presses the <b>OK</b> or <b>Cancel</b> buttons. 
     * @param event provides information on which button was pressed.
     *              
     */
    public void actionPerformed(ActionEvent event) {
        String arg = event.getActionCommand();
	if (okButton.getActionCommand().equals(arg)) {
	    //add the author text field as the current author
	    String s=currentAuthor.getText();
	    myAuthorContextDip.addAuthor(s);
	    dispose();
	} else if (cancelButton.getActionCommand().equals(arg)) {
	    dispose();
	}    
    }
    
    private Frame myParent;
    private List authorHistoryList;
    private Button okButton;
    private Button viewButton;
    private Button cancelButton;
    private TextField currentAuthor;
    private ContextResourceBundle myContextResourceBundle;
    private AuthorContextDip myAuthorContextDip;
    private static final int fileNotFoundError=28;

    private static final String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
