//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.7 com/java/src/com/ibm/beans/samples/dips/context/ContextElement.java, bbContextDip, bb97c, bb97c9750e 11/6/97 10:23:31 [12/11/97 17:01:27]
package com.ibm.beans.samples.dips.context;


/**
 * The ContextElement interface provides a common view of context elements between the
 * three different kinds of context dips. Context elements have getters and setters,
 * have names, and update policies associated with them.
 */
public interface ContextElement {
    /**
     * Gets the context element, either a version, author or annotation information.
     * @return An Object that is the context element.
     */
    public Object       getContextElement();
    /**
     * Sets the context element, either a version, author or annotation information.
     * @param o An Object that is the context element to be set.
     */
    public void         setContextElement(Object o);
    /**
     * Gets the name of the context element as a string.
     * @return A String representing the name of the context element.
     */
    public String       getContextElementName();
    /**
     * Gets the update policy for this context element.
     * @return A context policy update object.
     */
    public ContextUpdatePolicy getUpdatePolicy();
    /**
     * Sets the update policy for this context element.
     * @param u The context policy update object for this element.
     */
    public void         setUpdatePolicy(ContextUpdatePolicy u);
}













