//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbMessages
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/samples/dips/context/ContextResourceBundle.java, bbMessages, bb97c, bb97c9750e 10/2/97 09:01:53 [12/11/97 16:56:09]
package com.ibm.beans.samples.dips.context;

import java.awt.Toolkit;
import java.util.ListResourceBundle;

/**
 * ContextResourceBundle provides separation of the MRI from the source.
 * the strings contained here will be translated when the product is made
 * available in other locales.
 */
public class ContextResourceBundle extends ListResourceBundle {
    /**
     * Provides access to the key-value pairs which
     * comprise the resource bundle.
     * @return Object[][]. The first element is a String representing the
     *         key and the second is any object representing the value.
     */
    public Object[][] getContents() {
                return contents;
    }


    private static final Object[][] contents = {
         // LOCALIZE THIS
         /*
         * The following are GUI elements and not messages.
         */

            /*
             * The Dialog titles for the various contexts.
             */
            {"AnnotationDialogTitle", "Annotation Context"},
            {"ViewAnnotationDialogTitle", "View Annotations"},
            {"AuthorDialogTitle", "Author Context"},
            {"VersionDialogTitle", "Version Context"},
            /*
             * The Dialog Captions
             */
            {"AnnotationDialogCaption", "Enter Annotation Text"},
            {"ViewAnnotationDialogCaption", "Annotation History"},
            {"AuthorDialogCaption", "Current Author"},
            {"VersionDialogCaption", "Select a Version"},
            /*
             * Button Labels
             */
            {"OKButtonLabel", "OK"},
            {"ApplyButtonLabel", "Apply"},
            {"CancelButtonLabel", "Cancel"},
            {"ViewButtonLabel", "View Annotations..."},

            /*
             * Default Values
             */
            {"Anonymous","Anonymous"},
            {"NoPreviousAnnotations", "<!-- No Annotations Added -->"},
            {"NoPreviousAuthors", "<!-- No Previous Authors -->"},
            {"FirstVersion", "1.0"},
            {"NoProperties", "No properties available - customize after dip application is complete."},
            /*
             * Control Captions
             */
            {"VersionChoiceLabel","Select a Version"},
            {"CurrentAuthorLabel","Current Author"},
            {"AnnotationPolicyOptionLabel","Select a policy for allowing a new annotation"},
            {"AuthorPolicyOptionLabel","Select a policy for adding a new author"},
            {"VersionPolicyOptionLabel","Select a policy for changing the version"},
            /*
             * Dip Names
             */
            {"AnnotationDip","Annotation Dip"},
            {"AuthorDip","Author Dip"},
            {"VersionDip","Version Dip"},
            // Error Messages follow.
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * A call to Annotation.setContextElement failed
             * because the ContextElement argument was invalid.
             * <p class='Message Action'>
             * Use a valid context element object in the
             * call to setContext and retry the operation.
             */
            {"AnnotationSetContextError", "Annotation: ContextElement not set - Invalid type."},
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * A call to Author.setContextElement failed
             * because the ContextElement argument was invalid.
             * <p class='Message Action'>
             * Use a valid context element object in the
             * call to setContext and retry the operation.
             */
            {"AuthorSetContextError", "Author: ContextElement not set - Invalid type."},
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * A call to Version.setContextElement failed
             * because the ContextElement argument was invalid.
             * <p class='Message Action'>
             * Use a valid context element object in the
             * call to setContext and retry the operation.
             */
            {"VersionSetContextError", "Version: ContextElement not set - Invalid type."},
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * Introspection on the bean to establish an update
             * policy failed. The object may not be a valid dippable bean.
             * <p class='Message Action'>
             * Use a valid dippable bean in the call to the
             * UpdatePolicyOptions and retry the operation.
             */
            {"IntrospectionFailedInfo", "ContextUpdatePolicy: Introspection Failed."},
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * In an attempt to change versions,
             * a call to Method.invoke failed.
             * <p class='Message Action'>
             * The bean may restrict access to its properties,
             * so changing versions may not work on every
             * property of every bean.  If possible, modify the bean
             * to allow write access to this property and retry the operation.
             */
            {"InvokeFailedInfo", "Invoke failed - Can't change version."},
            /**
             * <!-- Message Owner: Otto Fox -->
             * <p class='Message Detail'>
             * The dip was unable to call the write method
             * on the property to change the version.
             * <p class='Message Action'>
             * The bean may restrict access to its properties,
             * so changing versions may not work on every
             * property of every bean.  If possible, modify the bean
             * to allow write access to this property and retry the operation.
             */
            {"IllegalAccessInfo", "Illegal access - Can't change version."}
            // END OF MATERIAL TO LOCALIZE
        };

    private static final String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}











