//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/dips/context/ViewAnnotationDialog.java, bbContextDip, bb97c, bb97c9750e 10/2/97 09:02:18 [12/11/97 17:01:30]
package com.ibm.beans.samples.dips.context;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/**
 *  The ViewAnnotationDialog class provides a list box which shows the previous annotations
 *  made on a bean instance.
 */
public class ViewAnnotationDialog extends Dialog implements WindowListener, ActionListener {
    /**
     * Constructs a ViewAnnotationDialog.
     * @param parent The Frame which parents this dialog.
     * @param title The dialog title.
     * @param theDip The annotation dip which is applied to the bean.
     */
    public ViewAnnotationDialog (Frame parent, String title, AnnotationContextDip theDip) {
	super(parent,title, true);
	
	myAnnotationContextDip=theDip;

	try {
	    myContextResourceBundle=(ContextResourceBundle)
		ResourceBundle.getBundle("com.ibm.beans.samples.dips.context.ContextResourceBundle");
	} catch (MissingResourceException x) {
	    System.err.println("*** Fatal Error for Annotation Context Dip - No Resource Bundle ***");
	    System.exit(fileNotFoundError);
	}

	myParent= parent;
	
	Label dialogCaption=new Label((String)
	   myContextResourceBundle.getString("ViewAnnotationDialogCaption"));
	add("North",dialogCaption);
	
	annotationHistoryList = new List();
	add("Center",annotationHistoryList);
	addAnnotationsToList(annotationHistoryList);
	okButton = new Button((String)
			      myContextResourceBundle.getString("OKButtonLabel"));
	okButton.setActionCommand("okButton");
        okButton.addActionListener(this);

	add("South",okButton);
	setSize(preferedWidth, preferedHeight);
	addWindowListener(this);
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosed(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeiconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowIconified(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowActivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowDeactivated(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowOpened(WindowEvent event) {
    }

    /**
     * Satisfies the WindowListener interface.
     * @param event The window event the listener receives.
     */
    public void windowClosing(WindowEvent event) {
	dispose();
    }

    /**
     * Listens for the <b>Ok</b> button and dismisses the dialog.
     * @param event The action event the listener receives.
     */
    public void actionPerformed(ActionEvent event) {
        String arg = event.getActionCommand();
        if (okButton.getActionCommand().equals(arg)) {
            dispose();
        }
    }

    
    private void addAnnotationsToList(List aList) {
	Vector aVec=(Vector)myAnnotationContextDip.getContextElement();
	if (aVec.isEmpty()) {
	    aList.addItem(
		myContextResourceBundle.getString("NoPreviousAnnotations"));
	} else {
	    for (int i=0; i<aVec.size(); i++) {
		aList.addItem((String)aVec.elementAt(i));
	    }
	}
    }

    private Frame myParent;
    private Button okButton;
    private List annotationHistoryList;
    private ContextResourceBundle myContextResourceBundle;
    private AnnotationContextDip myAnnotationContextDip;
    private static final int preferedWidth=260;
    private static final int preferedHeight=180;
    private static final int fileNotFoundError=28;

    private static final String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
