//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27,180
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.14 com/java/src/com/ibm/beans/samples/dips/license/LicenseIssuer.java, bbLicenseDip, bb97c, bb97c9750e 11/18/97 17:52:03 [12/11/97 17:01:40]
package com.ibm.beans.samples.dips.license;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.ResourceBundle;
import com.ibm.beans.samples.dips.license.HostAndDurationLicensePolicyCustomizer;
import com.ibm.beans.samples.dips.license.Messages;

/**
 * This class extends <tt>java.applet.Applet</tt> to provide a user-interface
 * for generating licenses.
 * It provides for:
 * <ul>
 * <li>Selection of the policy instance to use
 * <li>Presentation of the policy customizer
 * </ul>
 * The policy customizer is responsible for generating the license.
 */
public class LicenseIssuer extends Applet {

  /**
   * Starts LicenseIssuer as a Java application.  To invoke, enter the command
   * <tt>java com.ibm.beans.samples.dips.license.LicenseIssuer</tt>.  It
   * ignores all supplied arguments.
   *
   * @param args[]	The supplied arguments.
   */
  public static void main(String args[]) {
    // make and initialize an issuer app
    LicenseIssuer li = new LicenseIssuer();
    li.init();
    li.start();

    // make somewhere to put it
    Frame fr = new Frame("License Issuer");
    fr.add(li, "Center");

    // reseize the frame to fit applet
    fr.setSize(li.getPreferredSize());

    // listen for frame death
    fr.addWindowListener(li.new WindowDeathListener());

    fr.show();
  }

  /**
   * Gets the preferred width and height of the customizer.
   *
   * @return The preferred dimensions of the customizer.
   */
  public Dimension getPreferredSize() {
    Dimension x = new Dimension(400,300);
    return x;
  }

  /**
   * Creates the user-interface for this class.
   */
  public void init() {
    setLayout(new BorderLayout());

    // center
    // this is where the customizer will go

    // bottom
    Button loadButton = new Button("Load Policy");
    loadButton.addActionListener(new loadButtonListener());
    add(loadButton, "South");
  }

  // catches frame death and kills app
  class WindowDeathListener implements WindowListener {
    public void windowOpened(WindowEvent e) { }
    public void windowClosing(WindowEvent e) {
      System.exit(0);
    }
    public void windowClosed(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }
  }

  // Loads policy object and sets up customizer for it.
  class loadButtonListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {

      Object obj = null;	// the object we load

      // remove any existing customizer
      if (customizer != null) {
	remove(customizer);
      }

      // The following is necessary to create a file
      // dialog, select a file to read from, ensure that it can be
      // opened, open it for reading, make sure it is
      // read to as an object stream, stream in the license
      // issuer's policy clone object and then close the stream.
      // It is basically copied from JavaSoft's beanbox Save() method.
      String fname = null;
      java.awt.Component c = (java.awt.Component)e.getSource();
      while (c != null && !(c instanceof java.awt.Frame)) c = c.getParent();
      FileDialog fd = new FileDialog((java.awt.Frame)c , "Load License Issuer Object", FileDialog.LOAD);
      // the setDirectory() is not needed, except for a bug under Solaris...
      fd.setDirectory(System.getProperty("user.dir"));
      // Solaris currently ignores the setFile()
      fd.setFile("HDLIssuer.ser");
      fd.show();
      fname = fd.getFile();
      // if cancelled
      if (fname == null) {
	return;
      }
      String dname = fd.getDirectory();

      try {
	// create the single ObjectInputStream
	File serFile = new File(dname, fname);
	FileInputStream f = new FileInputStream(serFile);
	ObjectInputStream ois = new ObjectInputStream(f);
	obj = ois.readObject();
	ois.close();
      }
      catch (Exception ex) {
	Messages messages = (Messages)ResourceBundle.getBundle("com.ibm.beans.samples.dips.license.Messages");
	System.err.println(messages.handleGetObject("LoadPolicyError"));
	return;
      }

      // test if its a HostAndDurationLicensePolicy
      if (!(obj instanceof HostAndDurationLicensePolicy)) {
	Messages messages = (Messages)ResourceBundle.getBundle("com.ibm.beans.samples.dips.license.Messages");
	System.err.println(messages.handleGetObject("WrongTypeError"));
	return;
      }

      // instantiate a customizer for it and add it to the interface
      customizer = new HostAndDurationLicensePolicyCustomizer();
      add(customizer, "Center");

      // do the set object
      customizer.setObject(obj);

      // cause the selected customizer to fill out and display
      validate();
    }
  }

  private HostAndDurationLicensePolicyCustomizer customizer;
  private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
