//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/dips/license/PrintLicenseDipCustomizer.java, bbLicenseDip, bb97c, bb97c9750e 11/18/97 17:52:06 [12/11/97 17:01:38]
package com.ibm.beans.samples.dips.license;

import java.awt.Dimension;
import java.awt.Panel;
import java.beans.Customizer;
import java.beans.PropertyChangeListener;

/**
 * The PrintLicenseDipCustomizer serves as a shell for the
 * license policy customizer.  There are no properties on the print license
 * dip that require customization.
 */
public class PrintLicenseDipCustomizer extends Panel implements Customizer {

  /**
   * Constructs a PrintLicenseDipCustomizer.  This customizer gets
   * and presents a license policy customizer for the dip.
   */
  public PrintLicenseDipCustomizer() {
    // ideally, we would figure this out at setObject() time
    // but since we know it's not going to change...
    policyCustomizer = new HostAndDurationLicensePolicyCustomizer();
    add(policyCustomizer);
  }
  
  // Panel overrides

  /**
   * Gets the preferred size of the customizer.
   * This method performs a passthru to the policy's customizer because it
   * is the only thing presented by this customizer.
   *
   * @return The preferred width and height of the customizer.
   */
  public Dimension getPreferredSize() {
    return policyCustomizer.getPreferredSize();
  }

  // Customizer interface

  /**
   * Sets the object instance with which this customizer is to interact.
   * Once the object is set, the customizer for the license
   * policy can be set.
   *
   * @param bean	The bean instance to customize.
   */
  public void setObject(Object bean) {
    // we don't need to keep a reference to the dip, but we
    // do need its policy object.  If someone gives us a bean that's
    // not what we expect, we're in trouble. 
    PrintLicenseDip dip = (PrintLicenseDip)bean;
    policyCustomizer.setObject(dip.getPolicy());
  }

  /**
   * Adds a listener to get notified when the customizer changes the
   * bean in a significant manner.  There are no significant changes
   * that can be made to the dip itself.
   *
   * @param listener	The object to be notified of changes.
   */
  public void addPropertyChangeListener(PropertyChangeListener listener) { }

  /**
   * Removes a listener from the notification list.
   *
   * @param listener	The object to be removed from the notification list.
   */
  public void removePropertyChangeListener(PropertyChangeListener listener) { }

  private HostAndDurationLicensePolicyCustomizer policyCustomizer;

  private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
