/*
    PerformanceDip bean

    Package: com.ibm.beans.samples.dips.perform
    Bean   : PerformanceDip

    Author : John W. Alcorn (jalcorn@us.ibm.com)
    Date   : November 18, 1997

    Copyright (c) IBM Corp., 1997
        - all rights reserved

    //====START_GENERATED_PROLOG======================================
    //
    //
    //   COMPONENT_NAME: bbDipWizard
    //
    //   CLASSES: none
    //
    //   ORIGINS: 27
    //
    //
    //   (C) COPYRIGHT International Business Machines Corp. 1997
    //   All Rights Reserved
    //   Licensed Materials - Property of IBM
    //   US Government Users Restricted Rights - Use, duplication or
    //   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
    //
    //   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
    //   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    //   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
    //   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
    //   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    //   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
    //   OR PERFORMANCE OF THIS SOFTWARE.
    //
    //====END_GENERATED_PROLOG========================================
    //
    // @(#) 1.4 com/java/src/com/ibm/beans/samples/dips/perform/PerformanceDip.java, bbDipWizard, bb97c, bb97c9750e 11/21/97 15:41:38 [12/11/97 17:03:35]
*/

// Code generated by IBM BeanExtender Dip Creation Wizard
package com.ibm.beans.samples.dips.perform;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.text.*;
import java.util.*;
import com.ibm.beans.dip.*;
import com.ibm.beans.util.*; //This line added after code generation by Dip Creation Wizard


/**
 * This dip outputs how long each method call, property change, and event fire takes.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 */
public class PerformanceDip extends SimpleDip implements Serializable, DipMethodCallListener, DipVetoableMethodListener, DipPropertyChangeListener, DipVetoableChangeListener, DipEventFireListener, DipVetoableEventListener
{   /**
    * Default constructor, invoked when the Dipping Framework calls
    * Beans.instantiate() to create an instance of this dip, in order to
    * apply to a dippable bean.  After the constructor runs, the dip's
    * createImplementation() method will be invoked.
    */
   public PerformanceDip ()
   {
      super();

      //Place initialization code here

      //Begin code added after generation by Dip Creation Wizard
      fDateVector = new Vector();

      fMsgFormatter = new MessageFormatter("com.ibm.beans.samples.dips.perform.PerformanceDipTextBundle");
      fOutputLog = BeanSystem.getOutputLog();
      //End code added after generation by Dip Creation Wizard
   }


   private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException
   {
      in.defaultReadObject();

      //Place initialization of transient data here

      //Begin code added after generation by Dip Creation Wizard
      fDateVector = new Vector();
      fOutputLog = BeanSystem.getOutputLog();
      //End code added after generation by Dip Creation Wizard
   }


   /**
    * Returns the dip type name as a String.  The typeName() method of
    * SimpleDip is abstract, so typeName() must be implemented here.
    *
    * @return A descriptive string describing the type of dip.
    * @see com.ibm.beans.dip.DipInfo#typeName()
    */
   public String typeName()
   {
      return "Performance Dip";
   }


   /**
    * Indicates whether this dip will allow another dip to be applied to its
    * dippable bean.  The default implementation in SimpleDip is to always
    * allow any other dip to be applied.
    * <p>
    * The Performance Dip always returns false, so that other dips won't
    * interfere with performance measurements.
    *
    * @param dipTypeName The new dip requesting to be added to the bean.
    * @return boolean indicating if new dip is allowed to be added.
    * @see com.ibm.beans.dip.DipInfo#worksWith()
    */
   public boolean worksWith(String dipTypeName)
   {
      //Some dips may want conditional code here (such as a performance dip
      //that will allow things like security dips, that don't affect every
      //method call, but refuse things like a trace dip, that would bias
      //any performance data gathered, due to the influence of the trace
      //dip on the speed with which each method executes).

      return false;
   }


   /**
    * Wires the dip to receive notification immediately after the specified
    * methods of the dippable bean are called.
    *
    * @param impl This value should be <tt>null</tt>.  There is no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipMethodCallListeners with this dip set to
    *         listen at the appropriate method indices.
    * @see #handleMethodCall
    * @see com.ibm.beans.dip.Dip#createMethodCallListener()
    */
   public DipMethodCallListener[] createMethodCallListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the methodCallListeners array comes from SimpleDip
      super.createMethodCallListener(impl, methods);

      for (int i = 0; i < methodCallListeners.length; i++) {
         methodCallListeners[i] = this;
      } /* endfor */

      return methodCallListeners;
   }


   /**
    * Communicates to the dipping framework whether this dip requires
    * the arguments for intercepted methods of the dippable bean.  Returning
    * <tt>false</tt> avoids the performance impact of parameter marshaling.
    *
    * @return boolean indicating whether this dip requires the arguments
    *         from intercepted methods.
    * @see com.ibm.beans.dip.DipMethodCallListener#needsArguments
    */
   public boolean needsArguments() {
      //Note that, although most general purpose dips will return false
      //here, in order to avoid the performance impact of parameter
      //marshaling, some dips may need to return true, if their behavior
      //depends upon the values contained in the arguments to the
      //intercepted methods.  Custom dips, which are only applicable
      //to specific classes (such as business logic dips), in particular
      //may need to inspect the arguments and react accordingly.

      return false;
   }


   /**
    * Responds to a bound method of the dippable bean being invoked.
    *
    * @param evt A MethodCallEvent object describing the event source
    *        and the property that changed.
    * @see com.ibm.beans.dip.MethodCallListener#handleMethodCall
    */
   public void handleMethodCall(MethodCallEvent evt)
   {
      //Place code here for responding to bound method calls

      //Begin code added after generation by Dip Creation Wizard
      if (evt.getMethodId().indexOf("readObject")==-1) { //readObject not vetoable
         Date endTime = new Date();
         Date startTime = (Date) fDateVector.elementAt(fDateVector.size()-1);
         if (startTime!=null) { // It will be null for readObject, which isn't vetoable
            fDateVector.removeElement(startTime);
            long elapsedTime = endTime.getTime()-startTime.getTime();
            fOutputLog.println(fMsgFormatter, "methodCall", java.lang.Long.toString(elapsedTime), evt.getMethodId());
         } /* endif */
      } /* endif */
      //End code added after generation by Dip Creation Wizard
   }


   /**
    * Wires the dip to receive notification immediately before the specified
    * methods of the dippable bean are called.  The dip will also have the
    * option of vetoing the method call in progress.
    *
    * @param impl This value should be <tt>null</tt>.  This dip has no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipVetoableMethodListeners with this dip set to
    *         listen at the appropriate method indices.
    * @see #handleVetoableMethod
    * @see com.ibm.beans.dip.Dip#createVetoableMethodListener()
    */
   public DipVetoableMethodListener[] createVetoableMethodListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the vetoableMethodListeners array comes from SimpleDip
      super.createVetoableMethodListener(impl, methods);

      for (int i = 0; i < vetoableMethodListeners.length; i++) {
         vetoableMethodListeners[i] = this;
      } /* endfor */

      return vetoableMethodListeners;
   }

   /**
    * Responds to a constrained method of the dippable bean being invoked.
    *
    * @param evt An MethodCallEvent object describing the event source
    *        and the method that was called.
    * @exception MethodVetoException This exception is thrown if the VetoableMethodListener
    *            wants the method operation not to be performed.
    * @see com.ibm.beans.dip.VetoableMethodListener#handleVetoableMethod
    */
   public void handleVetoableMethod(MethodCallEvent evt) throws MethodVetoException
   {
      //Place code here for responding to constrained method calls

      //Following line added after code generation by Dip Creation Wizard
      fDateVector.addElement(new Date());
   }


   /**
    * Allows listeners to perform recovery operations when a constrained method is vetoed.
    *
    * @param evt A MethodCallEvent object describing the event source
    *        and the method that was called.
    * @see com.ibm.beans.dip.VetoableMethodListener#recoverFromMethodVeto
    */
   public void recoverFromMethodVeto(MethodCallEvent evt)
   {
      //Place code here for responding to veto of the specified method by another dip
      fDateVector.removeElementAt(fDateVector.size()-1);
   }


   /**
    * Wires the dip to receive notification immediately after the specified
    * properties of the dippable bean are changed.
    *
    * @param impl This value should be <tt>null</tt>.  This dip has no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipPropertyChangeListeners with this dip set to
    *         listen at the appropriate method indices.
    * @see #propertyChange
    * @see com.ibm.beans.dip.Dip#createPropertyChangeListener()
    */
   public DipPropertyChangeListener[] createPropertyChangeListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the propertyChangeListeners array comes from SimpleDip
      super.createPropertyChangeListener(impl, methods);

      for (int i = 0; i < propertyChangeListeners.length; i++) {
         propertyChangeListeners[i] = this;
      } /* endfor */

      return propertyChangeListeners;
   }


   /**
    * Responds to a bound property of the dippable bean being changed.
    *
    * @param evt A PropertyChangeEvent object describing the event
    *        source and the property that changed.
    * @see java.beans.PropertyChangeListener#propertyChange
    */
   public void propertyChange(PropertyChangeEvent evt)
   {
      //Place code here for responding to bound property changes

      //Begin code added after generation by Dip Creation Wizard
      Date endTime = new Date();
      Date startTime = (Date) fDateVector.elementAt(fDateVector.size()-1);
      if (startTime!=null) {
         fDateVector.removeElement(startTime);
         long elapsedTime = endTime.getTime()-startTime.getTime();
         fOutputLog.println(fMsgFormatter, "propertyChange", java.lang.Long.toString(elapsedTime), evt.getPropertyName());
      } /* endif */
      //End code added after generation by Dip Creation Wizard
   }


   /**
    * Wires the dip to receive notification immediately before the specified
    * properties of the dippable bean are changed.  The dip will also have the
    * option of vetoing the property change in progress.
    *
    * @param impl This value should be <tt>null</tt>.  This dip has no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipVetoableMethodListeners with this dip set to
    *         listen at the appropriate method indices.
    * @see #vetoableChange
    * @see com.ibm.beans.dip.Dip#createVetoableChangeListener()
    */
   public DipVetoableChangeListener[] createVetoableChangeListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the vetoableChangeListeners array comes from SimpleDip
      super.createVetoableChangeListener(impl, methods);

      for (int i = 0; i < vetoableChangeListeners.length; i++) {
         vetoableChangeListeners[i] = this;
      } /* endfor */

      return vetoableChangeListeners;
   }


   /**
    * Responds to a constrained property of the dippable bean being changed.
    * Note that, unlike the method and event listeners, there is no
    * recoverFromPropertyVeto() method that will get called if another
    * dip vetoes the property change; instead, vetoableChange() will
    * get called again, and its PropertyChangeEvent parameter will
    * contain the original value of the property.
    *
    * @param evt A PropertyChangeEvent object describing the
    *        event source and the property that changed.
    * @exception PropertyVetoException This exception is thrown if the dip
    *            does not approve of the property change in progress.
    * @see java.beans.VetoableChangeListener#vetoableChange
    */
   public void vetoableChange(PropertyChangeEvent evt) throws PropertyVetoException
   {
      //Place code here for responding to constrained property changes

      //Following line added after code generation by Dip Creation Wizard
      fDateVector.addElement(new Date());
   }


   /**
    * Wires the dip to receive notification immediately after the specified
    * events of the dippable bean are fired.
    *
    * @param impl This value should be <tt>null</tt>.  This dip has no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipEventFireListeners with this dip set to listen at
    *         the appropriate method indices.
    * @see #handleEventFire
    * @see com.ibm.beans.dip.Dip#createEventFireListener()
    */
   public DipEventFireListener[] createEventFireListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the eventFireListeners array comes from SimpleDip
      super.createEventFireListener(impl, methods);

      for (int i = 0; i < eventFireListeners.length; i++) {
         eventFireListeners[i] = this;
      } /* endfor */

      return eventFireListeners;
   }


   /**
    * This method is called when a bound event is fired.
    *
    * @param evt An EventFireEvent object describing the event source
    *        and the event that was fired.
    * @see com.ibm.beans.dip.EventFireListener#handleEventFire
    */
   public void handleEventFire(EventFireEvent evt)
   {
      //Place code here for responding to bound event fires

      //Begin code added after generation by Dip Creation Wizard
      Date endTime = new Date();
      Date startTime = (Date) fDateVector.elementAt(fDateVector.size()-1);
      if (startTime!=null) {
         fDateVector.removeElement(startTime);
         long elapsedTime = endTime.getTime()-startTime.getTime();
         fOutputLog.println(fMsgFormatter, "eventFire", java.lang.Long.toString(elapsedTime), evt.getEventSetName());
      } /* endif */
      //End code added after generation by Dip Creation Wizard
   }


   /**
    * Wires the dip to receive notification immediately before the specified
    * events of the dippable bean are fired.  The dip will also have the
    * option of vetoing the event fire in progress.
    *
    * @param impl This value should be <tt>null</tt>.  This dip has no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipVetoableEventListeners with this dip set to listen at
    *         the appropriate method indices.
    * @see #handleVetoableEvent
    * @see com.ibm.beans.dip.Dip#createVetoableEventListener()
    */
   public DipVetoableEventListener[] createVetoableEventListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the vetoableEventListeners array comes from SimpleDip
      super.createVetoableEventListener(impl, methods);

      for (int i = 0; i < vetoableEventListeners.length; i++) {
         vetoableEventListeners[i] = this;
      } /* endfor */

      return vetoableEventListeners;
   }


   /**
    * This method is called when a constrained event is fired.
    *
    * @param evt An EventFireEvent object describing the event source
    *        and the event that was fired.
    * @exception EventVetoException This exception is thrown if the VetoableEventListener
    *            instance wants the event firing canceled.
    * @see com.ibm.beans.dip.VetoableEventListener#handleVetoableEvent
    */
   public void handleVetoableEvent(EventFireEvent evt) throws EventVetoException
   {
      //Place code here for responding to constrained event fires

      //Following line added after code generation by Dip Creation Wizard
      fDateVector.addElement(new Date());
   }


   /**
    * Allow listeners to perform recovery operations when a constrained event was vetoed.
    *
    * @param evt An EventFireEvent object describing the event source
    *        and the event that was vetoed.
    * @see com.ibm.beans.dip.VetoableEventListener#recoverFromEventVeto
    */
   public void recoverFromEventVeto(EventFireEvent evt)
   {
      //Place code here for responding to a vetoed event

      //Following line added after code generation by Dip Creation Wizard
      fDateVector.removeElementAt(fDateVector.size()-1);
   }



  // Copyright Statement
  private final static String kCopyright = "(c) Copyright IBM Corp. 1997";

  // Serializable Stream Unique ID
  private final static long serialVersionUID = 2000L;

  // TextBundle containing translatable strings
  private PerformanceDipTextBundle bundle;

  // Vector of dates (this variable added after Dip Creation Wizard code generation)
  private transient Vector fDateVector;

  // MessageFormatter (this variable added after Dip Creation Wizard code generation)
  private transient MessageFormatter fMsgFormatter;

  // Output log (this variable added after Dip Creation Wizard code generation)
  private transient LogStream fOutputLog;
}
