//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbPrintDip
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/dips/print/PrintDipBeanInfo.java, bbPrintDip, bb97c, bb97c9750e 10/24/97 17:52:27 [12/11/97 17:01:45]
package com.ibm.beans.samples.dips.print;

import java.awt.Image;
import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.SimpleBeanInfo;

/**
 * <p>
 * The PrintDipBeanInfo class provides access to the
 * customizer and the icons for the PrintDip class.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 * @see com.ibm.beans.samples.dips.print.PrintDip
 * @see com.ibm.beans.samples.dips.print.PrintDipCustomizer
 */
public class PrintDipBeanInfo extends SimpleBeanInfo {

  /**
   * Gets a BeanDescriptor with the PrintDipCustomizer
   * as the customizer class.
   *
   * @return A BeanDescriptor with an appropriate customizer defined.
   */
  public BeanDescriptor getBeanDescriptor() {
     return new BeanDescriptor(PrintDip.class, PrintDipCustomizer.class);
  }


  /**
   * Provides icon representations for the Print Dip.
   * This method is for use by tools such as the BeanBag.
   *
   * @param iconKind The desired format for the icon image.
   * @return The image of the requested format.
   */
  public Image getIcon(int iconKind) {
     Image icon = null;

     if (iconKind == BeanInfo.ICON_COLOR_16x16)
        icon = loadImage("PrintDipIconColor16.gif");

     if (iconKind == BeanInfo.ICON_COLOR_32x32)
        icon = loadImage("PrintDipIconColor32.gif");

     return icon;
  }


  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

