//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbPrintDip
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved - Patent(s) Pending
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/samples/dips/print/PrintDipCustomizer.java, bbPrintDip, bb97c, bb97c9750e 10/24/97 17:52:40 [12/11/97 17:01:42]
package com.ibm.beans.samples.dips.print;

import java.awt.Checkbox;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import java.beans.Customizer;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.ResourceBundle;

/**
 * <p>
 * This class allows customization of the properties of the Print Dip.
 * By using this customizer, the assembler or user can specify whether to
 * show the floating frame, where it should appear, its size, what text to
 * display in the <b>Print</b> button, the title bar text, the print job
 * title, and so forth.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 * @see com.ibm.beans.samples.dips.print.PrintDip
 */
public class PrintDipCustomizer extends Panel implements Customizer, TextListener, ItemListener {

  // Panel overrides

  /**
   * Constructs a new Print Dip Customizer.  All of the AWT controls for
   * the customizer panel are created here.  These controls are initialized
   * in the setObject method.
   *
   * @see #setObject
   */
  public PrintDipCustomizer() {
     resourceBundle = (PrintDipResourceBundle) ResourceBundle.getBundle(
        "com.ibm.beans.samples.dips.print.PrintDipResourceBundle");

     GridBagLayout gridBag = new GridBagLayout();
     GridBagConstraints constraints = new GridBagConstraints();
     constraints.fill = GridBagConstraints.BOTH;
     constraints.weightx =  constraints.weighty = 1;
     constraints.insets = new Insets(2, 5, 2, 5);
     setLayout(gridBag);

/* Label and Checkbox for whether to show the floating dialog */
     Label printButtonFrameCheckboxLabel = new Label(
        resourceBundle.getString("GroupBoxLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameCheckboxLabel, constraints);
     add(printButtonFrameCheckboxLabel);

     showPrintButtonFrameCheckbox = new Checkbox(
        resourceBundle.getString("VisibilityLabel"));
     showPrintButtonFrameCheckbox.addItemListener(this);
     constraints.weighty = 3;
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(showPrintButtonFrameCheckbox, constraints);
     add(showPrintButtonFrameCheckbox);

/* Label and TextField for horizontal position of floating dialog */
     Label printButtonFrameXPosLabel = new Label(
        resourceBundle.getString("XPosLabel"), Label.RIGHT);
     constraints.weighty = 1;
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameXPosLabel, constraints);
     add(printButtonFrameXPosLabel);

     printButtonFrameXPosTextField = new TextField(5);
     printButtonFrameXPosTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonFrameXPosTextField, constraints);
     add(printButtonFrameXPosTextField);

/* Label and TextField for vertical position of floating dialog */
     Label printButtonFrameYPosLabel = new Label(
        resourceBundle.getString("YPosLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameYPosLabel, constraints);
     add(printButtonFrameYPosLabel);

     printButtonFrameYPosTextField = new TextField(5);
     printButtonFrameYPosTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonFrameYPosTextField, constraints);
     add(printButtonFrameYPosTextField);

/* Label and TextField for width of floating dialog */
     Label printButtonFrameWidthLabel = new Label(
        resourceBundle.getString("WidthLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameWidthLabel, constraints);
     add(printButtonFrameWidthLabel);

     printButtonFrameWidthTextField = new TextField(5);
     printButtonFrameWidthTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonFrameWidthTextField, constraints);
     add(printButtonFrameWidthTextField);

/* Label and TextField for height of floating dialog */
     Label printButtonFrameHeightLabel = new Label(
        resourceBundle.getString("HeightLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameHeightLabel, constraints);
     add(printButtonFrameHeightLabel);

     printButtonFrameHeightTextField = new TextField(5);
     printButtonFrameHeightTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonFrameHeightTextField, constraints);
     add(printButtonFrameHeightTextField);

/* Blank vertical buffer label */
     Label buffer1Label = new Label();
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(buffer1Label, constraints);
     add(buffer1Label);

/* Label and TextField for title bar text of floating dialog */
     Label printButtonFrameTitleTextLabel = new Label(
        resourceBundle.getString("TitleBarTextLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonFrameTitleTextLabel, constraints);
     add(printButtonFrameTitleTextLabel);

     printButtonFrameTitleTextTextField = new TextField(15);
     printButtonFrameTitleTextTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonFrameTitleTextTextField, constraints);
     add(printButtonFrameTitleTextTextField);

/* Label and TextField for "Print" button text in floating dialog */
     Label printButtonTextLabel = new Label(
        resourceBundle.getString("PrintButtonTextLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printButtonTextLabel, constraints);
     add(printButtonTextLabel);

     printButtonTextTextField = new TextField(15);
     printButtonTextTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printButtonTextTextField, constraints);
     add(printButtonTextTextField);

/* Blank vertical buffer label */
     Label buffer2Label = new Label();
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(buffer2Label, constraints);
     add(buffer2Label);

/* Label and TextField for print job title text */
     Label printJobTitleTextLabel = new Label(
        resourceBundle.getString("PrintJobTitleLabel"), Label.RIGHT);
     constraints.gridwidth = 1;
     gridBag.setConstraints(printJobTitleTextLabel, constraints);
     add(printJobTitleTextLabel);

     printJobTitleTextTextField = new TextField(15);
     printJobTitleTextTextField.addTextListener(this);
     constraints.gridwidth = GridBagConstraints.REMAINDER;
     gridBag.setConstraints(printJobTitleTextTextField, constraints);
     add(printJobTitleTextTextField);
  }


  /**
   * Returns the smallest width and height at which this panel can be displayed
   * with all of its AWT controls visible.
   *
   * @return A Dimension structure containing this panel's minimum width and height
   */
  public Dimension getMinimumSize() {
     return(new Dimension(209, 237));
  }


  // Customizer interface

  /**
   * Sets the object instance with which this customizer is to interact.
   * This is where each of the AWT controls (created in the constructor
   * method) are initialized, based on the values of the properties
   * associated with the instance of the PrintDip provided as input.
   *
   * @param bean	The instance of the PrintDip to customize.
   */
  public void setObject(Object bean) {
     if (bean != null) {
        printDip = (PrintDip) bean;
        propertyChangeSupport = new PropertyChangeSupport(printDip);
     } else {
        return; //not much we can do - caller isn't expecting any exceptions
                //returning at least keeps us from trapping...
     } /* endif */

     showPrintButtonFrameCheckbox.setState(printDip.getShowPrintButtonFrame());
     printButtonFrameXPosTextField.setText(Short.toString(printDip.getPrintButtonFrameXPos()));
     printButtonFrameYPosTextField.setText(Short.toString(printDip.getPrintButtonFrameYPos()));
     printButtonFrameWidthTextField.setText(Short.toString(printDip.getPrintButtonFrameWidth()));
     printButtonFrameHeightTextField.setText(Short.toString(printDip.getPrintButtonFrameHeight()));
     printButtonFrameTitleTextTextField.setText(printDip.getPrintButtonFrameTitleText());
     printButtonTextTextField.setText(printDip.getPrintButtonText());
     printJobTitleTextTextField.setText(printDip.getPrintJobTitleText());
  }


  /**
   * Adds a listener to be notified when the customizer changes
   * one of the bean's properties.
   *
   * @param listener	The object to be notified of changes.
   */
  public void addPropertyChangeListener(PropertyChangeListener listener) {
     propertyChangeSupport.addPropertyChangeListener( listener );
  }


  /**
   * Removes a listener from the notification list.
   *
   * @param listener	The object to be removed from the notification list.
   */
  public void removePropertyChangeListener(PropertyChangeListener listener) {
     propertyChangeSupport.removePropertyChangeListener( listener );
  }


  // ItemListener interface

  /**
   * Receives selection events from the checkbox.
   *
   * @param evt	Describes the event that occurred.
   */
  public void itemStateChanged(ItemEvent evt) {
     if (evt.getSource()==showPrintButtonFrameCheckbox) {
        if (evt.getStateChange()==ItemEvent.SELECTED) {
           printDip.setShowPrintButtonFrame(true);
           propertyChangeSupport.firePropertyChange("showPrintButtonFrame",
              new Boolean(false), new Boolean(true));
        } /* endif */

        if (evt.getStateChange()==ItemEvent.DESELECTED) {
           printDip.setShowPrintButtonFrame(false);
           propertyChangeSupport.firePropertyChange("showPrintButtonFrame",
              new Boolean(true), new Boolean(false));
        } /* endif */
     } /* endif */
  }


  // TextListener interface

  /**
   * Receives keystrokes from the text fields.
   *
   * @param evt	Describes the event that occurred.
   */
  public void textValueChanged(TextEvent evt) {
/* Floating dialog Horizontal location changed */
     if (evt.getSource()==printButtonFrameXPosTextField) {
        String newText = printButtonFrameXPosTextField.getText();
        try {
           Short xPos = new Short(newText);
           Short oldXPos = new Short(printDip.getPrintButtonFrameXPos());
           printDip.setPrintButtonFrameXPos(xPos.shortValue());
           propertyChangeSupport.firePropertyChange("printButtonFrameXPos",
              oldXPos, xPos);
        } catch(NumberFormatException ex) {
           System.err.println(ex.getClass().getName());
        } /* end try */

        String xPosString = Short.toString(printDip.getPrintButtonFrameXPos());
        if (!newText.equals(xPosString)) { /* dip rejected new value */
           printButtonFrameXPosTextField.setText(xPosString);
        } /* endif */
     } /* endif */

/* Floating dialog Vertical location changed */
     if (evt.getSource()==printButtonFrameYPosTextField) {
        String newText = printButtonFrameYPosTextField.getText();
        try {
           Short yPos = new Short(newText);
           Short oldYPos = new Short(printDip.getPrintButtonFrameYPos());
           printDip.setPrintButtonFrameYPos(yPos.shortValue());
           propertyChangeSupport.firePropertyChange("printButtonFrameYPos",
              oldYPos, yPos);
        } catch(NumberFormatException ex) {
           System.err.println(ex.getClass().getName());
        } /* end try */

        String yPosString = Short.toString(printDip.getPrintButtonFrameYPos());
        if (!newText.equals(yPosString)) { /* dip rejected new value */
           printButtonFrameYPosTextField.setText(yPosString);
        } /* endif */
     } /* endif */

/* Floating dialog Width changed */
     if (evt.getSource()==printButtonFrameWidthTextField) {
        String newText = printButtonFrameWidthTextField.getText();
        try {
           Short width = new Short(newText);
           Short oldWidth = new Short(printDip.getPrintButtonFrameWidth());
           printDip.setPrintButtonFrameWidth(width.shortValue());
           propertyChangeSupport.firePropertyChange("printButtonFrameWidth",
              oldWidth, width);
        } catch(NumberFormatException ex) {
           System.err.println(ex.getClass().getName());
        } /* end try */

        String widthString = Short.toString(printDip.getPrintButtonFrameWidth());
        if (!newText.equals(widthString)) { /* dip rejected new value */
           printButtonFrameWidthTextField.setText(widthString);
        } /* endif */
     } /* endif */

/* Floating dialog Height changed */
     if (evt.getSource()==printButtonFrameHeightTextField) {
        String newText = printButtonFrameHeightTextField.getText();
        try {
           Short height = new Short(newText);
           Short oldHeight = new Short(printDip.getPrintButtonFrameHeight());
           printDip.setPrintButtonFrameHeight(height.shortValue());
           propertyChangeSupport.firePropertyChange("printButtonFrameHeight",
              oldHeight, height);
        } catch(NumberFormatException ex) {
           System.err.println(ex.getClass().getName());
        } /* end try */

        String heightString = Short.toString(printDip.getPrintButtonFrameHeight());
        if (!newText.equals(heightString)) { /* dip rejected new value */
           printButtonFrameHeightTextField.setText(heightString);
        } /* endif */
     } /* endif */

/* Floating dialog title bar text changed */
     if (evt.getSource()==printButtonFrameTitleTextTextField) {
        String titleText = printButtonFrameTitleTextTextField.getText();
        String oldTitleText = printDip.getPrintButtonFrameTitleText();
        printDip.setPrintButtonFrameTitleText(titleText);
        propertyChangeSupport.firePropertyChange("printButtonFrameTitleText",
           oldTitleText, titleText);
     } /* endif */

/* "Print" button text changed */
     if (evt.getSource()==printButtonTextTextField) {
        String buttonText = printButtonTextTextField.getText();
        String oldButtonText = printDip.getPrintButtonText();
        printDip.setPrintButtonText(buttonText);
        propertyChangeSupport.firePropertyChange("printButtonText",
           oldButtonText, buttonText);
     } /* endif */

/* Print job title text changed */
     if (evt.getSource()==printJobTitleTextTextField) {
        String jobTitleText = printJobTitleTextTextField.getText();
        String oldJobTitleText = printDip.getPrintJobTitleText();
        printDip.setPrintJobTitleText(jobTitleText);
        propertyChangeSupport.firePropertyChange("printJobTitleText",
           oldJobTitleText, jobTitleText);
     } /* endif */
  }


/* Instance of the PrintDip being customized */
  private PrintDip printDip = null;

/* AWT controls */
  private Checkbox showPrintButtonFrameCheckbox = null;

  private TextField printButtonFrameXPosTextField = null;
  private TextField printButtonFrameYPosTextField = null;

  private TextField printButtonFrameWidthTextField = null;
  private TextField printButtonFrameHeightTextField = null;

  private TextField printButtonFrameTitleTextTextField = null;

  private TextField printButtonTextTextField = null;

  private TextField printJobTitleTextTextField = null;

/* Helper class for handling property updates via the customizer */
  private PropertyChangeSupport propertyChangeSupport = null;

/* Helper class for retrieving translatable strings */
  private PrintDipResourceBundle resourceBundle = null;

/* Standard copyright statement */
  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}
