//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbMessages
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved - Patent(s) Pending
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.6 com/java/src/com/ibm/beans/samples/dips/print/PrintDipResourceBundle.java, bbMessages, bb97c 9/25/97 13:54:58 [10/7/97 18:37:52]
package com.ibm.beans.samples.dips.print;

import java.awt.Toolkit;
import java.util.ListResourceBundle;

/**
 * <p>
 * This class provides the Print Dip access to its translatable strings.
 * The PrintDipCustomizer also utilizes this class.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 * @see java.util.ListResourceBundle
 */
public class PrintDipResourceBundle extends ListResourceBundle {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
  /**
   * Retrieves an array, into which one can index to obtain a translatable string.
   *
   * @return A two dimensional array, where the first element in the
   * array is a String key, and the second element in the array is the
   * value or message.
   */
  public Object[][] getContents() {
    return contents;
  }


  static final Object[][] contents = {
    // LOCALIZE THIS

    /*
     * Dipping Framework related strings
     */

    /**
      * <!-- Message Owner: John W. Alcorn -->
      * <p class='Message Detail'>
      * An attempt was made to apply the Print Dip to a dippable bean which
      * does not have <tt>java.awt.Component</tt> as an ancestor.
      * <p class='Message Action'>
      * The Print Dip cannot be applied to this bean.  To use the Print Dip,
      * it must be applied to a bean which has <tt>java.awt.Component</tt> as
      * an ancestor.
      */
    {"RejectAdditionException", "PrintDip001E: Dippable bean is not an AWT component"},

    /**
      * <!-- Message Owner: John W. Alcorn -->
      * <p class='Message Detail'>
      * An attempt was made to apply the Print Dip to a dippable bean which
      * did not have its addNotify and/or removeNotify methods wrapped when
      * it was morphed.
      * <p class='Message Action'>
      * Re-morph the bean, this time allowing the addNotify and removeNotify
      * methods to be wrapped.
      */
    {"RejectAdditionException2", "PrintDip002E: Dippable bean's addNotify or removeNotify methods not wrapped"},


    // The rest of the messages do not need to be exposed in the message guide


    /* Print Dip's Type Name (used in "Dips Applied" dialog) */
    {"TypeName", "Print Dip"},


    /*
     * Defaults for PrintDip properties of type String
     */

    /* Default title bar text for floating dialog */
    {"DefaultPrintButtonFrameTitleText", "Print Dip"},

    /* Default label text for "Print" button (in the floating dialog) */
    {"DefaultPrintButtonText", "Print"},

    /* Default print job title */
    {"DefaultPrintJobTitleText", "Print Dip"},


    /*
     * Labels for fields in the PrintDipCustomizer
     */

    /* Describes the floating frame's X Pos value */
    {"XPosLabel", "Horizontal Location"},

    /* Describes the floating frame's Y Pos value */
    {"YPosLabel", "Vertical Location"},

    /* Describes the floating frame's width value */
    {"WidthLabel", "Width"},

    /* Describes the floating frame's height value */
    {"HeightLabel", "Height"},

    /* Describes the print button's text */
    {"PrintButtonTextLabel", "Print Button Text"},

    /* Describes the floating frame's title bar text */
    {"TitleBarTextLabel", "Title Bar Text"},

    /* Describes the floating frame's visibility value */
    {"VisibilityLabel", "Visible"},

    /* The floating frame group box title */
    {"GroupBoxLabel", "Print Button Dialog"},

    /* Describes the print job's title text value */
    {"PrintJobTitleLabel", "Print Job Title"}

  };
}

