//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/dips/sessauth/SAAuthenticator.java, bbSecurityDip, bb97c, bb97c9750e 11/18/97 18:38:21 [12/11/97 17:01:50]
package com.ibm.beans.samples.dips.sessauth;

import java.io.Serializable;

/**
    This object describes the concept of an authenticator.  An
    authenticator is an object that knows how to validate
    a particular principal.  For example, the sample authenticator knows
    how to validate the sample principal, which consists of a User ID and
    Password.
    <p>
    This interface extends the interface Serializable.
    Therefore, classes implementing this interface should
    consider defining a serialVersionUID class variable such as:
    <br>
    <tt>private static final long serialVersionUID = 2000L;</tt>

    @see com.ibm.beans.samples.dips.sessauth.SAPrincipal
    @see com.ibm.beans.samples.dips.sessauth.demo.SampleSimpleAuthenticator
    @see com.ibm.beans.samples.dips.sessauth.demo.SamplePrincipal
*/
public interface SAAuthenticator extends Serializable
{
    /**
        Authenticates the principal.

        @param principal The principal that is to be authenticated.
        @return <tt>true</tt> if authentication is successful; <tt>false</tt> otherwise.
    */
    boolean authenticatePrincipal( SAPrincipal principal );

    /**
        Change this principal's authentication information.

        @param oldPrincipal The authentication information of the original principal.
        @param newPrincipal The revised authentication information.
        @return <tt>true</tt> if information was successfully changed; <tt>false</tt> otherwise.
    */
    boolean changeAuthenticationInformation( SAPrincipal oldPrincipal, SAPrincipal newPrincipal );
}
