//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/com/ibm/beans/samples/dips/sessauth/SAInstantiationListener.java, bbSecurityDip, bb97c, bb97c9750e 11/19/97 10:24:53 [12/11/97 17:01:53]
package com.ibm.beans.samples.dips.sessauth;

import com.ibm.beans.dip.Dip;
import com.ibm.beans.dip.DipMethodCallListener;
import com.ibm.beans.dip.MethodCallEvent;

/**
    This object intercepts calls to instantiate a dippable bean that has been
    dipped in the Session Authentication dip. For example, when a dippable bean's
    readObject method is called.  When the dippable bean is
    instantiated, this dip attempts to authenticate the principal by
    first querying for the principal's information, such as a User ID and
    Password, and then attempting to authenticate that principal.
    <p>
    This is the object that the Session Authentication dip registers with the
    dip framework for each method in the dippable bean that instantiates the bean.

    @see com.ibm.beans.samples.dips.sessauth.SessionAuthenticationDip
    @see com.ibm.beans.samples.dips.sessauth.SessionAuthenticationDip#createMethodCallListener
    @see com.ibm.beans.samples.dips.sessauth.SAPrincipal
    @see com.ibm.beans.samples.dips.sessauth.SAPrincipalQuery
    @see com.ibm.beans.samples.dips.sessauth.SAAuthenticator
*/
public class SAInstantiationListener implements com.ibm.beans.dip.DipMethodCallListener
{
    /*
        We must have a reference to the implemenation, so don't allow constructing
        without it.
    */
    private SAInstantiationListener() { }

    /**
        Constructs an SAInstantiationListener.

        @param implementation A reference to this dip's implementation.
    */
    public SAInstantiationListener( SAImpl implementation ) {
        this.implementation = implementation;
    }

    /**
        Handles calls to the dippable beans methods by authenicating the principal.  
        This method is invoked when a dippable bean is instantiated and
        the principal should be validated.
        The dippable bean's instantiation from a serialized object using a
        call to it's readObject method is intercepted.  The dippable bean's
        constructors are not intercepted.

        @param evt A MethodCallEvent object describing the method.
    */
    public void handleMethodCall( MethodCallEvent evt ) {
        SADip.traceln( 1000, "SAInstantiationListener.handleMethodCall" );
        implementation.authenticate();
    }

    /**
        Indicates whether this listener needs arguments.  By not needing arguments,
        performance is improved because the dipping framework does not need to do
        any marshaling.

        @return <tt>true</tt> if the listener requires arguments, <tt>false</tt> otherwise.
    */
    public boolean needsArguments( ) {
        return false;
    }

    /**
        Retrieves a pointer to the Dip that created the listener.

        @return A reference to the dip that created this listener.
     */
    public Dip retrieveDip() {
        return implementation.getDip();
    }

    //----------------------------------------
    // Private methods and data

    SAImpl implementation;

    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
