//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/samples/dips/sessauth/SAPrincipalQuery.java, bbSecurityDip, bb97c, bb97c9750e 11/19/97 10:24:54 [12/11/97 17:01:54]
package com.ibm.beans.samples.dips.sessauth;

import java.beans.PropertyDescriptor;

/**
    Defines the interface through which information pertaining to a particular principal
    is queried.
    This abstract class should be extended to query for a particular principal.
    The Session Authentication Dip invokes this object's queryForPrincipal() method
    to initiate validation.  
    <p>
    This method should obtain the principal information and invoke
    the authenticator to validate that principal.
    The information pertaining to a particular principal might
    consist of a User ID and Password, for example.
    A concrete implementation of this class for that principal would prompt the end user
    to enter a User ID and Password using an AWT dialog, and then invoke the appropriate
    authenticator to validate the User ID and Password.


    @see com.ibm.beans.samples.dips.sessauth.SAPrincipal
    @see com.ibm.beans.samples.dips.sessauth.SAAuthenticator
    @see com.ibm.beans.samples.dips.sessauth.demo.SamplePrincipalQuery


*/
public abstract class SAPrincipalQuery /* NOT Serializable */
{
    /**
        Queries the principal information and attempts to
        authenticate it.  The Session Authentication
        Implementation state regarding the success or failure of
        authentication is updated
        based on the return value of this method.
        <p>
        This method obtains the principal information, and then invokes the authenticator
        to validate that principal.  The authenticator is invoked by calling the
        implementation's doAuthentication() method.
        <p>
        This method must suspend the calling thread
        until authentication is complete, regardless of whether
        authentication is successful or not.

        @return <tt>true</tt> to indicate authentication successful, <tt>false</tt> otherwise.
        @see com.ibm.beans.samples.dips.sessauth.SAImpl#doAuthentication()
    */
    public abstract boolean queryForPrincipal( SAPrincipal principal );

    //----------------------------------------
    // Protected methods and data

    /**
        Returns the Session Authentication Dip implementation.  This reference can be
        used to set the value entered by the user for the principal in the implementation, and
        to invoke the appropriate authenticator on the principal.

        @see com.ibm.beans.samples.dips.sessauth.SAImpl#setPrincipal()

        @return The Session Authentication Dip implementation.
    */
    protected SAImpl getImplementation() {
        return implementation;
    }

    /*
        This method is called by the Session Authentication dip
        immediately after the SADialog object is created.  The dialog
        will need the Implementation referece to set
        authenticationSuccessfull
    */
    void setImplementation( SAImpl implementation ) {
        this.implementation = implementation;
    }


    //----------------------------------------
    // Private methods and data

    private SAImpl implementation;

    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
