//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/samples/dips/sessauth/demo/SamplePrincipalQueryAWT.java, bbSecurityDip, bb97c, bb97c9750e 11/19/97 10:24:46 [12/11/97 17:01:59]
package com.ibm.beans.samples.dips.sessauth.demo;

import com.ibm.beans.samples.dips.sessauth.SAPrincipalQuery;
import com.ibm.beans.samples.dips.sessauth.SAPrincipal;
import com.ibm.beans.samples.dips.sessauth.SAImpl;

import java.awt.*;
import java.awt.event.*;

/*
    This sample for the Session Authentication dip will query the
    user via an AWT modal dialog for the information required by the
    SamplePrincipal object.  It will attempt to use the SampleAuthenticator
    object to validate that principal information.

    IMPORTANT NOTES:
    - This object is NOT serializable.
*/
class SamplePrincipalQueryAWT extends Dialog implements ActionListener
{
    public SamplePrincipalQueryAWT( SamplePrincipalQuery sampleQuery, Frame frame, String title ) {
        super( frame, title, true /* modal */ );
        this.frame = frame;
        this.sampleQuery = sampleQuery;

        pleaseEnter = new Label( sampleQuery.retrieveMessage( "SM_PLEASE_ENTER" ) );
        add( "North", pleaseEnter );

        // Build the prompt for UserID and Password

        promptPanel = new Panel();
        promptPanel.setLayout( new GridLayout( NUMBER_OF_ROWS, NUMBER_OF_COLUMNS ) );

        uidLabel = new Label( sampleQuery.retrieveMessage( "SM_UID_LABEL" ) );
        uidEntry = new TextField();

        pwLabel = new Label( sampleQuery.retrieveMessage( "SM_PW_LABEL" ) );
        pwEntry = new TextField();
        pwEntry.setEchoChar( '*' );

        promptPanel.add( uidLabel );
        promptPanel.add( uidEntry );

        promptPanel.add( pwLabel );
        promptPanel.add( pwEntry );

        add( "Center", promptPanel );

        buttonPanel = new Panel();
        buttonPanel.setLayout( new FlowLayout( FlowLayout.CENTER ) );

        okButton = new Button( sampleQuery.retrieveMessage( "SM_OK_BUTTON" ) );
        okButton.addActionListener( this );
        buttonPanel.add( okButton );

        cancelButton = new Button( sampleQuery.retrieveMessage( "SM_CANCEL_BUTTON" ) );
        cancelButton.addActionListener( this );
        buttonPanel.add( cancelButton );

        add( "South", buttonPanel );
        pack();
    }

    public void dispose() {
        // Attempt to cleanup any AWT event
        // threads that were spawned.

        okButton.removeActionListener( this );
        cancelButton.removeActionListener( this );
        super.dispose();
    }

    public void getPrincipalInfo( SamplePrincipal principal ) {

        this.principal = principal;
        uidEntry.setText( null );
        pwEntry.setText( null );

        // Since this is a modal dialog, the following will block UNTIL
        // the dialog is hidden.  This is done in the actionPerformed method
        // based on the user clicking a button

        setVisible( true );
    }

    public void actionPerformed( ActionEvent event ) {

        String actionCommand = event.getActionCommand();

        String tmpUserID = null;
        String tmpPassword = null;

        if ( actionCommand.equals( sampleQuery.retrieveMessage( "SM_OK_BUTTON" ) ) ) {
            tmpUserID = uidEntry.getText();
            tmpPassword = pwEntry.getText();
        }
        else if ( actionCommand.equals( sampleQuery.retrieveMessage( "SM_CANCEL_BUTTON" ) ) ) {
            tmpUserID = null;
            tmpPassword = null;
        }
        else {
            // unknown action
            tmpUserID = null;
            tmpPassword = null;
        }

        principal.setUserID( tmpUserID );
        principal.setPassword( tmpPassword );

        setVisible( false );  // hide ourselves, unblocking the thread
    }

    //----------------------------------------
    // Private data

    private static final int NUMBER_OF_ROWS = 2;
    private static final int NUMBER_OF_COLUMNS = 2;

    private static int unitTest = 0;

    private SamplePrincipalQuery sampleQuery;
    private Frame frame;
    private SamplePrincipal principal;

    // AWT fields

    private Panel promptPanel = null;
    private Panel buttonPanel = null;

    private Label pleaseEnter = null;
    private Label uidLabel = null;
    private Label pwLabel = null;

    private TextField uidEntry = null;
    private TextField pwEntry = null;

    private Button okButton = null;
    private Button cancelButton = null;

    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
