//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.14 com/java/src/com/ibm/beans/samples/dips/sessauth/demo/SampleSimpleAuthenticator.java, bbSecurityDip, bb97c, bb97c9750e 11/19/97 10:24:47 [12/11/97 17:01:54]
package com.ibm.beans.samples.dips.sessauth.demo;

import com.ibm.beans.samples.dips.sessauth.SAAuthenticator;
import com.ibm.beans.samples.dips.sessauth.SAPrincipal;

/**
    This is a sample authenticator for the Session Authentication Dip.  This
    authenticator can validate a SamplePrincipal.  That principal consists of
    a User ID and Password.

    Valid values for User ID and Password
    are set when this authenticator is customized.
    <p>
    When the dipped bean is instantiated, the values entered by the end user
    will be validated against the values set during customization.

    @see com.ibm.beans.samples.dips.sessauth.demo.SamplePrincipal
    @see com.ibm.beans.samples.dips.sessauth.demo.SamplePrincipalQuery
*/
public class SampleSimpleAuthenticator implements SAAuthenticator
{
    private static final long serialVersionUID = 2000L;

    /**
        Validate the principal.  The Sample Principal consists of a User ID and Password.
        The valid values for the User ID and Password were set when this authenticator was
        customized.

        @param principal The Sample Principal to validate.
        @return <tt>true</tt> if authentication is successful; <tt>false</tt> otherwise.
    */
    public boolean authenticatePrincipal( SAPrincipal principal )
    {
        SamplePrincipal samplePrincipal = (SamplePrincipal) principal;

        if ( ( samplePrincipal.getUserID() == null )
             || ( samplePrincipal.getPassword() == null ) ) {
            return false;
        }
        else if ( samplePrincipal.getUserID().equals( validUID )
             && samplePrincipal.getPassword().equals( validPW ) ) {
            return true;
        }
        else {
            return false;
        }
    }

    /**
        Change the password for this user.  Changing passwords is not supported by this sample.

        @param oldPrincipal The User ID and old Password.
        @param newPrincipal The User ID and new Password.
        @return <tt>true</tt> if the password was successfully changed; <tt>false</tt> otherwise.
    */
    public boolean changeAuthenticationInformation( SAPrincipal oldPrincipal, SAPrincipal newPrincipal )
    {
        return false;
    }

    void setValidUID( String validUID ) {
        this.validUID = validUID;
    }

    String getValidUID() {
        return this.validUID;
    }

    void setValidPW( String validPW ) {
        this.validPW = validPW;
    }
    String getValidPW() {
        return this.validPW;
    }

    //----------------------------------------
    // Private data

    private String validUID = null;
    private String validPW = null;

    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
