//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbContent
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.12 com/java/src/com/ibm/beans/samples/dips/sessauth/demo/SampleSimpleAuthenticatorCustomizer.java, bbSecurityDip, bb97c, bb97c9750e 11/19/97 10:24:49 [12/11/97 17:01:54]
package com.ibm.beans.samples.dips.sessauth.demo;

import java.awt.*;
import java.awt.event.*;

import java.util.ResourceBundle;
import java.util.MissingResourceException;

import java.beans.Customizer;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;

import java.awt.Panel;

/**
    This object allows customization of a sample authenticator.  The sample authenticator is
    customized using an AWT-based
    interaction with a user.  The two properties that are customizable are the valid values
    for the User ID and Password.  The values entered for the User ID and Password
    during customization will be used to validate what the end user enters when they
    instantiate the dippable bean.

    @see com.ibm.beans.samples.dips.sessauth.demo.SampleSimpleAuthenticator
*/
public class SampleSimpleAuthenticatorCustomizer extends Panel implements java.beans.Customizer, ActionListener
{
    /**
        Constructs the Session Authentication Customizer.
    */
    public SampleSimpleAuthenticatorCustomizer () {
        try {
            resourceBundle = (SampleResourceBundle) ResourceBundle.getBundle(
                "com.ibm.beans.samples.dips.sessauth.demo.SampleResourceBundle" );

        }
        catch ( MissingResourceException e ) {
            System.out.println( "SampleSimpleAuthenticatorQuery: Unable to open resource bundle" );
        }

    }

    /**
        Sets the Sample Principal object this customizer is to customize.

        @param objectToCustomize The SampleSimpleAuthenticator instance to customize.
    */
    public void setObject( Object objectToCustomize ) {

        sampleAuthenticator = (SampleSimpleAuthenticator) objectToCustomize;
        tmpUID = null;
        tmpPW = null;

        changingInfo = false;
        tmpPreviousUID = null;
        tmpPreviousPW = null;

        setLayout( new BorderLayout() );

        /*
            Put the NLS text in the labels
        */

        okButton = new Button( retrieveMessage( "SM_OK_BUTTON" ) );
        okButton.addActionListener( this );

        cancelButton = new Button( retrieveMessage( "SM_CANCEL_BUTTON" ) );
        cancelButton.addActionListener( this );

        instruction1 = new Label( retrieveMessage( "SM_CUSTOMIZE_AUTH_1" ) );
        instruction2 = new Label( retrieveMessage( "SM_CUSTOMIZE_AUTH_2" ) );
        instruction3 = new Label( retrieveMessage( "SM_CUSTOMIZE_AUTH_3" ) );

        uidPreviousLabel = new Label( retrieveMessage( "SM_OLD_UID_LABEL" ) );
        pwPreviousLabel = new Label( retrieveMessage( "SM_OLD_PW_LABEL" ) );

        uidLabel = new Label( retrieveMessage( "SM_UID_LABEL" ) );
        pwLabel = new Label( retrieveMessage( "SM_PW_LABEL" ) );

        instructionPanel.setLayout( new GridLayout( 3 /* 3 lines of instruction */,
                                                    1 /* 1 column per line of instr */ ) );
        instructionPanel.add( instruction1 );
        instructionPanel.add( instruction2 );
        instructionPanel.add( instruction3 );

        add( "North", instructionPanel );

        uidEntry = new TextField();
        pwEntry = new TextField();
        pwEntry.setEchoChar( '*' );

        uidPreviousEntry = new TextField();
        pwPreviousEntry = new TextField();
        pwPreviousEntry.setEchoChar( '*' );

        if ( sampleAuthenticator.getValidUID() != null
             || sampleAuthenticator.getValidPW() != null ) {
            changingInfo = true;
            queryPanel.setLayout( new GridLayout(  4 /* rows: Old UID, Old PW, UID, PW */,
                                                   2 /* cols: Label and entry field */ ) );

            queryPanel.add( uidPreviousLabel );
            queryPanel.add( uidPreviousEntry );

            queryPanel.add( pwPreviousLabel );
            queryPanel.add( pwPreviousEntry );
        }
        else {
            changingInfo = false;
            queryPanel.setLayout( new GridLayout(  2 /* rows: UID, PW */,
                                                   2 /* cols: Label and entry field */ ) );
        }

        queryPanel.add( uidLabel );
        queryPanel.add( uidEntry );

        queryPanel.add( pwLabel );
        queryPanel.add( pwEntry );

        add( "Center", queryPanel );

        buttonPanel.setLayout( new FlowLayout( FlowLayout.CENTER ) );

        buttonPanel.add( okButton );
        buttonPanel.add( cancelButton );

        add( "South", buttonPanel );
    }

    /**
        Register a listener for the PropertyChange event.
        This customizer fires a PropertyChange
        event whenever it changes the Sample Simple Authenticator such that
        the displayed properties should be refreshed.

        @param listener Object to be notified when this customizer changes a property
    */
    public void addPropertyChangeListener( PropertyChangeListener listener ) {
	    propertyChangeSupport.addPropertyChangeListener( listener );
    }

    /**
        Remove a listener from the PropertyChange event for the Sample Simple Authenticator.

        @param listener Object to be removed from the list of listeners.
    */
    public void removePropertyChangeListener( PropertyChangeListener listener ) {
	    propertyChangeSupport.removePropertyChangeListener( listener );
    }
    /**
        Handle the <b>OK</b> and <b>Cancel</b> button actions.
    */
    public void actionPerformed( ActionEvent event ) {

        String actionCommand = event.getActionCommand();

        if ( actionCommand.equals( retrieveMessage( "SM_OK_BUTTON" ) ) ) {
            handleOKButton();
        }
        else if ( actionCommand.equals( retrieveMessage( "SM_CANCEL_BUTTON" ) ) ) {
            handleCancelButton();
        }
        else {
            // Shouldn't happen...
        }
    }

    //----------------------------------------
    // Private methods and data

    private void handleOKButton() {

        /*
            If the user entered no text, then set the entry fields to null
        */
        tmpUID = uidEntry.getText();
        if ( tmpUID.length() == 0 ) {
            tmpUID = null;
        }

        tmpPW = pwEntry.getText();
        if ( tmpPW.length() == 0 ) {
            tmpPW = null;
        }

        if ( changingInfo ) {

            /*
                There is an existing UID/PW.  Make sure the user entered the
                correct info before allowing them to change it.
            */
            tmpPreviousUID = uidPreviousEntry.getText();
            if ( tmpPreviousUID.length() == 0 ) {
                tmpPreviousUID = null;
            }

            tmpPreviousPW = pwPreviousEntry.getText();
            if ( tmpPreviousPW.length() == 0 ) {
                tmpPreviousPW = null;
            }

            SamplePrincipal principal = new SamplePrincipal();
            principal.setUserID( tmpPreviousUID );
            principal.setPassword( tmpPreviousPW );

            if ( sampleAuthenticator.authenticatePrincipal( principal ) ) {
                sampleAuthenticator.setValidUID( tmpUID );
                sampleAuthenticator.setValidPW( tmpPW );
            }
            else {
                System.out.println( retrieveMessage( "SM_INVALID_PW" ) );
            }
        }
        else {
            sampleAuthenticator.setValidUID( tmpUID );
            sampleAuthenticator.setValidPW( tmpPW );
        }

        tmpUID = null;
        tmpPW = null;

        tmpPreviousUID = null;
        tmpPreviousPW = null;
    }

    private void handleCancelButton() {
        // just reset the values in the entry boxes
        tmpUID = null;
        uidEntry.setText( tmpUID );

        tmpPW = null;
        pwEntry.setText( tmpPW );
    }

    private String retrieveMessage( String messageKey ) {
        return (String) resourceBundle.handleGetObject( messageKey );
    }

    private SampleSimpleAuthenticator sampleAuthenticator = null;
    private SampleResourceBundle resourceBundle;

    private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);

    private String tmpUID = null;
    private String tmpPW = null;

    private boolean changingInfo = false;
    private String tmpPreviousUID = null;
    private String tmpPreviousPW = null;

    //----------------------------------------
    // Customizer panel elements

    // We use our own reference to the resource bundle rather than the
    // one in SAImpl so we can initialize the labels more effieiently

    private Panel instructionPanel = new Panel();
    private Panel queryPanel = new Panel();
    private Panel buttonPanel = new Panel();

    private Button okButton = null;
    private Button cancelButton = null;

    private Label instruction1 = null;
    private Label instruction2 = null;
    private Label instruction3 = null;

    private Label uidLabel = null;
    private Label pwLabel = null;

    private TextField uidEntry = null;
    private TextField pwEntry = null;

    private Label uidPreviousLabel = null;
    private Label pwPreviousLabel = null;

    private TextField uidPreviousEntry = null;
    private TextField pwPreviousEntry = null;

    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
}
