/*
    SplashScreenDip bean

    Package: com.ibm.beans.samples.dips.splash
    Bean   : SplashScreenDip

    Author : John W. Alcorn
    Date   : November 17, 1997

    Copyright (c) IBM Corp, 1997
        - all rights reserved

    //====START_GENERATED_PROLOG======================================
    //
    //
    //   COMPONENT_NAME: bbDipWizard
    //
    //   CLASSES: none
    //
    //   ORIGINS: 27
    //
    //
    //   (C) COPYRIGHT International Business Machines Corp. 1997
    //   All Rights Reserved
    //   Licensed Materials - Property of IBM
    //   US Government Users Restricted Rights - Use, duplication or
    //   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
    //
    //   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
    //   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    //   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
    //   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
    //   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    //   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
    //   OR PERFORMANCE OF THIS SOFTWARE.
    //
    //====END_GENERATED_PROLOG========================================
    //
    // @(#) 1.4 com/java/src/com/ibm/beans/samples/dips/splash/SplashScreenDip.java, bbDipWizard, bb97c, bb97c9750e 11/21/97 01:22:54 [12/11/97 17:03:32]
*/

// Code generated by IBM BeanExtender Dip Creation Wizard
package com.ibm.beans.samples.dips.splash;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.text.*;
import java.util.*;
import com.ibm.beans.dip.*;
import com.ibm.beans.samples.media.ImageViewer; //added after code generation


/**
 * This dip causes a modal dialog containing text and/or an image to be
 * displayed just before the bean to which this dip is applied is displayed.
 *
 * @author John W. Alcorn
 */
public class SplashScreenDip extends SimpleDip implements Serializable, DipMethodCallListener, ActionListener
{   /**
    * Default constructor, invoked when the Dipping Framework calls
    * Beans.instantiate() to create an instance of this dip, in order to
    * apply to a dippable bean.  After the constructor runs, the dip's
    * createImplementation() method will be invoked.
    *
    * @see #createImplementation
    */
   public SplashScreenDip ()
   {
      super();

      //Place initialization code here
      noticeText = ""; //added after code generation
      imageName = ""; //added after code generation
   }


   private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException
   {
      in.defaultReadObject();

      //Place initialization of transient data here
   }


   /**
    * Returns the dip type name as a String.  The typeName() method of
    * SimpleDip is abstract, so typeName() must be implemented here.
    *
    * @return A descriptive string describing the type of dip.
    * @see com.ibm.beans.dip.DipInfo#typeName()
    */
   public String typeName()
   {
      return "Splash Screen Dip";
   }


   /**
    * Returns the priority of this dip in relation to all other dips.
    * This priority is used to determine which dips are acted on first.
    * The default priority is 500 - a higher number means the dip gets
    * notifications before other dips.
    *
    * @return The desired priority of this dip.
    * @see com.ibm.beans.dip.DipInfo#priority()
    */
    public int priority()
    {
       return 100;
    }


   /**
    * Indicates whether this dip can be removed from its dipped bean.
    *
    * @return boolean indicating if dip can be removed.
    * @see com.ibm.beans.dip.DipInfo#isRemovable()
    */
   public boolean isRemovable()
   {
      //Some dips may want conditional code here (such as only allowing the
      //dip to be removed if an administrator password has been entered).

      return false;
   }


   /**
    * Indicates whether given method should be "wrapped" during the
    * morphing process.  This method will be called once for each
    * method as the bean is morphed.  Returning true causes the
    * method to be overriden in the subclass, and to have the
    * instrumentation generated in the overriden method allowing
    * it to be hooked by dips.  The more methods that are wrapped,
    * the larger the subclass for the dippable bean will be.
    *
    * @return boolean indicating if method should be wrapped.
    * @see com.ibm.beans.dip.Dip#includeInMorphedClass()
    */
   public boolean includeInMorphedClass(String methodName)
   {
      //Dips that only hook certain methods can choose to only have
      //those methods get wrapped during the morphing process.

      boolean includeThisMethod = false;

      if (methodName.indexOf("addNotify()")!=-1) includeThisMethod = true;

      return includeThisMethod;
   }


   /**
    * Indicates whether this dip has a separate implementation class for its
    * policy, and if this dip can be applied to the specified dippable bean.
    *
    * @param obj The bean being dipped. This is the only reference to this
    *        dip's dippable bean that will ever be provided to the dip.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return null, indicating this dip implements its own policy.
    * @see com.ibm.beans.dip.Dip#createImplementation()
    */
   public Object createImplementation(Object obj) throws DipRejectAdditionException
   {
      if (obj instanceof java.awt.Component) {
         myDippableBean = (java.awt.Component) obj;

         //Place initialization code here
      } else {
         throw new DipRejectAdditionException("Dippable bean must extend java.awt.Component");
      } /* endif */

      return null;
   }


   /**
    * Wires the dip to receive notification immediately after the specified
    * methods of the dippable bean are called.
    *
    * @param impl This value should be <tt>null</tt>.  There is no separate implementation.
    * @param methods An array of method signatures from the dippable bean.
    * @exception DipRejectAdditionException This exception is thrown if the
    *            dip rejects being added to the bean.
    * @return Array of DipMethodCallListeners with this dip set to
    *         listen at the appropriate method indices.
    * @see #handleMethodCall
    * @see com.ibm.beans.dip.Dip#createMethodCallListener()
    */
   public DipMethodCallListener[] createMethodCallListener(Object impl, String[] methods) throws DipRejectAdditionException
   {
      //Let SimpleDip create and initialize the listener array
      //Note that the methodCallListeners array comes from SimpleDip
      super.createMethodCallListener(impl, methods);

      int count=0;
      for (int i = 0; i < methodCallListeners.length; i++) {
         if (methods[i].indexOf("addNotify()")!=-1) {
            methodCallListeners[i] = this;
            count++;
         } /* endif */
      } /* endfor */

      if (count!=1)
         throw new DipRejectAdditionException("Some methods required by this dip were not wrapped.");

      return methodCallListeners;
   }


   /**
    * Communicates to the dipping framework whether this dip requires
    * the arguments for intercepted methods of the dippable bean.  Returning
    * <tt>false</tt> avoids the performance impact of parameter marshaling.
    *
    * @return boolean indicating whether this dip requires the arguments
    *         from intercepted methods.
    * @see com.ibm.beans.dip.DipMethodCallListener#needsArguments
    */
   public boolean needsArguments() {
      //Note that, although most general purpose dips will return false
      //here, in order to avoid the performance impact of parameter
      //marshaling, some dips may need to return true, if their behavior
      //depends upon the values contained in the arguments to the
      //intercepted methods.  Custom dips, which are only applicable
      //to specific classes (such as business logic dips), in particular
      //may need to inspect the arguments and react accordingly.

      return false;
   }


   /**
    * Responds to a bound method of the dippable bean being invoked.
    *
    * @param evt A MethodCallEvent object describing the event source
    *        and the property that changed.
    * @see com.ibm.beans.dip.MethodCallListener#handleMethodCall
    */
   public void handleMethodCall(MethodCallEvent evt)
   {
      //Place code here for responding to bound method calls

     if (evt.getMethodId().indexOf("addNotify()")!=-1) {
        //Place code here for responding to "addNotify()"

        //Begin code added after code generation by Dip Creation Wizard
        if (noticeText.equals("") && imageName.equals("")) return;

        parentFrame = null;
        Component parent = myDippableBean;
        while ((parentFrame==null) && (parent!=null)) {
           if (parent instanceof Frame) {
              parentFrame = (Frame) parent;
           } else {
              parent = parent.getParent();
           } /* endif */
        } /* endwhile */
        if (parentFrame==null) parentFrame = new Frame("Splash Screen");

//      splashWindow = new Window(parentFrame); //this causes no border - looks embedded in Layout view

//      splashWindow = new Dialog(parentFrame, "Splash Screen", true); //being modal causes deadlock
        splashWindow = new Dialog(parentFrame, "Splash Screen");

        if (!imageName.equals("")) {
           ImageViewer image = new ImageViewer(imageName);
           splashWindow.add("North", image);
        } /* endif */

        if (!noticeText.equals("")) {
           TextArea text = new TextArea(noticeText);
           text.setEditable(false);
           splashWindow.add("Center", text);
        } /* endif */

        Button button = new Button("OK");
        button.addActionListener(this);
        splashWindow.add("South", button);

        splashWindow.pack();
        Dimension splashSize = splashWindow.getSize();
        Dimension screenSize = splashWindow.getToolkit().getScreenSize();

        if (splashSize.width>screenSize.width) {
           splashWindow.setSize(screenSize.width, splashSize.height);
           splashSize = splashWindow.getSize();
        } /* endif */

        if (splashSize.height>screenSize.height-30) { //allow for Start Bar/WarpCenter
           splashWindow.setSize(splashSize.width, screenSize.height-30);
           splashSize = splashWindow.getSize();
        } /* endif */

        splashWindow.setLocation((screenSize.width-splashSize.width)/2,
                                 (screenSize.height-30-splashSize.height)/2);

        parentFrame.setEnabled(false); //workaround for modality deadlock
        splashWindow.setVisible(true);
        //End code added after code generation by Dip Creation Wizard
     } /* endif */
   }


   /*
    * Property: NoticeText
    * Access: read write
    *
    * Text on splash dialog
    */

   /**
    * getNoticeText
    * @return Value of NoticeText property
    * @see setNoticeText
    */
   public String getNoticeText ()
   {
      return (noticeText);
   }

   /**
    * setNoticeText
    * @param value New value of NoticeText property
    * @see getNoticeText
    */
   public synchronized void setNoticeText (String value)
   {
      String old = noticeText;
      noticeText = value;
   }


   /*
    * Property: ImageName
    * Access: read write
    *
    * Filename of image on splash dialog
    */

   /**
    * getImageName
    * @return Value of ImageName property
    * @see setImageName
    */
   public String getImageName ()
   {
      return (imageName);
   }

   /**
    * setImageName
    * @param value New value of ImageName property
    * @see getImageName
    */
   public synchronized void setImageName (String value)
   {
      String old = imageName;
      imageName = value;
   }


   /**
    * Action event received
    */
   public void actionPerformed (ActionEvent event)
   {
      splashWindow.setVisible(false);
      splashWindow.dispose();
      parentFrame.setEnabled(true); //workaround for modality deadlock
      parentFrame = null;
   }


  // Copyright Statement
  private final static String kCopyright = "(c) Copyright IBM Corp 1997";

  // Serializable Stream Unique ID
  private final static long serialVersionUID = 2000L;

  // Reference to the dippable bean to which this dip is applied
  private java.awt.Component myDippableBean;

  // Legal or other text displayed on the splash screen dialog.
  private String noticeText;

  // Filename or resource name of image displayed on the splash screen dialog.
  private String imageName;

  // TextBundle containing translatable strings
  private SplashScreenDipTextBundle bundle;

  private Window splashWindow; //added after code generation
  private Frame parentFrame; //added after code generation
}
