/*
    SplashScreenDip bean

    Package: com.ibm.beans.samples.dips.splash
    Bean   : SplashScreenDip

    Author : John W. Alcorn
    Date   : November 14, 1997

    Copyright (c) IBM Corp, 1997
        - all rights reserved

    //====START_GENERATED_PROLOG======================================
    //
    //
    //   COMPONENT_NAME: bbDipWizard
    //
    //   CLASSES: none
    //
    //   ORIGINS: 27
    //
    //
    //   (C) COPYRIGHT International Business Machines Corp. 1997
    //   All Rights Reserved
    //   Licensed Materials - Property of IBM
    //   US Government Users Restricted Rights - Use, duplication or
    //   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
    //
    //   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
    //   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    //   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
    //   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
    //   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    //   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
    //   OR PERFORMANCE OF THIS SOFTWARE.
    //
    //====END_GENERATED_PROLOG========================================
    //
    // @(#) 1.3 com/java/src/com/ibm/beans/samples/dips/splash/SplashScreenDipCustomizer.java, bbDipWizard, bb97c, bb97c9750e 11/21/97 00:40:44 [12/11/97 17:03:33]
*/

package com.ibm.beans.samples.dips.splash;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.ResourceBundle;

/**
 * Customizer for the SplashScreenDip bean.
 *
 * @author John W. Alcorn
 */

public class SplashScreenDipCustomizer extends Panel implements Customizer, TextListener
 {
    protected SplashScreenDipBeanInfoTextBundle bundle = (SplashScreenDipBeanInfoTextBundle) ResourceBundle.getBundle ("com.ibm.beans.samples.dips.splash.SplashScreenDipBeanInfoTextBundle");

    protected SplashScreenDip target;
    protected TextArea attr0; //changed from TextField to TextArea
    protected TextField attr1;

    protected PropertyChangeSupport pcs = new PropertyChangeSupport (this);

    //Following line added after code generation
    private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";


    /**
     * Default constructor
     * The object to be customized is set through the setObject method
     */
    public SplashScreenDipCustomizer ()
     {
        setLayout (new GridBagLayout ());

        attr0 = new TextArea (); //changed from text field to text area
        attr1 = new TextField ();

        Insets insets = new Insets (2, 4, 2, 2);

        addToGrid (this, new Label (" "), 0, 0, 1, 1, 0.0, 0.0, null);
        addToGrid (this, new Label (bundle.getString ("BI:Notice Text")), 1, 0 + 1, 1, 1, 0.0, 0.0, insets);
        addToGrid (this, new Label (bundle.getString ("BI:Image Name")), 1, 1 + 1, 1, 1, 0.0, 0.0, insets);
        addToGrid (this, attr0, 2, 0 + 1, 1, 1, 1.0, 0.0, insets);
        addToGrid (this, attr1, 2, 1 + 1, 1, 1, 1.0, 0.0, insets);
        addToGrid (this, new Label (" "), 3, 3, 1, 1, 0.0, 1.0, null);
     }

    /**
     * When an object is to be customized, a reference is passed through this method.
     * Initialize the values of the fields and add listeners as required to perform
     * the processing of the customizer.
     */
    public void setObject (Object object)
     {
        target = (SplashScreenDip) object;

        // set initial values
        attr0.setText(target.getNoticeText()); //added after code generation
        attr1.setText(target.getImageName()); //added after code generation

        // add listeners
        attr0.addTextListener(this); //added after code generation
        attr1.addTextListener(this); //added after code generation
     }

    /**
     * Return the size of the Customizer plus a small height buffer
     */
    public Dimension getPreferredSize ()
     {
        Dimension d = super.getPreferredSize ();
//      d.width += 100; //added after code generation
        d.height += 20;
        return (d);
     }

    /**
     * Event interface implementation for text field changes
     */
    public void textValueChanged (TextEvent event)
     {
        Object source = event.getSource();                      //added after code generation
        if (source==attr0) target.setNoticeText(attr0.getText()); //added after code generation
        if (source==attr1) target.setImageName(attr1.getText());  //added after code generation

        // fire dummy property change to update property sheet
        pcs.firePropertyChange ("", null, null);
     }

    /** Register a listener for events generated by notebook
     * @see #removePropertyChangeListener
     * @param l the PropertyChangeListener
     */
    public void addPropertyChangeListener (PropertyChangeListener l)
     {
        pcs.addPropertyChangeListener (l);
     }

    /** Unregister a listener from notebook
     * @see #addPropertyChangeListener
     * @param l the PropertyChangeListener
     */
    public void removePropertyChangeListener (PropertyChangeListener l)
     {
        pcs.removePropertyChangeListener (l);
     }

    // GridBagLayout helper method
    public void addToGrid (Container container, Component component, int x, int y, int w, int h, double wx, double wy, Insets insets)
     {
        GridBagConstraints c = new GridBagConstraints ();
        c.fill = GridBagConstraints.BOTH;
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = w;
        c.gridheight = h;
        c.weightx = wx;
        c.weighty = wy;
        c.anchor = GridBagConstraints.WEST;
        if (insets != null)
            c.insets = insets;

        container.add (component);
        ((GridBagLayout) container.getLayout ()).setConstraints (component, c);
     }
 }
