//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbTraceDip
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/samples/dips/trace/TraceDipCustomizer.java, bbTraceDip, bb97c, bb97c9750e 10/29/97 08:22:37 [12/11/97 17:02:02]

package com.ibm.beans.samples.dips.trace;

import java.awt.Checkbox;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import java.beans.Customizer;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.ResourceBundle;


/**
 * This class defines a TraceDipCustomizer instance that is the customizer
 * for a TraceDip instance.  The customizer is used to modify property values
 * of the TraceDip instance.
 *
 * @see com.ibm.beans.samples.dips.trace.TraceDip
 */
public class TraceDipCustomizer extends Panel implements Customizer, ItemListener, TextListener {

    /**
     *  Constructs a TraceDipCustomizer instance.
     */
    public TraceDipCustomizer() {
        super();
    }

    /**
     * Sets the object instance with which this customizer interacts.
     * Controls are added to the panel for property customization
     * on the TraceDip instance.
     * @param obj A Trace Dip instance to be customized.
     */
    public void setObject(Object obj) {
        target = (TraceDip) obj;
        panel1 = new Panel();
        panel2 = new Panel();
        panel1.setLayout(new FlowLayout(FlowLayout.LEFT));
        panel2.setLayout(new FlowLayout(FlowLayout.LEFT));

        getMessages();
        if(target.getTraceEventsFlag() == true)
          traceEventsFlag = new Checkbox((String)messages.handleGetObject("TraceEvents"),true);
        else
          traceEventsFlag = new Checkbox((String)messages.handleGetObject("TraceEvents"),false);
        panel1.add(traceEventsFlag);

        if(target.getTraceMethodsFlag() == true)
          traceMethodsFlag = new Checkbox((String)messages.handleGetObject("TraceMethods"),true);
        else
          traceMethodsFlag = new Checkbox((String)messages.handleGetObject("TraceMethods"),false);
        panel1.add(traceMethodsFlag);

        if(target.getTracePropertiesFlag() == true)
           tracePropertiesFlag = new Checkbox((String)messages.handleGetObject("TraceProperties"),true);
        else
           tracePropertiesFlag = new Checkbox((String)messages.handleGetObject("TraceProperties"),false);
        panel1.add(tracePropertiesFlag);

        traceEventsFlag.addItemListener(this);
        traceMethodsFlag.addItemListener(this);
        tracePropertiesFlag.addItemListener(this);

        Label t1 = new Label("MsgDispServerHostName", Label.LEFT);
        panel2.add(t1);


        if(target.getMsgDispHostName() != null)
          msgDispHostName = new TextField(target.getMsgDispHostName(),20);
        else
          msgDispHostName = new TextField(20);
        panel2.add(msgDispHostName);

        msgDispHostName.addTextListener(this);

        add("North",panel1);
        add("Center",panel2);
    }

    private void getMessages() {
      if (messages == null) {
        messages = (Messages)ResourceBundle.getBundle("com.ibm.beans.samples.dips.trace.Messages");
      }
    }

    /**
     * Returns the preferred size for this customizer panel.
     * @return The dimensions of the customizer.
     */
    public Dimension getPreferredSize() {
        return new Dimension(400, 100);
    }

    /**
     * Responds to checkboxes being checked or unchecked.
     * @param evt The ItemEvent stating which checkbox was checked/unchecked.
     */
    public void itemStateChanged(ItemEvent evt) {
        Object evtSource = evt.getSource();
        if (evtSource == traceEventsFlag) {
            target.setTraceEventsFlag(traceEventsFlag.getState());
            support.firePropertyChange("", null, null);
        } else {
            if (evtSource == traceMethodsFlag ) {
                target.setTraceMethodsFlag(traceMethodsFlag.getState());
                support.firePropertyChange("", null, null);
            } else {
                if (evtSource == tracePropertiesFlag ) {
                    target.setTracePropertiesFlag(tracePropertiesFlag.getState());
                    support.firePropertyChange("", null, null);
                } /* endif */
            } /* endif */
        } /* endif */
    }

    /**
     * Responds to TextField content changes.
     * @param evt The TextEvent stating which TextField's contents changed.
     */
    public void textValueChanged(TextEvent evt) {
        if (evt.getSource() == msgDispHostName) {
            target.setMsgDispHostName(msgDispHostName.getText());
            support.firePropertyChange("", null, null);
        } /* endif */
    }

    /**
     * Adds a listener to the property-change notification list.
     * @param l The listener to add.
     */
    public void addPropertyChangeListener(PropertyChangeListener l) {
        support.addPropertyChangeListener(l);
    }

    /**
     * Removes a listener from the property-change notification list.
     * @param l The listener to remove.
     */
    public void removePropertyChangeListener(PropertyChangeListener l) {
        support.removePropertyChangeListener(l);
    }

    private PropertyChangeSupport support = new PropertyChangeSupport(this);

    //----------------------------------------------------------------------

    private TraceDip target;
    private TextField msgDispHostName;
    private Checkbox traceEventsFlag;
    private Checkbox traceMethodsFlag;
    private Checkbox tracePropertiesFlag;
    private Panel panel1;
    private Panel panel2;
    private transient Messages messages;

    private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

