//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbMediaDemo
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/samples/media/ImageViewerBeanInfo.java, bbMediaDemo, bb97c, bb97c9750e 10/29/97 12:12:23 [12/11/97 17:02:46]
package com.ibm.beans.samples.media;

import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.SimpleBeanInfo;

/**
 * <p>
 * The ImageViewerBeanInfo class provides access to the
 * icons and the customizer for the ImageViewer class.
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 * @see com.ibm.beans.samples.media.ImageViewer
 */
public class ImageViewerBeanInfo extends SimpleBeanInfo {

  /**
   * Gets a BeanDescriptor with the ImageViewerCustomizer
   * as the customizer class.
   *
   * @return A BeanDescriptor with an appropriate customizer defined.
   */
  public BeanDescriptor getBeanDescriptor() {
     return new BeanDescriptor(ImageViewer.class, ImageViewerCustomizer.class);
  }


  /**
   * Provides icon representations for the Image Viewer.
   * This method is for use by tools such as the BeanBag.
   *
   * @param iconKind The desired format for the icon image.
   * @return The image of the requested format.
   */
  public java.awt.Image getIcon(int iconKind) {
     java.awt.Image icon = null;

     if (iconKind == BeanInfo.ICON_COLOR_16x16)
        icon = loadImage("ImageViewerIconColor16.gif");

     if (iconKind == BeanInfo.ICON_COLOR_32x32)
        icon = loadImage("ImageViewerIconColor32.gif");

     return icon;
  }


  private final static String kBeanExtenderIBMCopyright = "(c) Copyright IBM Corporation 1997";
}

