//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/netdeploy/client/SampleContainer.java, bbNetDeploy, bb97c, bb97c9750e 12/10/97 12:52:11 [12/11/97 16:58:21]
package com.ibm.beans.samples.netdeploy.client;
import java.awt.*;
import java.applet.*;
import com.ibm.beans.netdeploy.client.*;


/**
 * The SampleContainer class is a very simple container used to
 * show usage of the Network Deployment class loader to dynamically
 * download class files used for class loading.  The driver for this
 * container, SampleDriver, loads this class with the Network
 * Deployment class loader, which is then used to load applets from
 * this container.  
 *
 * @see COM.ibm.beans.samples.client.SampleDriver
 * @see COM.ibm.beans.client.NetworkClassLoader
 */
public class SampleContainer 
    extends Frame 
{
    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
    TextField   inputBox;
    Button      loadButton;
    ClassLoader loader;
    Panel       embedBox;

    /**
     * SampleContainer constructor.
     */
    public SampleContainer () {
        super ("SampleContainer");
        loader = null;

        System.out.println ("SampleContainer ()");

        setLayout (null);
        setBounds (100, 100, 300, 400);

        loadButton = new Button ("Load");
        loadButton.setBounds (20, 50, 50, 30);
        add (loadButton);

        inputBox = new TextField ();
        inputBox.setBounds (80, 50, 190, 30);
        inputBox.setText ("com.ibm.beans.samples.netdeploy.deployToWarehouse.Clock");
        add (inputBox);

        embedBox = new Panel (new BorderLayout ());
        embedBox.setBounds (20, 100, 260, 260);
        embedBox.setBackground (Color.white);
        add (embedBox);

        show ();
    }

    /**
     * Called by SampleDriver to set the class loader.
     */
    public void run (ClassLoader newLoader) {
        System.out.println ("running...");
        loader = newLoader;
    }

    /**
     * Event handling code...
     */
    public boolean handleEvent (Event event) {

        if (event.id == Event.WINDOW_DESTROY)
            System.exit (0);

        if (event.id == Event.ACTION_EVENT) {
            /*
             *  Try and load the user specified class...
             */
            if (event.target == loadButton) {
                System.out.println ("pressed load...");
                try {
                    String className = inputBox.getText ();
                    System.out.println ("text = "+ className);
                    if (className != null && loader != null) {
                        System.out.println ("Creating: "+className);
                        Object object = 
                            loader.loadClass (className).newInstance();
                        ((Applet) object).init ();
                        ((Applet) object).start ();
                        embedBox.removeAll ();
                        embedBox.add ((Applet) object, "Center");
                        repaint ();
                    }
                } catch (Exception e) {
                    System.out.println("Caught exception : "+e);
                }
            }
        }
        return super.handleEvent (event);
    }
}
