//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/netdeploy/client/SampleDriver.java, bbNetDeploy, bb97c, bb97c9750e 12/10/97 12:51:32 [12/11/97 16:58:22]
package com.ibm.beans.samples.netdeploy.client;
import com.ibm.beans.netdeploy.client.*;

/**
 * SampleDriver is an application used to instantiate a sample
 * container with the Network Deployment class loader.  The sample
 * container thus "inherits" the Network Deployment class loader as
 * its class loader, which dynamically downloads and loads the
 * specified class to be imedded in the sample container.
 *
 * @see com.ibm.beans.samples.netdeploy.client.SampleContainer
 * @see com.ibm.beans.netdeploy.client.NetworkClassLoader
 */
public class SampleDriver 
{
    private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";

    /**
     * This method is the main program for SampleDriver.  It creates an
     * instance of COM.ibm.beans.netdeploy.client.NetworkClassLoader
     * loads the SampleContainer class with it.  The SampleContainer
     * instance thus "inherits" the Network Deployment class loader as
     * its class loader, which dynamically downloads and loads the
     * specified class to be imedded in the sample container.
     */
    public static void main (String args[]) {
        /*
         *  Instantiate a SampleContainer via the Network Deployment class loader...
         */
        try {
            ClassLoader loader = new NetworkClassLoader ();

            Object object = (loader.loadClass("com.ibm.beans.samples.netdeploy.client.SampleContainer")).newInstance();

            if (object instanceof SampleContainer) {
                System.out.println ("Created an instance of SampleContainer!!!!");
            }

            ((SampleContainer) object).run (loader);

        } catch (Throwable e) {
            System.out.println("Caught exception: " + e);
        }
    }
}
