//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
/* This program has been modified to be run as a Java 1.1 application. */
/* Parameters have been removed and replaced with hard-coded values,   */
/* and package name has been changed.                                  */

/*
 * @(#)Chart.java	1.6f 95/03/27 Sami Shaio
 *
 * Copyright (c) 1994-1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted. 
 * Please refer to the file http://java.sun.com/copy_trademarks.html
 * for further important copyright and trademark information and to
 * http://java.sun.com/licensing.html for further important licensing
 * information for the Java (tm) Technology.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */
package com.ibm.beans.samples.netdeploy.deployToWarehouse;

import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.io.*;
import java.lang.*;
import java.net.URL;

/**
 *  This class is a simple application to demonstrate the On Demand file group
 *  download control option on a Network Deployment client.  This application,
 *  residing on a Network Deployment server, can be launched from a Network
 *  Deployment client using the Network Deployment sample application
 *  COM.ibm.beans.netdeploy.samples.client.Launcher.
 *
 *  @see com.ibm.beans.samples.netdeploy.client.Launcher
 */ 
public class BarChart extends Frame {
	private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
	static final int	VERTICAL = 0;
	static final int 	HORIZONTAL = 1;

	static final int	SOLID = 0;
	static final int	STRIPED = 1;

	int            orientation;
	String         title;
	Font           titleFont;
	FontMetrics    titleFontMetrics;
	int            titleHeight = 15;
	int            columns = 4;

	int            values[] = {10, 20, 5, 30};
	int            max = 30;
	Color          colors[] = {Color.blue, Color.green, Color.magenta, Color.yellow};
	String         labels[] = {"Q1", "Q2", "Q3", "Q4"};
	int            styles[] = {STRIPED, SOLID, STRIPED, SOLID};
	int            scale = 10;
	int            maxLabelWidth = 0;
	int            barWidth;
	int            barSpacing = 10;

   /**
    *  BarChart constructor.
    */
	public BarChart()
	{
		super("Bar Chart");
	}

   /**
    *  This method initializes this BarChart object.
    */
	public synchronized void init() {
		enableEvents(WindowEvent.WINDOW_CLOSING);	
		String rs;
	
		titleFont = new java.awt.Font("Courier", Font.BOLD, 12);
		titleFontMetrics = getFontMetrics(titleFont);

		title = "Performance";

		columns = 4;

		scale = 10;

		orientation = HORIZONTAL; // orientation = VERTICAL; 

		for (int i=0; i < columns; i++) {
			// parse the label for this column
			maxLabelWidth = Math.max(titleFontMetrics.stringWidth((String)(labels[i])),
			                maxLabelWidth);

		}
		switch (orientation) {
	  		case VERTICAL:
	  		default:
				barWidth = maxLabelWidth;
				setSize(Math.max(columns * (barWidth + barSpacing),
				        titleFontMetrics.stringWidth(title)) +
				        titleFont.getSize() + 5,
				        (max * scale) + (2 * titleFont.getSize()) + 5 + titleFont.getSize());
				break;
		case HORIZONTAL:
			barWidth = titleFont.getSize();
			setSize(Math.max((max * scale) + titleFontMetrics.stringWidth("" + max),
			        titleFontMetrics.stringWidth(title)) + maxLabelWidth + 5,
		           (columns * (barWidth + barSpacing)) + titleFont.getSize() + 10);
			break;
		}

		setSize(350, 150);
	}

   /**
    *  This method paints the bar chart.
    */
	public synchronized void paint(Graphics g) {
		int i, j;
		int cx, cy;
		char l[] = new char[1];
		int vertOffset = 20;


		// draw the title centered at the bottom of the bar graph
		g.setColor(Color.black);
		g.setFont(titleFont);
		i = titleFontMetrics.stringWidth(title);
		g.drawString(title, Math.max((getSize().width - i)/2, 0),
				 getSize().height - titleFontMetrics.getDescent() - 5); 
		for (i=0; i < columns; i++) {
			switch (orientation) {
				case VERTICAL:
				default:
					// set the next X coordinate to account for the label
					// being wider than the bar getSize().width.
					cx = (Math.max((barWidth + barSpacing),maxLabelWidth) * i) +
					barSpacing;
	
					// center the bar chart
					cx += Math.max((getSize().width - (columns *
					      (barWidth + (2 * barSpacing))))/2,0);
			
					// set the next Y coordinate to account for the getSize().height
					// of the bar as well as the title and labels painted
					// at the bottom of the chart.
					cy = getSize().height - (values[i] * scale) - 1 - (2 * titleFont.getSize());
	
					// draw the label
					g.setColor(Color.black);		
					g.drawString((String)labels[i], cx,
					   getSize().height - titleFont.getSize() - titleFontMetrics.getDescent());
	
					// draw the shadow bar
					if (colors[i] == Color.black) {
						g.setColor(Color.gray);
					}
					g.fillRect(cx + 5, cy - 3, barWidth,  (values[i] * scale));
					// draw the bar with the specified color
					g.setColor((Color)(colors[i]));
					switch (styles[i]) {
						case SOLID:
						default:
							g.fillRect(cx, cy, barWidth, (values[i] * scale));
							break;
						case STRIPED:
						{
							int steps = (values[i] * scale) / 2;
							int ys;
	
							for (j=0; j < steps; j++) {
								ys = cy + (2 * j);
								g.drawLine(cx, ys, cx + barWidth, ys);
							}
						}
						break;
					}
					g.drawString("" + values[i],
					             cx,
					             cy - titleFontMetrics.getDescent());
					break;
				case HORIZONTAL:
					// set the Y coordinate
					cy = ((barWidth + barSpacing) * i) + barSpacing + vertOffset;
				       
					// set the X coordinate to be the getSize().width of the widest
					// label 
					cx = maxLabelWidth + 1;
	
					cx += Math.max((getSize().width - (maxLabelWidth + 1 +
					      titleFontMetrics.stringWidth("" +
					      max) + (max * scale))) / 2, 0);
					// draw the labels and the shadow
					g.setColor(Color.black);		
					g.drawString((String)labels[i], cx - maxLabelWidth - 1,
					             cy + titleFontMetrics.getAscent());
					if (colors[i] == Color.black) {
						g.setColor(Color.gray);
					}
					g.fillRect(cx + 3,
					           cy + 5,
					           (values[i] * scale),
					           barWidth);
	
					// draw the bar in the current color
					g.setColor((Color)(colors[i]));
					switch (styles[i]) {
						case SOLID:
						default:
							g.fillRect(cx,
							           cy,
							           (values[i] * scale),
							           barWidth);
							break;
						case STRIPED:
						{
							int steps = (values[i] * scale) / 2;
							int ys;
	
							for (j=0; j < steps; j++) {
								ys = cx + (2 * j);
								g.drawLine(ys, cy, ys, cy + barWidth);
							}
						}
						break;
					}
					g.drawString("" + values[i],
					             cx + (values[i] * scale) + 3,
					             cy + titleFontMetrics.getAscent());
				     
					break;
			}
		}
	}

   /**
    *  This method handles the "Close Window" event.
    */
	public void processWindowEvent(WindowEvent e)
	{
		if (e.getID() == WindowEvent.WINDOW_CLOSING)
			System.exit(0);
	}

   /**
    *  This method is the called by the application launcher.
    */
	public static void main (String[] args)
	{
		BarChart a = new BarChart();
		a.init();
		a.show();
	}
}
