//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.9 com/java/src/com/ibm/beans/samples/netdeploy/deployToWarehouse/NervousText.java, bbNetDeploy, bb97c, bb97c9750e 12/7/97 14:49:11 [12/11/97 16:59:49]
/* This program has been modified to be run as a Java 1.1 application. */
/* Also, package name has been changed.                                */

/*  Daniel Wyszynski 
    Center for Applied Large-Scale Computing (CALC) 
    04-12-95 

    Test of text animation.

    kwalrath: Changed string; added thread suspension. 5-9-95
*/
package com.ibm.beans.samples.netdeploy.deployToWarehouse;

import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.event.WindowEvent;


/**
 *  This class is a simple application to demonstrate the On Demand file group
 *  download control option on a Network Deployment client.  This application,
 *  residing on a Network Deployment server, can be launched from a Network
 *  Deployment client using the Network Deployment sample application
 *  COM.ibm.beans.netdeploy.samples.client.Launcher.
 *
 *  @see com.ibm.beans.samples.netdeploy.client.Launcher
 */ 
public class NervousText extends Frame implements Runnable {

	private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";
	char separated[];
	String s = null;
	Thread killme = null;
	int i;
	int x_coord = 0, y_coord = 0;
	String num;
	int speed=35;
	int counter =0;
	boolean threadSuspended = false; //added by kwalrath

   /**
    *  NervousText constructor.
    */
	public NervousText(String txt)
	{
		super("Nervous Text");
		if (txt == null)
			s = "Java Beans";
		else
			s = txt;
	} 

   /**
    *  This method initializes this NervousText object.
    */
	public void init() {
		enableEvents(WindowEvent.WINDOW_CLOSING);

		separated =  new char [s.length()];
		s.getChars(0,s.length(),separated,0);
		setSize(225, 75);
		setFont(new Font("TimesRoman",Font.BOLD,36));
		if(killme == null) 
		{
			killme = new Thread(this);
			killme.start();
		}
}


   /**
    *  This method is called as a separate thread to periodically
    *  update the text window.
    */
public void run() {
	while (killme != null) {
		try {Thread.sleep(100);} catch (InterruptedException e){}
		repaint();
	}
	killme = null;
}

   /**
    *  This method draws the text in the text window.
    */
public void paint(Graphics g) {
	for(i=0;i<s.length();i++)
	{
		x_coord = (int) (Math.random()*10+15*i) + 35;
		y_coord = (int) (Math.random()*10+36) + 15;
		g.drawChars(separated, i,1,x_coord,y_coord);
	}
}

	/* Added by kwalrath. */
   /**
    *  This method alternately suspends and resume the NervousText thread 
    *  when a "mouse down" event is received.
    */
	public boolean mouseDown(java.awt.Event evt, int x, int y) {
		if (threadSuspended) {
			killme.resume();
		}
		else {
			killme.suspend();
		}
		threadSuspended = !threadSuspended;
		return true;
	}

   /**
    *  This method handles the "Close Window" event.
    */
	public void processWindowEvent(WindowEvent e)
	{
		if (e.getID() == WindowEvent.WINDOW_CLOSING)
			System.exit(0);
	}

   /**
    *  This method is the called by the application launcher.
    */
	public static void main (String[] argv)
	{
		String txt = null;
		if (argv != null && argv.length >= 1)
		{
			txt = argv[0];
		}
			
		NervousText a = new NervousText(txt);
		a.init();
		a.show();
	}
}
