//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
/* This program has been modified to be run as a Java 1.1 application. */
/* Also, package name has been changed.                                */

/*
 * @(#)GraphApplet.java
 *
 * Copyright (c) 1994-1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted.
 * Please refer to the file http://java.sun.com/copy_trademarks.html
 * for further important copyright and trademark information and to
 * http://java.sun.com/licensing.html for further important licensing
 * information for the Java (tm) Technology.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

package com.ibm.beans.samples.netdeploy.deployToWarehouse;

import java.awt.Frame;
import java.awt.Graphics;
import java.awt.event.WindowEvent;

/**
 *  This class is a simple application to demonstrate the On Demand file group
 *  download control option on a Network Deployment client.  This application,
 *  residing on a Network Deployment server, can be launched from a Network
 *  Deployment client using the Network Deployment sample application
 *  COM.ibm.beans.netdeploy.samples.client.Launcher.
 *
 *  @see com.ibm.beans.samples.netdeploy.client.Launcher
 */ 
public class SimpleGraph extends Frame {
	private final static String kBeanExtenderIBMCopyright="(c) Copyright IBM Corporation 1997";

   /**
    *  SimpleGraph constructor.
    */
	public SimpleGraph()
	{
		super("Simple Graph");
	}

   /**
    *  This method initializes this SimpleGraph object.
    */
	public void init()
	{
		setSize(300, 120);
		enableEvents(WindowEvent.WINDOW_CLOSING);
	}

   /**
    *  This method implements the function whose curve is graphed.
    */
	double f(double x) {
		return (Math.cos(x/5) + Math.sin(x/7) + 2) * getSize().height / 4;
	}

   /**
    *  This method paints the graph.
    */
	public void paint(Graphics g)
	{
		for (int x = 0 ; x < getSize().width ; x++)
			g.drawLine(x, (int)f(x), x + 1, (int)f(x + 1));
	}

   /**
    *  This method handles the "Close Window" event.
    */
	public void processWindowEvent(WindowEvent e)
	{
		if (e.getID() == WindowEvent.WINDOW_CLOSING)
			System.exit(0);
	}

   /**
    *  This method is the called by the application launcher.
    */
	public static void main (String[] args)
	{
		SimpleGraph a = new SimpleGraph();
		a.init();
		a.show();
	}
}
