//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbNetDeploy
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.1 com/java/src/com/ibm/beans/samples/netdeploy/warehouse/SimpleStorageSystemImplCustomizer.java, bbNetDeploy, bb97c, bb97c9750e 11/24/97 18:43:09 [12/11/97 16:59:43]
/*-------------------------------------------------------------------+
|                    SimpleStorageSystemImplCustomizer.java          |
| ================================================================== |
|                                                                    |
| Description:  
|                                                                    |
| Author(s):    Sreedhar Arda and Ajay Apte                          |
|               Copyright IBM Corporation, 1997                      |
|                                                                    |
+-------------------------------------------------------------------*/
package com.ibm.beans.samples.netdeploy.warehouse;

import java.awt.*;
import java.io.*;

import java.beans.Customizer;
import com.ibm.beans.netdeploy.NetDeployException;

import com.ibm.beans.netdeploy.*;
import com.ibm.beans.netdeploy.warehouse.*;

public class SimpleStorageSystemImplCustomizer extends StorageSystemImplCustomizer 

{
   /*--------------------------------------------------------------------------+
   |  Copyright notice:                                                        |
   +--------------------------------------------------------------------------*/

   private final static String kBeanExtenderIBMCopyright =
           "(c) Copyright IBM Corporation 1997";

    Label authLabel;
    TextField authField;
    Label pluginLabel;
    TextField pluginField;
    Label pluginClassLabel;
    TextField pluginClassField;

    public SimpleStorageSystemImplCustomizer() {

        super();

	authLabel = new Label("Class of Authentication System :", Label.LEFT);
	authLabel.setSize(230, 20);
	add (authLabel);

	authField = new TextField(20);
	authField.setSize(230, 25);
	add(authField);
        authField.setText ("com.ibm.beans.samples.netdeploy.warehouse.DefaultAuthenticationImpl");

	pluginClassLabel = new Label("Class of Authentication Plugin :", Label.LEFT);
	pluginClassLabel.setSize(230, 20);
	add (pluginClassLabel);

	pluginClassField = new TextField(20);
	pluginClassField.setSize(230, 25);
	add(pluginClassField);
        pluginClassField.setText ("com.ibm.beans.samples.netdeploy.warehouse.SimpleAuthPluginImpl");

	pluginLabel = new Label("Location of Authentication Plugin :", Label.LEFT);
	pluginLabel.setSize(230, 20);
	add (pluginLabel);

	pluginField = new TextField(20);
	pluginField.setSize(230, 25);
	add(pluginField);
        pluginField.setText ("SimpleAuthPlugin.jar");

    }


    public Dimension getPreferredSize() {
	return new Dimension(250,260);
    }



    // NDNestedCustomizerInterface methods 

    public boolean validateProperties ()
    {
        boolean flag = super.validateProperties();

        if (flag == false)
            return flag;

        try {

            Class c = Class.forName (authField.getText());
            Class []interfaces = c.getInterfaces();

            boolean found = false;
            for (int i = 0; i < interfaces.length; i++) {
                if (interfaces[i].getName().equals (
                 "com.ibm.beans.netdeploy.warehouse.AuthenticationInterface"))
                    found = true;
            }

            flag = found;

            if (flag == true) {
                File ff = new File (pluginField.getText());
                if (ff.exists() == false) {
                    flag = false;
                    System.out.println ("Error: The file for auth plugin not found");
                }
            }
        }
        catch (Exception e) {

            System.out.println ("Error in validation " + e);
            e.printStackTrace();
            flag = false;
        }
        return flag;
    }

    public void setAllProperties () throws Exception
    {
        super.setAllProperties ();

        SimpleStorageSystemImpl ssImpl = (SimpleStorageSystemImpl)target;

        ssImpl.setAuthenticationClassName (authField.getText());
        ssImpl.setAuthenticationPluginFileName (pluginField.getText());
        ssImpl.setAuthenticationPluginClassName (pluginClassField.getText());
    }
}
