//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.7 com/java/src/com/ibm/beans/samples/script/beans/table/TableCell.java, bbScripting, bb97c, bb97c9750e 11/18/97 11:47:19 [12/11/97 16:54:30]
package com.ibm.beans.samples.script.beans.table;

import java.lang.*;
import java.io.Serializable;
import java.text.*;
import java.util.*;

import com.ibm.beans.samples.script.beans.table.TableModel;
import com.ibm.beans.samples.script.beans.table.TableModelEvent;
import com.ibm.beans.samples.script.beans.table.CellIndex;





public class TableCell implements Serializable
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
   private static final long serialVersionUID = 2000L;
public final static int DOUBLE   = 1;
public final static int STRING  = 2;
public final static int FORMULA = 4;
public final static int EMPTY = 8;

private boolean currency;

public boolean getCurrency()
  {
    return currency;
  }

public void setCurrency(boolean newCurrency)
  {
    currency = newCurrency;
  }


public  String getDisplayString()
  {
	switch (type)
	  {
	  case DOUBLE:
	        if (! currency)
		  return String.valueOf(doubleValue);
		else
		  {
		    NumberFormat form = NumberFormat.getCurrencyInstance(Locale.getDefault());
		    return form.format(doubleValue);
		  }


	  case STRING:
		return new String(stringValue);
	  case FORMULA:
		return computeFormula();
	  }

	return new String("");
  }


protected String computeFormula()
  {
	return new String(stringValue);
  }

public int getType()
  {
	return type;
  }

public void setDouble(double newValue)
  {
	type = DOUBLE;
	doubleValue = newValue;
	fireEvent();
  }

protected void fireEvent()
  {
    if (model != null)
	  model.fireTableEvent(new TableModelEvent(model, this, model.getCellIndex(this)));
  }

public double getDouble()
  {
	double ret = 0;

	switch (type)
	  {
	  case DOUBLE:
		ret = doubleValue;
	  case STRING:
		ret = Double.valueOf(stringValue).doubleValue();
	  }

	return ret;
  }

public void setString(String newValue)
  {
	type = STRING;
	stringValue = newValue;
	fireEvent();
  }

public String getString()
  {
	switch (type)
	  {
	  case DOUBLE:
		return String.valueOf(doubleValue);
	  case STRING:
	  case FORMULA:
		return stringValue;
	  }

	return null;
  }

public void setFormula(String newValue)
	{
	  type = FORMULA;
	  stringValue = newValue;
	  fireEvent();
	}

public String getFormula()
  {
	return type == FORMULA ? stringValue : null;
  }


public void setEmpty()
  {
	type = EMPTY;
	doubleValue = 0;
	stringValue = null;
  }


public boolean isEmpty()
  {
	return type == EMPTY;
  }

public void setName(String newName)
  {
	name = newName;
	fireEvent();
  }

public String getName()
  {
	return name;
  }

public void setModel(TableModel newModel)
  {
	model = newModel;
  }

private String name = null;
private int type = EMPTY;
private double doubleValue;
private String stringValue;
private TableModel model;

}
