//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/samples/script/beans/table/TableModel.java, bbScripting, bb97c, bb97c9750e 11/18/97 11:47:28 [12/11/97 16:54:36]
package com.ibm.beans.samples.script.beans.table;

import java.util.Hashtable;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.Serializable;
import com.ibm.beans.samples.script.beans.table.TableModelListener;
import com.ibm.beans.samples.script.beans.table.TableModelEvent;
import com.ibm.beans.samples.script.beans.table.TableModelException;
import com.ibm.beans.samples.script.beans.table.CellIndex;


public class TableModel extends Panel implements Serializable
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
   private static final long serialVersionUID = 2000L;


public int rowSize = 20;
public int columnSize = 75;



public TableModel(int newRowSize, int newColumnSize)
  {
    super();
    initTableModel(newRowSize, newColumnSize);
  }

public TableModel()
  {
    super();
    initTableModel(10, 7);
  }

private void initTableModel(int newRowSize, int newColumnSize)
  {
    rows = newRowSize;
    columns = newColumnSize;
    selectedIndex = new CellIndex(0,0);
    cells = new TableCell[rows][columns];
    
	/*
    for (int r = 0; r < rows; r++)
	  for (int c = 0; c < columns; c++)
		{
		  TableCell newCell = new TableCell();
		  newCell.setString("");
		  cells[r][c] = newCell;
		  newCell.setModel(this);		  
		}
		*/
    
    setLayout(null);
    setBackground(new Color(200, 200, 200));
    
    entry = new TextField();
    nameEntry = new TextField();
	add(nameEntry);
    
    ma = new MouseAdapterImp();
	
    addMouseListener(ma);
    addComponentListener(ma);
    entry.addKeyListener(ma);
	nameIndex = new Hashtable();	
    nameButton = new Button();
    nameButton.setLabel("Name:");
	nameButton.addActionListener(ma);
	add(nameButton);
  }

  MouseAdapterImp ma;

  class MouseAdapterImp implements MouseListener, KeyListener, Serializable,
								   ComponentListener, ActionListener
  {
    public void mouseClicked(MouseEvent e)
    {
      Point p = e.getPoint();
      
      CellIndex i = getIndexAt(p.x, p.y);
      
      if (i != null)
	{
	  setSelectedIndex(i);
	}
      
    }
    public void mouseReleased(java.awt.event.MouseEvent e) {}
    public void mousePressed(java.awt.event.MouseEvent e) {}
    public void mouseEntered(java.awt.event.MouseEvent e) {}
    public void mouseExited(java.awt.event.MouseEvent e)  {}

    public void keyTyped(java.awt.event.KeyEvent e)
    {
      //      System.out.println("e="+e);
    }

    public void keyPressed(java.awt.event.KeyEvent e) {}

    public void keyReleased(java.awt.event.KeyEvent e) {}



    public void actionPerformed(ActionEvent e)
	{
         if (e.getSource() == nameButton)
		   {
			 CellIndex i = getSelectedIndex();

			 if ( i != null)
			   setCellName(i, nameEntry.getText());
		   }
	}      
    /**
      * <b>SPI - Do not call this method.<b>
      *
      * Component listener interface 
      */
    
    public void componentHidden(ComponentEvent event) 
      {
      }
    
    /**
      * <b>SPI - Do not call this method.<b>
      *
      * Component listener interface
      */
    
    public void componentMoved(ComponentEvent event) 
      {
      }
    
    /**
      * <b>SPI - Do not call this method.<b>
      *
      * Component listener interface
      */
    
    public void componentResized(ComponentEvent event) 
      {
        doLayout(getSize());
      }
    
    /**
      * <b>SPI - Do not call this method.<b>
      *
      * Component listener interface
      */
    
    public void componentShown(ComponentEvent event)
      {
      }



  }

  public Dimension getPreferredSize()
  {
    Rectangle r = getCellBounds(new CellIndex(getRows()-1, getColumns()-1));
    
    if (r == null)
      return new Dimension(300, 300);
    
    
    return new Dimension(r.x + r.width + 10, r.y + r.height + 10);
  }



  public void doLayout(Dimension size)
  {
    nameButton.setBounds(5, 5, 45, 20);
	nameEntry.setBounds(50, 7, 100, 20);
  }


  public Rectangle getCellBounds(CellIndex i)
  {
    int cx = X;
    int cy = Y;

    for (int r = 0; r != i.row; r++)
      {
	cy += getRowSize(r) + borderWidth;
      }

    for (int c = 0; c != i.column; c++)
      {
	cx += getColumnSize(c) + borderWidth;
      }
    
    Dimension d = getCellSize(i);
    
    return new Rectangle(cx, cy, d.width, d.height);
  }

  public TableCell getCellAt(int x, int y)
  {
    TableCell cell = null;
    
    CellIndex i = getIndexAt(x, y);
    
    if (i != null)
      {
	cell = getCell(i);
      }
    return cell;
  }

  public CellIndex getIndexAt(int x, int y)
  {
    int rows = getRows();
    int columns = getColumns();


    int cx = X;
    int cy = Y;

    for (int r = 0; r < rows; r++)
      {
	int h = getRowSize(r);
	
	for (int c = 0; c < columns; c++)
	  {
	    
	    int w = getColumnSize(c);
	    
	    Rectangle rect = new Rectangle(cx, cy, w, h);
	    if (rect.contains(x, y))
	      return new CellIndex(r, c);
	    
	    cx += w + borderWidth;
	  }
	
	cx = X;
	cy += h + borderWidth;
      }
    
    return null;
  }


  public final static int CTL_HT = 25;
  public final static int X = 10;
  public final static int Y = CTL_HT + 10;
  

  public void paint(Graphics g)
  {
    Rectangle bounds = getBounds();

    g.setColor(getBackground());
    
    g.fill3DRect(1, 1, bounds.width-1, CTL_HT, true );
    g.fill3DRect(1, CTL_HT+4, bounds.width-1, bounds.height-1-CTL_HT-4, true );


    

    int rows = getRows();
    int columns = getColumns();
    
    int tx = X;
    int ty = Y;
    
    for (int r = 0; r < rows; r++)
      {
	int h = getRowSize(r);
	
	for (int c = 0; c < columns; c++)
	  {
	    CellIndex i = new CellIndex(r, c);
	    
	    int w = getColumnSize(c);
	    
	    paintCell(g, tx, ty, w, h, i, getCell(i));
	    
	    tx += w + borderWidth;
	  }
	
	tx = X;
	ty += h + borderWidth;
      }
    
  }

  protected void paintCell(Graphics g, int x, int y, int width, int height, CellIndex i, TableCell cell)
  {
    
    g.setColor(Color.lightGray);
    g.fill3DRect(x, y, width, height, true);
    
    
    if (cell != null)
      {
	String value = cell.getDisplayString();
	if (value != null)
	  {
	    g.setColor(Color.black);
	    g.drawString(value, x+5, y+height-5);		
	  }
      }
  }


  public Dimension getCellSize(CellIndex i)
  {
    return new Dimension(getColumnSize(i.column), getRowSize(i.row));
  }
  
public int getRowSize(int row)
  {
	return rowSize;
  }

public int getColumnSize(int column)
  {
	return columnSize;
  }

public int getRows()
  {
	return rows;
  }

public int getColumns()
  {
	return columns;
  }

public int getDefaultRows()
  {
	return 20;
  }

public int getDefaultColumns()
  {
	return 10;
  }


public CellIndex getCellIndex(TableCell cell)
  {
	CellIndex i = null;

	for (int r = 0; r < rows; r++)
	  for (int c = 0; c < columns; c++)
	  {
		if (cell == cells[r][c])
		  {
			i = new CellIndex(r, c);
			break;
		  }
	  }

	return i;
  }

public TableCell getCell(String name)
  {
	CellIndex i = (CellIndex) nameIndex.get(name);
	return i != null ? getCell(i) : null;
  }


public void setCellString(int row, int col, String newString)
  {
	TableCell cell = getCreateCell(row, col);
	cell.setString(newString);
  }

public void setCellFormula(int row, int col, String newString)
  {
	TableCell cell = getCreateCell(row, col);
    try{
	cell.setFormula(newString);
    } catch(RuntimeException e){}
  }

public void setCellDouble(int row, int col, double value)
  {
	TableCell cell = getCreateCell(row, col);
	cell.setDouble(value);
  }



public String getCellString(int row, int column)
  {

	TableCell cell = getCell(row, column);

	return ((cell == null) || (cell.getString() == null)) ? 
	  new String("") :
	  cell.getString();
  }

public String getCellString(String name)
  {

	TableCell cell = getCell(name);

	return ((cell == null) || (cell.getString() == null)) ? 
	  new String("") :
	  cell.getString();
  }

public CellIndex getCellIndex(String name)
  {
	return (CellIndex) nameIndex.get(name);
  }

public double getCellDouble(String name)
  {
	TableCell cell = getCell(name);
	return cell != null ?  cell.getDouble() : (double) 0;
  }



public void setCellCurrency(int row, int col, double value)
  {
	TableCell cell = getCreateCell(row, col);
	cell.setDouble(value);
	cell.setCurrency(true);
  }


public void setEmpty(int row, int col)
  {
	TableCell cell = getCreateCell(row, col);
	cell.setEmpty();
  }

public void emptyCells(int row, int col)
  {

	for (int r = 0; r < rows; r++)
	  {
		for (int c = 0; c < columns; c++)
		  {
			cells[r][c].setEmpty();
		  }
	  }
  }


public TableCell getCreateCell(int row, int col)
  {
	TableCell cell = getCell(row, col);

	if (cell == null)
	  {
		cell = new TableCell();
		setCell(row, col, cell);
	  }

	return cell;
  }

public void setCellName(int row, int col, String name)
  {
	setCellName(new CellIndex(row, col), name);
  }


public void setCellName(CellIndex i, String name)
  {
	TableCell cell = getCreateCell(i.row, i.column);

	cell.setName(name);
		
	CellIndex oldI = (CellIndex) nameIndex.put(new String(name), i);
	if (oldI != null)
	{
	  TableCell oldCell = getCell(oldI);

	  if (oldCell != null)
		{
		  oldCell.setName(null);
		  fireTableEvent(new TableModelEvent(this, oldCell, i));
		}
	}


  }


public TableCell setCell(int row, int col, TableCell newCell)
  {
	return setCell(new CellIndex(row, col), newCell);
  }

public TableCell setCell(CellIndex i, TableCell newCell)
  {
	if (i.row >= rows || i.row < 0 || i.column >= columns || i.column < 0)
	  return null;

	TableCell cell = getCell(i);

	cells[i.row][i.column] = newCell;
	newCell.setModel(this);

	fireTableEvent(new TableModelEvent(this, newCell, i));

	return cell;
  }



public synchronized void addTableModelListener(TableModelListener l)
  {
	if (listeners == null)
	  listeners = new Vector();

	listeners.addElement(l);
  }
	
public synchronized void removeTableModelListener(TableModelListener l)
  {
	if (listeners != null)
	  listeners.removeElement(l);
  }

public void fireTableEvent(TableModelEvent e)
  {
	if (listeners == null)
	  return;

	Vector v;
	int size;

	synchronized(this)
	  {
		v = (Vector) listeners.clone();
		size = v.size();
	  }
	
	for (int i = 0; i < size; i++)
	  {
	    	    try
	     {
		TableModelListener listener = (TableModelListener) v.elementAt(i);

		listener.tableChanged(e);
		listener.tableChanged();
		     }
		    catch(TableModelException ex)
		{
		System.out.println("Table Caught table model exception");
		}
	  }

  }

public TableCell getCell(int row, int column)
  {
	return getCell(new CellIndex(row, column));
  }

public TableCell getCell(CellIndex i)
  {
	if (i.row >= rows || i.row < 0 || i.column >= columns || i.column < 0)
	  return null;

	return cells[i.row][i.column];
  }


public void setTableSize(int newRows, int newColumns)
  {
	TableCell tmp[][] = cells;

	rows = newRows;
	columns = newColumns;

	cells = new TableCell[rows][columns];
	copyCells(tmp, new CellIndex(0,0));

	setSize(getPreferredSize());

	if (listeners == null)
	  return;
	
	Vector v;
	int size;

	synchronized(this)
	  {
		v = (Vector) listeners.clone();
		size = v.size();
	  }
	
	for (int i = 0; i < size; i++)
	  {
		TableModelListener listener = (TableModelListener) v.elementAt(i);

		listener.tableChangedSize(rows, columns);
	  }


  }
  
public void copyCells(TableCell source[][], CellIndex target)
  {
	int startColumn = target.column;

	for (int r = 0; r < rows; r++)
	  {
		if (r >= source.length)
		  break;

		for (int c = 0; c < columns; c++)
		  {
			if (c >= source[r].length)
			  break;

			cells[r][c] = source[r][c];
		  }
	  }
  }

public boolean setSelectedIndex(CellIndex i)
  {
    if (i.row >= rows || i.column >= columns)
	  return false;

	if (selectedIndex != null)
	  {
		String text = entry.getText();
		if (text != null)
		  {
			TableCell cell = getCell(selectedIndex);
			if (cell != null)
			  {
				cell.setString(new String(text));
			  }
			else
			  {
				cell = new TableCell();
				cell.setString(new String(text));
				setCell(selectedIndex, cell);
			  }
		  }
	  }
	
	selectedIndex = new CellIndex(i);
	
	TableCell cell = getCell(selectedIndex);
	
	if (cell != null)
	  {
	    String text = cell.getString();
	    if (text != null)
	      entry.setText(new String(text));

		String name = cell.getName();

		nameEntry.setText(name);
	  }
	else
	  {
		entry.setText(new String());
		nameEntry.setText(new String());
	  }
	
	Rectangle r = getCellBounds(selectedIndex);
	
	if (r != null)
	  {
	    entry.setBounds(r.x, r.y, r.width, r.height);
	    add(entry);

	  }

	return true;
  }
  
  
public TableCell getSelectedCell()
  {
	return getCell(selectedIndex);
  }

public CellIndex getSelectedIndex()
  {
	return selectedIndex;
  }
	

  Button nameButton;
  TextField nameEntry;
  TextField entry;
  
  private int borderWidth = 2;
  
private TableCell cells[][];
private int rows;
private int columns;
private Hashtable nameIndex;
private Vector listeners;
private CellIndex selectedIndex;

}






