//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.33 com/java/src/com/ibm/beans/samples/script/form/BeanContainer.java, bbScripting, bb97c, bb97c9750e 11/11/97 17:27:27 [12/11/97 16:54:24]

package com.ibm.beans.samples.script.form;

import java.awt.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import com.ibm.beans.samples.script.form.Session;
import com.ibm.beans.samples.script.form.FormRunner;
import com.ibm.beans.script.SCRCodeGenUtils;
import com.ibm.beans.script.SCREnvironment;
import com.ibm.beans.script.SCRRTEnvironment;
import com.ibm.beans.script.SCREnvironmentFactory;
import com.ibm.beans.script.SCRComponentDescriptor;
import com.ibm.beans.script.SCRRTClient;
import com.ibm.beans.script.SCRClient;

public class BeanContainer extends Panel implements ActionListener, MouseListener, Externalizable, SCRClient, SCRRTClient, WindowListener {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    int lastIndex = 0;
    transient Hashtable children = null;
    transient Session fSession = null;
    boolean isRoot = true;
    boolean isRunning = false;

    private SCREnvironment scrEnv = null;
    private SCRRTEnvironment scrRTEnv = null;
    private transient PopupMenu descPopup;
    private transient SCRComponentDescriptor list[];
    private transient SCREnvironmentFactory factory;
    private transient FormRunner formRunning = null;

    private static final String packageName = new String ("scr.be");

    // design time
    public BeanContainer () {

        super();
        initData (null, true);
    }

    // design time
    public BeanContainer (Session session, boolean bRoot) {

        super();
        initData (session, bRoot);
        chooseColor(bRoot);
    }

    // design time
    public boolean setRunning (boolean flag, boolean withDebug) {

        //if alrady deployed then return .. this is an error
        if ((flag == true ) && (isRunning == true)) {
            System.out.println ("isRunning is true already .. something wrong");
            return false;
        }

        isRunning = flag;

        if (isRunning == true) {
        
            // called before saving for deployment
            if (scrEnv != null) {
                scrRTEnv = scrEnv.getRTEnvironment(withDebug);
            }
            else {

                // pass the call to children
                Enumeration e = children.keys ();

                for (; e.hasMoreElements() ;) {

                    Component c = (Component)e.nextElement ();
                    if (c.getClass().equals(this.getClass())) {
                        if (((BeanContainer)c).setRunning(flag, withDebug) == false)
                            return false;
                    }
                }
                return true;
            }

            if (scrRTEnv == null) {
                isRunning = false;
                return false;
            }
        }
        else {

             //called after deplyment is done
            scrRTEnv = null;
        }

        // now pass on this call to all children
        Enumeration e = children.keys ();

        for (; e.hasMoreElements() ;) {

            Component c = (Component)e.nextElement ();
            if (c.getClass().equals(this.getClass())) {
                if (((BeanContainer)c).setRunning(flag, withDebug) == false)
                    return false;
            }
        }
        return true;
        
    }

    // design and run time
    private synchronized void initData (Session session, boolean bRoot) {

        setLayout(null);
        addMouseListener (this);

        fSession = session;
        isRoot = bRoot;
        children = new Hashtable ();
        isRunning = false;
        factory = null;
        scrEnv = null;
    }

    // design time
    private void chooseColor(boolean bRoot) {


        if (bRoot == true) {
            setBackground(Color.white);
        }
        else {
            // choose at random
            Date date = new Date();
            Random rand = new Random(date.getTime());
            setBackground(new Color(rand.nextFloat(), rand.nextFloat(),
                                    rand.nextFloat()));
        }

    }

    // design time
    public void writeExternal(ObjectOutput out) throws IOException {

        try {

            out.writeInt (lastIndex);
            out.writeInt(getBackground().getRGB());
            out.writeBoolean(isRoot);
            out.writeBoolean(isRunning);
            Rectangle r = getBounds();
            out.writeInt(r.x);
            out.writeInt(r.y);
            out.writeInt(r.width);
            out.writeInt(r.height);

            out.writeInt(children.size());

            Enumeration lcv = children.keys ();

            for (; lcv.hasMoreElements() ;) {

                Component c = (Component)lcv.nextElement();
                out.writeObject (children.get(c));

                c.removeMouseListener(this);
                out.writeObject(c);
                c.addMouseListener(this);
            }

            if (isRunning == false)
	        out.writeObject(scrEnv);

            else {
	        out.writeObject(scrRTEnv);

                // lets publish all the generated class files
                if (scrEnv != null) {

                    Vector allNames = new Vector ();
                    Vector byteArrays = new Vector ();
                    scrEnv.getPackagingFiles(allNames, byteArrays);
                    String finDir;

                    // create the dir corresponding to the package name

                    try {

                        String wDir = SCRCodeGenUtils.createTempDir();
                        finDir = wDir + File.separator + packageName;
                        finDir = finDir.replace('.', File.separatorChar);
                        File fDir = new File (finDir);
                        fDir.mkdirs(); 
                        finDir = finDir + File.separator;
                    }

                    catch (Exception e) {

                        System.out.println ("Could not publish ..1");
                        return;
                    }
 
                    // dump byte arrays into respective files                   

                    for (int i = 0;  i < allNames.size(); i++) {

                        String fullName = (String) allNames.elementAt(i);
                        byte [] bArray = (byte[]) byteArrays.elementAt(i);

                        try {
                            FileOutputStream fout = new FileOutputStream (
                                finDir + fullName.substring 
                                (fullName.lastIndexOf('.') + 1) + ".class");

                            fout.write (bArray);
                            fout.close();
                        }

                        catch (Exception e) {

                            System.out.println ("Could not publish ..1");
                            return;
                        }

                    }
                }
            }

        } catch (IOException e) {}

    }

    // design time
    public void readExternal(ObjectInput in) throws IOException {

        try {

            lastIndex = in.readInt ();
            setBackground(new Color(in.readInt()));
            isRoot = in.readBoolean();
            isRunning = in.readBoolean();
            int x = in.readInt();
            int y = in.readInt();
            int width = in.readInt();
            int height = in.readInt();
            setBounds(x,y,width, height);

            int count = in.readInt();

            try {
                for (int i = 0; i < count; i++) {
                    String name = (String) in.readObject();
                    Component c = (Component) in.readObject();

                    if (c instanceof Applet) {
                        // Assign an AppletStub
                        assignAppletStub((Applet) c, null , c.getClass());
                    }

                    add(c);
                    c.addMouseListener (this);
                    children.put(c, name);

                    if (c instanceof Applet) {
                        // start the Applet.
                        ((Applet)c).init();
                    }
                }

                // read appropriate env

                if (isRunning == false) {
		    scrEnv = (SCREnvironment) in.readObject();
	            if (scrEnv != null)
			scrEnv.initialize(this);
                    scrRTEnv = null;
                }
                else {
		    scrRTEnv = (SCRRTEnvironment) in.readObject();

                    if (scrRTEnv != null) {
                        Hashtable tbl = (Hashtable)children.clone();
                        scrRTEnv.initialize(tbl);
                    }
                    scrEnv = null;
                }

            } catch (ClassNotFoundException e) {
                System.out.println(" Class not found");
            }

        } catch (IOException e) {

              System.out.println ("Exception: Read failed: beanContainer");
              e.printStackTrace();
        }

    }

    //design and run time
    // Guess a codebase for a class in a classloader

    private void assignAppletStub(Applet applet, ClassLoader cl, Class k) {
        String className = k.getName();
        String resourceName = className.replace('.','/').concat(".class");

        // This code is identical to portions of Beans.intantiate()
        URL objectUrl = null;
        URL codeBase = null;
        URL docBase = null;

        // Now get the URL correponding to the resource name.
        if (cl == null) {
            objectUrl = ClassLoader.getSystemResource(resourceName);
        } else {
            objectUrl = cl.getResource(resourceName);
        }

        // If we found a URL, we try to locate the docbase by taking
        // of the final path name component, and the code base by taking
        // of the complete resourceName.
        // So if we had a resourceName of "a/b/c.class" and we got an
        // objectURL of "file://bert/classes/a/b/c.class" then we would
        // want to set the codebase to "file://bert/classes/" and the
        // docbase to "file://bert/classes/a/b/"

        if (objectUrl != null) {
            String s = objectUrl.toExternalForm();
            if (s.endsWith(resourceName)) {
                try{
                    int ix = s.length() - resourceName.length();
                    codeBase = new URL(s.substring(0,ix));
                    docBase = codeBase;
                    ix = s.lastIndexOf('/');
                    if (ix >= 0) {
                        docBase = new URL(s.substring(0,ix+1));
                    }
                } catch (Exception ex) {
                    docBase = codeBase = null;
                }
            }
        }

        // Setup a default context and stub.
        BeanContainerAppletContext context = 
                            new BeanContainerAppletContext(applet);
        BeanContainerAppletStub stub = 
              new BeanContainerAppletStub(applet, context, codeBase, docBase);
        applet.setStub(stub);

        // object is always deserialized
        stub.active = true;
    }

    // design time
    public synchronized void setSession (Session s) {

        fSession = s;

        Enumeration e = children.keys ();

        for (; e.hasMoreElements() ;) {
            Component c = (Component)e.nextElement();
            if (c.getClass().equals(this.getClass())) {
                ((BeanContainer)c).setSession(fSession);
            }
        }
    }

    // design time
    public void paint (Graphics g) {

        // we do not draw activation border at run time
        if (isRunning == true)
            return;

        Component c = fSession.getActiveComponent(this);
        if (c!= null) {

            Rectangle r = c.getBounds();
            int hashWidth = 7;
            int borderWidth = 3;
            int width = r.width;
            int height = r.height;

            for (int x = r.x-borderWidth;
                 x <= r.x+width+borderWidth; x += hashWidth) {

                // draw alternate dark gray and light gray stripes.
                if ((x%2) == 0)
                    g.setColor(Color.darkGray);
                else
                    g.setColor(Color.lightGray);

                int currWidth = (x+hashWidth <= r.x+width+borderWidth)
                        ? hashWidth : hashWidth-(r.x+width+borderWidth);

                g.fillRect(x, r.y-borderWidth, currWidth, borderWidth);
                g.fillRect(x, r.y+height, currWidth, borderWidth);

            }

            for (int y = r.y-borderWidth;
                 y <= r.y+height+borderWidth; y += hashWidth) {

                // draw alternate dark gray and light gray stripes.
                if ((y%2) == 0)
                    g.setColor(Color.darkGray);
                else
                    g.setColor(Color.lightGray);

                int currHeight = (y+hashWidth <= r.y+height+borderWidth)
                        ? hashWidth : hashWidth-(r.y+height+borderWidth);

                g.fillRect(r.x-borderWidth, y, borderWidth, currHeight);
                g.fillRect(r.x+width, y, borderWidth, currHeight);

            }
        }

    }

    // design time
    public void mouseClicked (MouseEvent evt) {

        // we do not handle click at run time
        if (isRunning == true)
            return;

       if (evt.getComponent() == this) {

           Component c = fSession.getPalette().getComponentToInsert(null);

           if (c == null) {

               if (isRoot == true) {

                   // looks like this is just a click. So activate self if root

                   fSession.setActiveComponent (this, null);
                   fSession.getPalette().setVisible(true);
               }
               return;
           }
           int width = c.getPreferredSize().width;
           int height = c.getPreferredSize().height;
           String name = shortName (c.getClass().getName());
           addNewChild(c, name, evt.getX(), evt.getY(), width, height);
       }

       else if (children.containsKey (evt.getComponent()) == true) {

           // this is a click in an embed. Activate it.
           fSession.setActiveComponent (evt.getComponent(), this);

           if (evt.getComponent().getClass().equals(this.getClass()))
               fSession.getPalette().setVisible(true);
           else
               fSession.getPalette().setVisible(false);
       }
    }

    private void addNewChild(Component c, String name, 
               int x, int y, int width, int height)
    {
           add (c);
           children.put(c, name);
           c.addMouseListener (this);
           if(width == 0)
              width = c.getPreferredSize().width; 
           if(height == 0)
              height = c.getPreferredSize().height; 
           c.setBounds(x, y, width, height);
           // register object
           if (scrEnv != null)
               scrEnv.registerObject(c.getClass(), name);
    }

    public void mouseEntered (MouseEvent e) {

    }

    public void mouseExited (MouseEvent e) {

    }

    public void mousePressed (MouseEvent e) {

    }

    public void mouseReleased (MouseEvent e) {

    }

    // Window Listener

    public  void windowOpened(WindowEvent e)
    {
    }
    public  void windowClosed(WindowEvent e)
    {
    }
    public  void windowClosing(WindowEvent e) {

        try {
            FormRunner f = (FormRunner) (e.getSource());
            if (f != formRunning) {
                System.out.println ("Different form is running ... error");
                return;
            }
            terminateRequest (scrEnv);

        }
        catch (Exception ex) {
            System.out.println ("Exception in windowClosed " + ex);
        }

    }
    public  void windowIconified(WindowEvent e)
    {
    }

    public  void windowDeiconified(WindowEvent e)
    {
    }

    public  void windowActivated(WindowEvent e)
    {
    }

    public  void windowDeactivated(WindowEvent e)
    {
    }


    // design time
    public void deleteChild (Component child) {

        if (scrEnv != null)
           scrEnv.deregisterObject ((String)children.get(child));

        children.remove (child);
        remove (child);
        doLayout();
        repaint();
    }

    // design time
    public void renameChild (Component child) {

        if (scrEnv == null)
            return;

        fSession.getNewName();
    }

    //design time
    public void setNewName (Component c, String newName) {

        if (newName == null)
            return;

        if (children.containsKey (c) == true) {
            boolean flag = scrEnv.renameObject ((String)children.get(c), newName);
            if (flag == true) {
                children.remove (c);
                children.put (c, newName);
            }
        }
    }

    // design time
    protected String shortName(String longName)
    {
	  int l = longName.length();
	  int dot = 0;

	  for (int i = 0; i < l; i++)
		{
		  if (longName.charAt(i) == '.')
			{
			  dot = i;
			}
		}
          String short_str = null;
	  if (dot == 0)
		short_str =  new String(longName);
          else
	        short_str = longName.substring(dot+1);
          char[] name_array = short_str.toCharArray();
          if(Character.isLetter(name_array[0]))
             name_array[0] = Character.toLowerCase(name_array[0]);
          return(new String(name_array) + lastIndex++);
    }


    // design time
    protected void editScript(String lang)
    {
        SCREnvironment e = getScrEnv(lang);
    
        if (e != null)
        {
            e.editScript();
        }
    
    }
    
    // design time
    public void handleDescPopup(ActionEvent event)
    {
        int s = descPopup.getItemCount();
    
        for (int i = 0; i < s; i++)
        {
            if (event.getSource() == descPopup.getItem(i))
            {
                if (list != null && list.length > i
                         && list[i] != null)
                {
                    createEnvironment(list[i]);
                    editScript(list[i].getLanguage());
                    list = null;
                    fSession.removePopup(descPopup);
                    descPopup = null;
                    break;
                }
    
            }
       }
    }
    
    // design time
    protected void showDescPopup()
    {
        factory = new SCREnvironmentFactory();
        list = factory.queryRegisteredComponents();
    
        if (list != null)
        {
          if (list.length > 1)
           {
            descPopup = new PopupMenu("descPopup");
            for (int i = 0; i < list.length; i++)
            {
                String s = list[i].getLanguage() +" "+
                      list[i].getVersion();
                MenuItem mi = new MenuItem(s);
                descPopup.add(mi);
                mi.addActionListener(this);
            }
            fSession.showPopup(descPopup);
          }
         else
          {
            createEnvironment(list[0]);
          }
        }
    }
    
    
    // design time
    private void createEnvironment(SCRComponentDescriptor desc)
    {
        try
        {
            if(factory == null)
               factory = new SCREnvironmentFactory();
            scrEnv = factory.create(this, desc);
    
            // register existing objects
            Enumeration e = children.keys();
            for ( ; e.hasMoreElements() ;) {
                Object c = (Component) e.nextElement ();
                scrEnv.registerObject(c.getClass(), (String) children.get (c));
            } 
    
        }
        catch(Exception e)
        {
            System.out.println("createEnvironment():"+e);
            e.printStackTrace();
            scrEnv = null;
        }
    }
    
    // design time
    public SCREnvironment getScrEnv(String lang)
    {
        if (scrEnv == null)
        {
            if(list == null)
	    {
               factory = new SCREnvironmentFactory();
               list = factory.queryRegisteredComponents();
            }
            for(int i = 0; i < list.length; i++)
	    {
               SCRComponentDescriptor desc =
                  (SCRComponentDescriptor) list[i];
               if(lang.equals(desc.getLanguage()))
                  createEnvironment(desc);
            }
        }
        else
	{
           if(lang == null)
              return(scrEnv);
           SCRComponentDescriptor desc;
           desc = scrEnv.getComponentDescriptor();
           if(lang.equals(desc.getLanguage()))
              return(scrEnv);
           else
	   {
              System.out.println("The script has been edited with language " +
                 desc.getLanguage() + ". It cannot be edited with language " +
                 lang + ".");
              return(null);
           }
        }
        return scrEnv;
    }
    
    // design time
    public void actionPerformed(ActionEvent event)
    {
    
        String cmd = event.getActionCommand();
    
        if (cmd == null)
          return;
    
        Object source = event.getSource();
    
        if (source instanceof MenuItem)
        {
            MenuItem mi = (MenuItem) source;
    
            if (mi.getParent() == descPopup)
            {
                handleDescPopup(event);
                return;
            }
        }
    
    
    }
    
    // design time
    public boolean runRequest(boolean runDebug, boolean compileDebug)
    {
         if (isRunning == false)
            return runRequest(scrEnv, runDebug, compileDebug);
    
         else 
             return runRequest(scrRTEnv, runDebug);
    } 
    
    // design time
    public boolean runRequest(SCREnvironment scrEnv, 
                boolean runDebug,
                boolean compileDebug)
    {
    
          if (formRunning != null) {
              System.out.println ("Close the existing form first");
              return false;
          }
    
          String tmpDirName = SCRCodeGenUtils.createTempDir ();
          String fname = tmpDirName + File.separator + "tmp123.tmp";
          boolean retVal = fSession.doDeploy (this, fname, compileDebug);
    
          if (retVal == true) {
              boolean dbg = runDebug && compileDebug;
              formRunning = new FormRunner("Run Form..", fname, 
                                  dbg, this);
              formRunning.addWindowListener (this);
              formRunning.shouldClose = false;
              formRunning.show();
          }
          return retVal;
    }
    
    //run time
    public boolean runRequest(SCRRTEnvironment rt, boolean withDebug)
    {
        if (scrRTEnv != null) {
            return scrRTEnv.runScript(withDebug, this);
        }
        return true;
    }
    
    
    // design and run time
    public boolean terminate()
    {
        if (isRunning == false)
          return terminate(scrEnv);
        else 
          return terminate(scrRTEnv);
    } 
    
    // design time
    public boolean terminateRequest(SCREnvironment scrEnv)
    {
       return(terminate(scrEnv));
    }


    public boolean terminate(SCREnvironment scrEnv)
    {
        if (formRunning != null) {
           formRunning.terminate();
           System.gc ();
           formRunning = null;
        }
        return true;
    }

    public void setFormRunning(FormRunner f)
    {
        formRunning = f;
    }

    public void formRunnerDeleted()
    {
       formRunning = null;
    }

    public boolean terminateRequest(SCRRTEnvironment rtEnv)
    {
       boolean rtn = formRunning.terminate();
       formRunning = null;
       return(rtn);
    }

    // run time
    public boolean terminate(SCRRTEnvironment rt)
    {
          if (scrRTEnv == rt && rt != null)
	  {
             formRunning = null;
             return scrRTEnv.terminateScript();
          }
          else
             System.out.println("different rt env");
          return true;
    }

    public Hashtable getRegisteredClassNames () {

        if ((scrEnv == null) && (scrRTEnv == null))
            return null;

        int num = children.size();
        if (num == 0) 
            return null;

        Hashtable tbl = new Hashtable(num);
        Enumeration e = children.keys ();

        for (; e.hasMoreElements() ;) {
            Component c = (Component)e.nextElement ();
            tbl.put (children.get(c), c.getClass()); 
        }
        return tbl;
    }

    public Vector getRegisteredClasses () {

        int num = children.size();
        if (num == 0) 
            return null;

        Vector v = new Vector (num);
        Enumeration e = children.keys ();

        for (; e.hasMoreElements() ;) 
            v.addElement (e.nextElement().getClass());

        return v;
    }

    public String getWorkingDirectory () {
        return SCRCodeGenUtils.createTempDir();
    }

    public String getPackageName () {
        return packageName;
    }

    public void importScript(BufferedReader in)
    {
        int f_width = SCRCodeGenUtils.importInt(in);
        int f_height = SCRCodeGenUtils.importInt(in);
        int j = 0;
        setSize(f_width, f_height);
        try
        {
           int scr_env_defined = SCRCodeGenUtils.importInt(in);
           if(scr_env_defined == 1)
           { 
              String lang = SCRCodeGenUtils.importString(in);
              String ver = SCRCodeGenUtils.importString(in);
              String clsName = SCRCodeGenUtils.importString(in);
              SCRComponentDescriptor desc = new SCRComponentDescriptor(
                  lang, ver, clsName, null);
              createEnvironment(desc);
           }
           int obj_num = SCRCodeGenUtils.importInt(in);
           for(int i = 0; i < obj_num; i++)
	   {
              String obj_name = SCRCodeGenUtils.importString(in);
              String obj_cls_name = SCRCodeGenUtils.importString(in);
              Class cls = Class.forName(obj_cls_name);
              Class[] interfaces = cls.getInterfaces();
              Object obj = fSession.getPalette().getComponentToInsert(
                                  obj_cls_name);
              if(obj instanceof Component)
	      {  
                 Component comp = (Component)obj;
                 int x = SCRCodeGenUtils.importInt(in);
                 int y = SCRCodeGenUtils.importInt(in);
                 int width = SCRCodeGenUtils.importInt(in);
                 int height = SCRCodeGenUtils.importInt(in);
                 addNewChild(comp, obj_name, x, y, width, height);
              }
              else if(scrEnv != null)
                 scrEnv.registerObject(obj.getClass(), obj_name);  
              if(obj instanceof com.ibm.beans.samples.script.form.BeanContainer)
	      {
                  ((BeanContainer)obj).importScript(in);
              }   
           }
           if(scrEnv != null)
              scrEnv.importScript(in);
           else if(scr_env_defined == 1)
             System.out.println(
              "Cannot create the exported scripting component. Import Failed."
              );
        }
        catch(Exception e)
	{
           e.printStackTrace();
        }            
    }

    public void exportScript(BufferedWriter out)
    {
        Dimension d = getSize();
        SCRCodeGenUtils.exportLine("// Export Java Scripting Form builder",
                      out);
        SCRCodeGenUtils.exportLine("Form Builder Width: " + d.width,
                      out);   
        SCRCodeGenUtils.exportLine("Form Builder Height: " + d.height,
                      out);        
        SCRCodeGenUtils.exportLine(
              "\n// Export Scripting Component Descriptor", out);
        if(scrEnv == null)
           SCRCodeGenUtils.exportLine("Scripting environment is defined: "
                                     + 0, out);
        else
        {
           SCRCodeGenUtils.exportLine("Scripting environment is defined: "
                                     + 1, out);
           SCRCodeGenUtils.exportLine("\n", out);
           SCRComponentDescriptor desc = scrEnv.getComponentDescriptor();
           SCRCodeGenUtils.exportLine("Scripting language: "
                                     + desc.getLanguage(), out);
           SCRCodeGenUtils.exportLine("Scripting language version: "
                                     + desc.getVersion(), out);
           SCRCodeGenUtils.exportLine("Scripting compontnt class name: "
                                     + desc.getClassName(), out);
        }
        SCRCodeGenUtils.exportLine("\n", out);
        SCRCodeGenUtils.exportLine("// Export registered objects", out);
        SCRCodeGenUtils.exportLine("Registered objects number: " + 
                   children.size(), out);
        if(children.size() > 0)
        {
           Enumeration e = children.keys();
           int i = 0;
           for (i = 0; i < children.size(); i++) 
           {
               Object obj = e.nextElement ();
               String name = (String)children.get(obj);
               SCRCodeGenUtils.exportLine("Name of Object[" + i + "]: " + name,
                                          out);
               String cls_name = obj.getClass().getName();
               SCRCodeGenUtils.exportLine("Class Name of Object[" + i + "]: " +
                                           cls_name, out);
               if(obj instanceof Component)
	       {
                   Component comp = (Component)obj;
                   Point p = comp.getLocation();
                   SCRCodeGenUtils.exportLine(name + ".x: " + p.x, 
                                              out);
                   SCRCodeGenUtils.exportLine(name + ".y: " + p.y,
                                              out);
                   d = comp.getSize();
                   SCRCodeGenUtils.exportLine(name + ".width: "
                                     + d.width, out);
                   SCRCodeGenUtils.exportLine(name + ".height: "
                                     + d.height + "\n", out);
               }
               if(obj instanceof com.ibm.beans.samples.script.form.BeanContainer)
	       {
                  SCRCodeGenUtils.exportLine("// Exporting subscript for " + 
                               name + "\n", out);
                  ((BeanContainer)obj).exportScript(out);
                  SCRCodeGenUtils.exportLine("// End of exporting subscript for " 
                          +  name + "\n", out);
            
               }
	   }   
        }
        SCRCodeGenUtils.exportLine("\n", out);
        if(scrEnv != null)
           scrEnv.exportScript(out);  
        SCRCodeGenUtils.exportLine("\n", out);
    }       

}

class BeanContainerAppletStub implements AppletStub {
    transient boolean active;
    transient Applet target;
    transient AppletContext context;
    transient URL codeBase;
    transient URL docBase;

   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    BeanContainerAppletStub(Applet target,
                AppletContext context, URL codeBase,
                                URL docBase) {
        this.target = target;
        this.context = context;
        this.codeBase = codeBase;
        this.docBase = docBase;
    }

    public boolean isActive() {
        return active;
    }

    public URL getDocumentBase() {
        // use the root directory of the applet's class-loader
        return docBase;
    }

    public URL getCodeBase() {
        // use the directory where we found the class or serialized object.
        return codeBase;
    }

    public String getParameter(String name) {
        return null;
    }

    public AppletContext getAppletContext() {
        return context;
    }

    public void appletResize(int width, int height) {
        // we do nothing.
    }
}


class BeanContainerAppletContext implements AppletContext {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    Applet target;
    java.util.Hashtable imageCache = new java.util.Hashtable();

    BeanContainerAppletContext(Applet target) {
        this.target = target;
    }

    public AudioClip getAudioClip(URL url) {
        // We don't currently support audio clips in the Beans.instantiate
        // applet context, unless by some luck there exists a URL content
        // class that can generate an AudioClip from the audio URL.
        try {
            return (AudioClip) url.getContent();
        } catch (Exception ex) {
            return null;
        }
    }

    public synchronized Image getImage(URL url) {
        Object o = imageCache.get(url);
        if (o != null) {
            return (Image)o;
        }
        try {
            o = url.getContent();
            if (o == null) {
                return null;
            }
            if (o instanceof Image) {
                imageCache.put(url, o);
                return (Image) o;
            }
            // Otherwise it must be an ImageProducer.
            Image img = target.createImage((java.awt.image.ImageProducer)o);
            imageCache.put(url, img);
            return img;

        } catch (Exception ex) {
            return null;
        }
    }

    public Applet getApplet(String name) {
        return null;
    }

    public java.util.Enumeration getApplets() {
        java.util.Vector applets = new java.util.Vector();
        applets.addElement(target);
        return applets.elements();
    }

    public void showDocument(URL url) {
        // We do nothing.
    }

    public void showDocument(URL url, String target) {
        // We do nothing.
    }

    public void showStatus(String status) {
        // We do nothing.
    }
}
