//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27, 180
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.14 com/java/src/com/ibm/beans/samples/script/form/BeanPalette.java, bbScripting, bb97c, bb97c9750e 11/12/97 13:35:25 [12/11/97 16:54:24]

/**
 * The BeanPalette is a panel that shows icons and ID strings
 * for the available JavaBeans in the current BeanBoxFrame.
 */

package com.ibm.beans.samples.script.form;

import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import com.ibm.beans.samples.script.form.BeanContainer;
import com.ibm.beans.samples.script.form.Session;
import com.ibm.beans.util.BeanSystem;

// We currently keep all the contents of the BeanPalette in a separate
// BeanPalettePanel object, to workaround win32 bug #4028421   KGH 1/28/97

class BeanPalette extends Frame implements WindowListener, KeyListener{
    private BeanPalettePanel panel;
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    BeanPalette(int x, int y, Session session, String jarDirName) {
	super("BeanPalette");

	setLayout(null);
	setBackground(Color.lightGray);
	setFont(new Font("serif", Font.PLAIN, 10));

        addWindowListener(this);
	panel = new BeanPalettePanel(this, session, jarDirName);
        panel.addKeyListener(this);
	add(panel);
	panel.setLocation(0,0);

	setLocation(x, y);
        setResizable (false);
	show();
    }

    Vector getLoadedJarInfo() {
	return panel.getLoadedJarInfo();
    }

    public synchronized Component getComponentToInsert(String cls_name) {
      if(cls_name == null)
         return panel.buildComponent();
      return panel.buildComponentByClassName(cls_name);
    }

    void addBeansInJar(String jarFile) {
	panel.addBeansInJar(jarFile);
    }

     public void windowOpened(WindowEvent event)
     {
     }
     public void windowClosed(WindowEvent event)
     {
     }


     public void windowActivated(WindowEvent event)
     {
     }

     public void windowDeactivated(WindowEvent event)
     {
     }

     public void windowClosing(WindowEvent event)
     {
        System.exit(0);
     }

     public void windowDeiconified(WindowEvent event)
     {
     }


     public void windowIconified(WindowEvent event)
     {
     }

     public void keyPressed(KeyEvent event)
     {
        if(event.getKeyCode() == 27)// this is stupid way but java does it too
        {
            panel.abortInsertMode();
        }
     }     
     public void keyReleased(KeyEvent event)
     {
     }     
     public void keyTyped(KeyEvent event)
     {
     }
  /*     
    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
        if (evt.id == Event.KEY_PRESS) {
           if (evt.key == 27) // this is stupid way but java does it too
           {
               panel.abortInsertMode();
               return true;
           }
        }
	return true;
    }
    */
}

class BeanPalettePanel extends Panel implements MouseListener{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    Session fSession;

    BeanPalettePanel(Frame frame, Session s, String jarDirName) {
	this.frame = frame;
        fSession = s;
	setLayout(null);
	setBackground(Color.lightGray);
	setFont(new Font("serif", Font.PLAIN, 10));
        addMouseListener(this);
        rowNum = -1;

	    beanLabels.addElement(new String ("Bean Container"));
	    beanNames.addElement(new String ("Bean Container"));
	    beanIcons.addElement(null);
	    beanJars.addElement(null);

	    beanLabels.addElement(new String ("Text Field"));
	    beanNames.addElement(new String ("Text Field"));
	    beanIcons.addElement(null);
	    beanJars.addElement(null);

	    beanLabels.addElement(new String ("Label"));
	    beanNames.addElement(new String ("Label"));
	    beanIcons.addElement(null);
	    beanJars.addElement(null);

	    beanLabels.addElement(new String ("Check Box"));
	    beanNames.addElement(new String ("Check Box"));
	    beanIcons.addElement(null);
	    beanJars.addElement(null);


	    beanLabels.addElement(new String ("Text Area"));
	    beanNames.addElement(new String ("Text Area"));
	    beanIcons.addElement(null);
	    beanJars.addElement(null);

	Vector jarNames = getJarNames(jarDirName);	
	for (int i = 0; i < jarNames.size(); i++) {
	    String name = (String)jarNames.elementAt(i);
	    addBeansInJar(name);
	}

    }

    public synchronized void abortInsertMode() {

        if (rowNum != -1) {
            rowNum = -1;
            repaint();
        }
    }


    // keep it with package scope for the inner class' sake
    void addWithUniqueName(Vector v, String s) {
	if (! v.contains(s)) {
	    debug("adding "+s);
	    v.addElement(s);
	    return;
	}
	int count = 2;
	while (v.contains(s+"<"+count+">")) {
	    count += 1;
	}
	debug("adding "+s+"<"+count+">");
	v.addElement(s+"<"+count+">");
	return;
    }

    private class Helper implements DoOnBean {
      //private static final String kBeanExtenderIBMCopyright=
      //           "(c) Copyright IBM Corporation 1997";
	public void action(JarInfo ji, BeanInfo bi, String beanName) {
	    String label;
	    Image img = null;

	    BeanDescriptor bd = bi.getBeanDescriptor();
	    debug("Helper.action; beanName: "+beanName);
	    debug("  beanName:  "+beanName);
	    debug("  getName(): "+bd.getName());
	    debug("  getBeanClass(): "+bd.getBeanClass());

	    Class beanClass = bd.getBeanClass();
	    if (beanName.equals(beanClass.getName())) {
		label = bi.getBeanDescriptor().getDisplayName();
		img = bi.getIcon(BeanInfo.ICON_COLOR_16x16);
	    } else {
	        label = beanName;
		int ix = beanName.lastIndexOf('.');
		if (ix >= 0) {
		    label = beanName.substring(ix+1);
		}
		img = null;
	    }
	    addWithUniqueName(beanLabels, label);
	    beanNames.addElement(beanName);
	    beanIcons.addElement(img);
	    beanJars.addElement(ji);
	}
	public void error(String msg) {
	    BeanPalettePanel.this.error(msg);
	}
	public void error(String msg, Exception ex) {
	    BeanPalettePanel.this.error(msg, ex);
	}
    }

    private Helper helper = new Helper();

    /**
     * Add all the beans in a Jar file into the BeanPalette
     */
    synchronized void addBeansInJar(String jarFile) {
	JarLoader.loadJarDoOnBean(jarFile, helper);
	doLayout();
    }

    public void doLayout() {
	topPad = frame.getInsets().top;
	sidePad = frame.getInsets().left;

	int height = topPad + (rowHeight * beanLabels.size()) + 6 + frame.getInsets().bottom;
        if (height != getSize().height) {
	    setSize(145, height);
	    frame.setSize(145, height);
	}
    }

    public void paint(Graphics g) {
	for (int i = 0; i < beanLabels.size(); i++) {
	    String name = (String)beanLabels.elementAt(i);
 
            if (i == rowNum)
                g.setFont(new Font("serif", Font.BOLD, 10));

	    g.drawString(name, sidePad + 21, topPad + (rowHeight*i) + rowHeight-4);
            if (i == rowNum)
                g.setFont(new Font("serif", Font.PLAIN, 10));

	    Image img = (Image)beanIcons.elementAt(i);
	    if (img != null) {
	        boolean status =
		    g.drawImage(img, sidePad+2, topPad + (rowHeight*i) + 2, 16, 16, this);
	    }
	}
    }

    public void mouseClicked(MouseEvent evt)
    {
    }
    public void mouseEntered(MouseEvent evt)
    {
    }
    public void mouseExited(MouseEvent evt)
    {
    }
    public void mousePressed(MouseEvent evt)
    {
    }
    public void mouseReleased(MouseEvent evt)
    {
      //looks like we need to select a bean for inserttion
      int oldNum = rowNum;
      rowNum = (evt.getY() - topPad)/rowHeight;
      if (rowNum >= beanNames.size()) { 
          abortInsertMode();
          return;
      }

      if (oldNum != rowNum)
          repaint();
    }
  /*
    public boolean handleEvent(Event evt) {

        if (evt.id == Event.MOUSE_UP) {

           //looks like we need to select a bean for inserttion
           int oldNum = rowNum;
           rowNum = (evt.y- topPad)/rowHeight;

           if (rowNum >= beanNames.size()) { 
               abortInsertMode();
               return true;
           }

           if (oldNum != rowNum)
               repaint();
           return true;
        }
        return false;
    }

    public synchronized Component buildComponent () {

        if (rowNum == -1)
            return null;

        Component comp = null;
        if (rowNum == 0) {

            //instantiate a bean container
            BeanContainer c = new BeanContainer(fSession, false);
            c.setSize (150, 150);
            comp = (Component)c;
        }
        else if (rowNum == 1) {

            //instantiate a bean container
            TextField c = new TextField("text field");
            comp = (Component)c;
        }
        else if (rowNum == 2) {

            //instantiate a bean container
            Label c = new Label("label");
            comp = (Component)c;
        }

        else if (rowNum == 3) {

            //instantiate a bean container
            Checkbox c = new Checkbox("checkbox label");
            comp = (Component)c;
        }

        else if (rowNum == 4) {

            //instantiate a bean container
            TextArea c = new TextArea("text area");
            comp = (Component)c;
        }

        else {

            String beanName = (String) beanNames.elementAt(rowNum);
            JarInfo ji = (JarInfo) beanJars.elementAt(rowNum);
            try {

                Object o = ji.getInstance(beanName);
                comp = (Component) Beans.getInstanceOf(o,
                                         Component.class);

                if (comp == null)
                    System.out.println("Could not instantiate class");

            } catch (Exception ex) {
                System.out.println ("instantiation of a new bean failed");
            }
        }

        rowNum = -1;
        repaint();
        return comp;
    }

    */

    public synchronized Component buildComponent () {

        String cls_name;
        if (rowNum == -1)
            return null;

        Component comp = null;
        if (rowNum == 0) {
            cls_name = "com.ibm.beans.samples.script.form.BeanContainer";
        }
        else if (rowNum == 1) {
            cls_name = "java.awt.TextField";
        }
        else if (rowNum == 2) {
            cls_name = "java.awt.Label";
        }
        else if (rowNum == 3) {
            cls_name = "java.awt.Checkbox";
        }

        else if (rowNum == 4) {
            cls_name = "java.awt.TextArea";
        }

        else {
            cls_name = (String) beanNames.elementAt(rowNum);
        }
        comp = buildComponentByClassName(cls_name);
        rowNum = -1;
        repaint();
        return comp;
    }


    public synchronized Component buildComponentByClassName(String cls_name)
    {
        Component comp = null;
        if (cls_name.equals("com.ibm.beans.samples.script.form.BeanContainer"))
	{

            //instantiate a bean container
            BeanContainer c = new BeanContainer(fSession, false);
            c.setSize (150, 150);
            comp = (Component)c;
        }
        else if (cls_name.equals("java.awt.TextField"))
	{

            //instantiate a bean container
            TextField c = new TextField("text field");
            comp = (Component)c;
        }
        else if (cls_name.equals("java.awt.Label")) {

            //instantiate a bean container
            Label c = new Label("label");
            comp = (Component)c;
        }

        else if (cls_name.equals("java.awt.Checkbox")) {

            //instantiate a bean container
            Checkbox c = new Checkbox("checkbox label");
            comp = (Component)c;
        }

        else if (cls_name.equals("java.awt.TextArea")) {

            //instantiate a bean container
            TextArea c = new TextArea("text area");
            comp = (Component)c;
        }

        else {
            try {

                Object o = Beans.instantiate(null, cls_name);
                comp = (Component) Beans.getInstanceOf(o,
                                         Component.class);

                if (comp == null)
                    System.out.println("Could not instantiate class");

            } catch (Exception ex) {
                System.out.println ("instantiation of a new bean failed");
                ex.printStackTrace();
            }
        }
        return comp;
    }




    /**
     * Provide information on all the loaded JAR files, regardless of origin.
     */
    public Vector getLoadedJarInfo() {
	return beanJars;
    }

    private static Vector getJarNames(String jarDirName) {

        File jars = null;

        if (jarDirName == null) {
            try {
                File cwd = BeanSystem.getWorkingDirectory(); 

                if (cwd == null) {
                    System.out.println (
                             "working dir prop not found");
                    System.exit(0);
                }
                jars = new File(cwd, "jars");
            }
            catch (Exception exp) {
                System.out.println ("Bean Palette: Cannot find working dir");
                exp.printStackTrace();
                System.exit(0);
            }
        }
        else
            jars = new File (jarDirName);

	if (! jars.isDirectory()) {
	    System.err.println(jars+" is not a directory!!");
            System.exit(0);
	}

	Vector result = new Vector();
	String names[];
	names = jars.list(new FileExtension(".jar"));
	for (int i=0; i<names.length; i++) {
	    result.addElement(jars.getPath() + File.separatorChar + names[i]);
	}
	names = jars.list(new FileExtension(".JAR"));
	for (int i=0; i<names.length; i++) {
	    result.addElement(jars.getPath() + File.separatorChar + names[i]);
	}

	return result;
    }

    public void error(String message, Exception ex) {
	String mess = message + ":\n" + ex;
	System.err.println(message);
	ex.printStackTrace();
	// Popup an ErrorDialog with the given error message.
	new ErrorDialog(frame, mess);

    }

    public void error(String message) {
	String mess = message;
	System.err.println(message);
	// Popup an ErrorDialog with the given error message.
	new ErrorDialog(frame, mess);

    }

    static  void debug(String msg) {
	if (debug) {
	    System.err.println("BeanPalette:: "+msg);
	}
    }

    Vector beanLabels = new Vector();
    Vector beanNames = new Vector();
    Vector beanIcons = new Vector();
    Vector beanJars = new Vector();
    private int topPad = 0;
    private int sidePad = 0;
    private final static int rowHeight = 20;
    private static boolean debug = false;
    private Object pendingBean;
    private Frame frame;

    private int rowNum = -1;

    private static Cursor crosshairCursor = Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR);
    private static Cursor defaultCursor = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);
}


// Auxiliary class

class FileExtension implements FilenameFilter {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    private String extension;

    public FileExtension(String ext) {
	this.extension = ext;
    }
    
    public boolean accept(File dir, String name) {
	return name.endsWith(extension);
    }
}
