//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.15 com/java/src/com/ibm/beans/samples/script/form/FormRunner.java, bbScripting, bb97c, bb97c9750e 9/30/97 15:36:35 [12/11/97 16:54:44]

package com.ibm.beans.samples.script.form;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;

import com.ibm.beans.samples.script.form.RTSession;


public class FormRunner extends Frame implements WindowListener{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    private RTSession fSession = null;
    public boolean shouldClose = true;
    private BeanContainer owner;
    private boolean auto;
 
    public FormRunner (String label, String filename, boolean dbg, 
                       BeanContainer own)
    {
        super (label);

        owner = own;
        setBackground(Color.black);
        setLocation (150, 20);
        auto = true;
        fSession = new RTSession (this, filename, true, dbg);
        addWindowListener(this);
    }

    public FormRunner (String label, String argv[]) {
        super (label);


        String fileName = null;
	auto = false;
        boolean withDebug = false;
        owner = null;
	if (argv != null)
	  for (int i = 0;  i < argv.length; i++)
	    {
	      if (argv[i].equalsIgnoreCase("-auto"))
		auto = true;
              else if(argv[i].equalsIgnoreCase("-autoDebug"))
	      {
                auto = true;
                withDebug =true;
              }
	      else if (fileName == null)
		fileName = argv[i];
	    }


        setBackground(Color.black);
        setLocation (150, 20);

        fSession = new RTSession (this, fileName, auto, withDebug);
        addWindowListener(this);
    }

    public boolean terminate()
    {
       if(owner != null)
       {
          removeWindowListener (owner);
          owner.formRunnerDeleted();
          dispose();
          return(fSession.terminate());
       }
       else if(auto)
       {
          fSession.terminate();
          System.exit(0);
       }
       return(fSession.terminate());
     }
     public void windowOpened(WindowEvent event)
     {
     }
     public void windowClosed(WindowEvent event)
     {
     }


     public void windowActivated(WindowEvent event)
     {
     }

     public void windowDeactivated(WindowEvent event)
     {
     }

     public void windowClosing(WindowEvent event)
     {
         if (shouldClose == true)
            System.exit(terminate() ? 1 : 0);
         else 
            this.setVisible (false);
     }

     public void windowDeiconified(WindowEvent event)
     {
     }


     public void windowIconified(WindowEvent event)
     {
     }


  /*

    public boolean handleEvent (Event evt) {

        if (evt.id == Event.WINDOW_DESTROY) {

            if (shouldClose == true)
                System.exit(terminate() ? 1 : 0);
            else 
                this.setVisible (false);
        }

        if (evt.id == Event.ACTION_EVENT && evt.target instanceof MenuItem)
            return fSession.doMenuItem(evt);
      
        return false;
    }
    */
    public RTSession getRTSession () {
        return fSession;
    }

    public static void main (String [] argv) {

        FormRunner ff = new FormRunner("Run Form..", argv);
        ff.show();
    }

}
