//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.16 com/java/src/com/ibm/beans/samples/script/form/RTSession.java, bbScripting, bb97c, bb97c9750e 9/30/97 15:37:10 [12/11/97 16:54:33]


package com.ibm.beans.samples.script.form;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import com.ibm.beans.samples.script.form.FormRunner;
import com.ibm.beans.samples.script.form.BeanContainer;

public class RTSession implements ActionListener{
        private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
        public RTSession (FormRunner runner, String fName, 
              boolean newAutoRun, boolean withDebug) {

        formRunner = runner;
        autoRun = newAutoRun;

	if (! autoRun)
	  {
            MenuBar menuBar = createBaseMenu();
            formRunner.setMenuBar (menuBar);
          }

        rootComponent = loadScript (fName);

        if (rootComponent == null) {
            System.out.println ("No script found ");
            System.exit (0);
        } 

        formRunner.add("Center", rootComponent);

	if (autoRun)
	  {
            ((BeanContainer)rootComponent).runRequest (withDebug, withDebug);
	  }
    }

    private synchronized MenuBar createBaseMenu() {

        MenuBar mBar = new MenuBar();

        // File Menu
        Menu loadMenu = new Menu("File");
        MenuItem scriptItem = new MenuItem("Load Script");
        loadMenu.add (scriptItem);
        scriptItem.addActionListener(this);
        //MenuItem dataItem = new MenuItem("Load Data");
        //loadMenu.add (dataItem);
        //MenuItem saveItem = new MenuItem("Save Data");
        //loadMenu.add (saveItem);
        MenuItem sep1Item = new MenuItem("-");
        loadMenu.add (sep1Item);
        MenuItem exitItem = new MenuItem("Exit");
        loadMenu.add (exitItem);
        exitItem.addActionListener(this);

        // Script menu
        Menu scriptMenu = new Menu("Script");
        MenuItem runItem = new MenuItem("Run");
        scriptMenu.add (runItem);
        runItem.addActionListener(this);
        MenuItem debugItem = new MenuItem("Debug");
        scriptMenu.add (debugItem);
        debugItem.addActionListener(this);
        MenuItem terminateItem = new MenuItem("Terminate");
        scriptMenu.add (terminateItem);
        terminateItem.addActionListener(this);

        mBar.add (loadMenu);
        mBar.add (scriptMenu);

        return mBar;
    }

    public void actionPerformed(ActionEvent evt) {

        MenuItem mi = (MenuItem)evt.getSource();
        String label = mi.getLabel();

        if (label.equals ("Run"))
	{
            ((BeanContainer)rootComponent).runRequest (false, false);
        }
        if (label.equals ("Debug"))
	{
            ((BeanContainer)rootComponent).setFormRunning(formRunner);
            ((BeanContainer)rootComponent).runRequest (true, true);
        }
        else if (label.equals ("Terminate"))
            terminate();
        else if (label.equals("Exit"))
	  {
            System.exit (terminate()? 1 : 0);
	  }

        else if (label.equals("Load Script"))
        {
            BeanContainer newRoot = loadScript(null);
            if (newRoot != null) {

                if (rootComponent != null) {
                    formRunner.remove (rootComponent);
                    rootComponent = null;
                }
                rootComponent = newRoot;
                formRunner.add("Center", rootComponent);
            }
        }
    }

    private synchronized BeanContainer loadScript (String fName) {

        if (fName == null) {

            FileDialog fd = new FileDialog(formRunner, 
                            "Load Script", FileDialog.LOAD);
            fd.setDirectory(System.getProperty("user.dir"));
            fd.show();

            String fname = fd.getDirectory() + fd.getFile();

            if (fd.getFile() == null)
                return null;
            fileName = new String (fname);

        }
        else
            fileName = new String(fName);

        formRunner.setTitle (fileName);

        try {
            FileInputStream f = new FileInputStream(fileName);
            ObjectInput s = new ObjectInputStream(f);

            // read the form dimensions
            int fWidth = s.readInt();
            int fHeight = s.readInt();
            formRunner.setSize (fWidth, fHeight);

            BeanContainer cont = (BeanContainer) s.readObject();
            if (cont == null) {
                System.out.println ("root is null!!!!!!!!!!!!");
                return cont;
            }
            cont.setFormRunning(formRunner);
            
            f.close();

            return cont;

        } catch (Exception ex) {
            System.out.println ("Load failed " +  ex);
	    ex.printStackTrace();
        }

        return null;

    }

    public boolean terminate()
     {
         return (((BeanContainer)rootComponent).terminate ());
     }  

    FormRunner formRunner = null;
    String fileName = null;
    Component rootComponent = null;
    boolean autoRun;
}

