//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbScripting
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.29 com/java/src/com/ibm/beans/samples/script/form/Session.java, bbScripting, bb97c, bb97c9750e 11/11/97 17:27:43 [12/11/97 16:54:58]


package com.ibm.beans.samples.script.form;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import com.ibm.beans.samples.script.form.FormBuilder;
import com.ibm.beans.samples.script.form.BeanContainer;
import com.ibm.beans.samples.script.form.BeanPalette;
//import com.ibm.beans.script.demo.form.NameDialog;
import com.ibm.beans.script.SCRCodeGenUtils;

public class Session implements ActionListener{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    public Session (FormBuilder builder, String fName, String jarDirName) {

        formBuilder = builder;
        menuBar = createBaseMenu();
        formBuilder.setMenuBar (menuBar);

        pal = new BeanPalette (10, 10, this, jarDirName);
        nameDialog = new NameDialog (this, builder);

        if (fName == null)
            rootComponent = new BeanContainer(this, true);
        else
            rootComponent = loadForm(fName);

        if (rootComponent == null)
            rootComponent = new BeanContainer(this, true);

        activeComponent = rootComponent;
        activeParent = null;
        pal.show();
        formBuilder.add("Center", rootComponent);

    }

    public synchronized BeanPalette getPalette() {

        return pal;
    }

    public synchronized Component getActiveComponent(BeanContainer c) {

        if (activeParent == c)
            return activeComponent;
        else
            return null;
    }

    public synchronized void setActiveComponent(Component c, BeanContainer p) {

        if (activeComponent == c)
           return;

        if (((Container)rootComponent).isAncestorOf (c) == false &&
            c != rootComponent) {
            return;
        }

        BeanContainer oldParent = activeParent;

        activeComponent = c;
        activeParent = p;

        if (activeParent != null)
            activeParent.repaint();
        if ((oldParent != null) && (activeParent != oldParent))
            oldParent.repaint();

    }

    private synchronized MenuBar createBaseMenu() {

        MenuBar mBar = new MenuBar();

        // File Menu
        docMenu = new Menu("Form");
        //MenuItem newItem = new MenuItem("New");
        //docMenu.add (newItem);
        MenuItem openItem = new MenuItem("Load");
        docMenu.add (openItem);
        openItem.addActionListener(this);
        MenuItem saveItem = new MenuItem("Save");
        docMenu.add (saveItem);
        saveItem.addActionListener(this);
        MenuItem saveAsItem = new MenuItem("Save As");
        docMenu.add (saveAsItem);
        saveAsItem.addActionListener(this);
        MenuItem importItem = new MenuItem("Import");
        docMenu.add (importItem);
        importItem.addActionListener(this);
        MenuItem exportItem = new MenuItem("Export");
        docMenu.add (exportItem);
        exportItem.addActionListener(this);
        MenuItem deployItem = new MenuItem("Deploy for run");
        docMenu.add (deployItem);
        deployItem.addActionListener(this);
        MenuItem depdebItem = new MenuItem("Deploy for debug");
        docMenu.add (depdebItem);
        depdebItem.addActionListener(this);
        MenuItem sep1Item = new MenuItem("-");
        docMenu.add (sep1Item);
        MenuItem exitItem = new MenuItem("Exit");
        docMenu.add (exitItem);
        exitItem.addActionListener(this);

        mBar.add (docMenu);

        // Edit menu
        editMenu = new Menu("Edit");
        MenuItem deleteItem = new MenuItem("Delete");
        editMenu.add (deleteItem);
        deleteItem.addActionListener(this);
        MenuItem renameItem = new MenuItem("Rename");
        editMenu.add (renameItem);
        renameItem.addActionListener(this);
        MenuItem sep2Item = new MenuItem("-");
        editMenu.add (sep2Item);
        scrEditMenu = new Menu("Edit Script");

	//        MenuItem javaEditItem = new MenuItem("Java");
        scrEditMenu.add ("Java");
        scrEditMenu.add ("NetReXX");
        scrEditMenu.getItem(0).addActionListener(this);
        scrEditMenu.getItem(1).addActionListener(this);
        //MenuItem netrexxEditItem = new MenuItem("NetReXX");

        editMenu.add (scrEditMenu);

        scrRunItem = new MenuItem("Deploy and Run");
        editMenu.add (scrRunItem);
        scrRunItem.addActionListener(this);

        MenuItem scrDebugItem = new MenuItem("Deploy and Debug");
        editMenu.add (scrDebugItem);
        scrDebugItem.addActionListener(this);

        mBar.add (editMenu);


        return mBar;
    }

    public void actionPerformed(ActionEvent evt) {

        MenuItem mi = (MenuItem)evt.getSource();
        MenuContainer parent = mi.getParent();
        String label = mi.getLabel();

        if (parent == docMenu) {

            if (label.equals("Exit"))
                System.exit(0);

            else if (label.equals("Save"))
                saveForm();

            else if (label.equals("Save As"))
                saveAsForm();

            else if (label.equals("Import"))
                importForm();
            else if (label.equals("Export"))
                exportForm();
            else if (label.equals("Load"))
                loadForm();

        }
        if(parent == scrEditMenu)
        {
           if ((label.equals("Java") || label.equals("NetReXX"))&&
               (activeComponent.getClass().getName().equals(
                         "com.ibm.beans.samples.script.form.BeanContainer")))
           {
               ((BeanContainer)activeComponent).editScript(label);

           }
        }
        if (label.equals("Edit Script") &&
               (activeComponent.getClass().getName().equals("com.ibm.beans.samples.script.form.BeanContainer")))
        {
            ((BeanContainer)activeComponent).editScript("Java");

        }
        else if (label.equals("Deploy and Run")) 
        {
            BeanContainer b = (BeanContainer) rootComponent;

            if ((activeComponent != null) && (activeComponent != rootComponent)) {
                if (activeComponent.getClass().getName().equals 
                     ("com.ibm.beans.samples.script.form.BeanContainer"))
                    b = (BeanContainer) activeComponent;
            }

            b.runRequest(false, false);

        }
        else if (label.equals("Deploy and Debug")) 
        {
            BeanContainer b = (BeanContainer) rootComponent;

            if ((activeComponent != null) && (activeComponent != rootComponent)) {
                if (activeComponent.getClass().getName().equals 
                     ("com.ibm.beans.samples.script.form.BeanContainer"))
                    b = (BeanContainer) activeComponent;
            }

            b.runRequest(true, true);

        }

        else if (label.equals ("Deploy for run"))
        {
            BeanContainer b = (BeanContainer) rootComponent;

            if ((activeComponent != null) && (activeComponent != rootComponent)) {
                if (activeComponent.getClass().getName().equals 
                     ("com.ibm.beans.samples.script.form.BeanContainer"))
                    b = (BeanContainer) activeComponent;
            }

            doDeploy ((BeanContainer)b, null, false);
        }
        else if (label.equals ("Deploy for debug"))
        {
            BeanContainer b = (BeanContainer) rootComponent;

            if ((activeComponent != null) && (activeComponent != rootComponent)) {
                if (activeComponent.getClass().getName().equals 
                     ("com.ibm.beans.samples.script.form.BeanContainer"))
                    b = (BeanContainer) activeComponent;
            }

            doDeploy ((BeanContainer)b, null, true);
        }

        else if (label.equals("Delete"))
        {
            if ((activeParent != null) && (activeComponent != null)) {
                activeParent.deleteChild (activeComponent);
                activeParent = null;
                activeComponent = rootComponent;
                pal.show();
            }
        }

        else if (label.equals("Rename")) 
        {
            if ((activeParent != null) && (activeComponent != null))
                activeParent.renameChild (activeComponent);
        }
    }

    public synchronized void getNewName () {

        nameDialog.showNameDialog (activeParent, activeComponent);
    } 

    public synchronized void showPopup (PopupMenu pp) {

        formBuilder.add(pp);
        pp.show(formBuilder, 10, 10);
    }

    public synchronized void removePopup (PopupMenu pp) {

        formBuilder.remove (pp);
    }

    private synchronized void saveForm () {

        if (fileName == null) {
            saveAsForm();
            return;
        }

        try {
            FileOutputStream f = new FileOutputStream(fileName);
            ObjectOutput s = new ObjectOutputStream(f);

            // write out the form dimensions
            s.writeInt (formBuilder.getSize().width);
            s.writeInt (formBuilder.getSize().height);

            s.writeObject(rootComponent);

            s.flush();
            f.close();

        } catch (Exception ex) {
            System.out.println ("Save failed " + ex);
        }

    }

    private synchronized void saveAsForm () {

        FileDialog fd = new FileDialog(formBuilder, "Save File", FileDialog.SAVE);
        fd.setDirectory(System.getProperty("user.dir"));
        fd.setFile("NewDoc.ser");
        fd.show();

        String fname = fd.getDirectory() + fd.getFile();

        if (fd.getFile() == null) {
            return;
        }

        fileName = new String (fname);
        saveForm ();
        renameFormBuilder ();

    }

    private synchronized void importForm () {

        FileDialog fd = new FileDialog(formBuilder, "Import File", 
                                 FileDialog.LOAD);
        fd.setDirectory(System.getProperty("user.dir"));
        fd.setFile("NewDoc.ser");
        fd.show();

        String fname = fd.getDirectory() + fd.getFile();

        if (fd.getFile() == null) {
            return;
        }
        try
	{
           FileReader frder = new FileReader(fname);
           BufferedReader in = new BufferedReader(frder);
           BeanContainer bcon = new BeanContainer(this, true);
           formBuilder.remove(rootComponent);
           rootComponent = null;
           rootComponent = bcon;
           formBuilder.add("Center", rootComponent);
           rootComponent.setLocation(0, 30);
           activeComponent = rootComponent;
           activeParent = null;
           pal.show();
           bcon.importScript(in);
           in.close();
           fileName = null;
           renameFormBuilder ();
           formBuilder.repaint();
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }

    }


    private synchronized void exportForm () {

        FileDialog fd = new FileDialog(formBuilder, "Export File", 
                                 FileDialog.SAVE);
        fd.setDirectory(System.getProperty("user.dir"));
        fd.setFile("NewDoc.ser");
        fd.show();
        
        String fname = fd.getDirectory() + fd.getFile();

        if (fd.getFile() == null) {
            return;
        }
        try
	{
           FileWriter fwrter = new FileWriter(fname);
           BufferedWriter out = new BufferedWriter(fwrter);
           ((BeanContainer)rootComponent).exportScript(out);
           out.close();
        }
        catch(Exception e)
	{
           e.printStackTrace();
        }
    }


    private synchronized void loadForm() {

        FileDialog fd = new FileDialog(formBuilder, "Load File", FileDialog.LOAD);
        fd.setDirectory(System.getProperty("user.dir"));
        fd.setFile("NewDoc.ser");
        fd.show();

        String fname = fd.getDirectory() + fd.getFile();
        if (fd.getFile() == null) {
            return;
        }

        BeanContainer c = loadForm(fname);

        if (c != null) {

            formBuilder.remove(rootComponent);
            rootComponent = null;

            rootComponent = c;
            formBuilder.add("Center", rootComponent);
            activeComponent = rootComponent;
            activeParent = null;
            pal.show();
        }
    }

    private synchronized BeanContainer loadForm(String fName) {

        fileName = new String(fName);
        renameFormBuilder();

        try {
            FileInputStream f = new FileInputStream(fileName);
            ObjectInput s = new ObjectInputStream(f);

            // read the form dimensions
            int fWidth = s.readInt();
            int fHeight = s.readInt();
            formBuilder.setSize (fWidth, fHeight);

            BeanContainer cont = (BeanContainer) s.readObject();
            if (cont == null) {
                System.out.println ("root is null!!!!!!!!!!!!");
                return cont;
            }

            cont.setSession(this);
            f.close();

            return cont;

        } catch (Exception ex) {
            System.out.println ("Load failed " +  ex);
	    ex.printStackTrace();
        }

        return null;

    }

    private synchronized void renameFormBuilder() {

        String s = new String ("Form: " + fileName);
        formBuilder.setTitle(s);

    }

    public synchronized boolean doDeploy (BeanContainer b, 
           String strFileName, boolean withDebug) {

        String fname;

        if (strFileName == null) {
            FileDialog fd = new FileDialog(formBuilder, "Deploy..", 
                                                  FileDialog.SAVE);
            fd.setDirectory(System.getProperty("user.dir"));
            fd.setFile("Deploy1.ser");
            fd.show();
        
            if (fd.getFile() == null)
                return false; 
            fname = fd.getDirectory() + fd.getFile();
        }
        else
            fname = strFileName;

        try {
            FileOutputStream f = new FileOutputStream(fname);
            ObjectOutput s = new ObjectOutputStream(f);

            // write out the form dimensions
            s.writeInt (b.getSize().width +
                 formBuilder.getSize().width - rootComponent.getSize().width);
            s.writeInt (b.getSize().height +
                 formBuilder.getSize().height - rootComponent.getSize().height);

            boolean retVal = ((BeanContainer)b).setRunning (true, withDebug);
            if (retVal == true) {
                s.writeObject(b);
                ((BeanContainer)b).setRunning (false, withDebug);
            }

            s.flush();
            f.close();

            return retVal;

        } catch (Exception ex) {
            System.out.println ("Save failed " + ex);
            ((BeanContainer)rootComponent).setRunning (false, withDebug);
        }
 
        return false;
    }

    public void terminate() {
            BeanContainer b = (BeanContainer) rootComponent;

            if ((activeComponent != null) && (activeComponent != rootComponent)) {
                if (activeComponent.getClass().getName().equals 
                     ("com.ibm.beans.samples.script.form.BeanContainer"))
                    b = (BeanContainer) activeComponent;
            }
            b.terminate();

        }

    MenuBar menuBar = null;
    Menu docMenu = null;
    Menu editMenu = null;
    Menu scrEditMenu = null;
    MenuItem scrRunItem;

    FormBuilder formBuilder = null;
    String fileName = null;
    BeanPalette pal;
    NameDialog nameDialog = null;

    Component activeComponent = null;
    BeanContainer activeParent = null;
    Component rootComponent = null;
}

class NameDialog extends Dialog implements ActionListener  {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    private Button okButton;
    private Button cancelButton;
    private TextField textArea;
    Frame frame;

    BeanContainer parentComp;
    Component child;

    public NameDialog (Session s, FormBuilder f) {

        super (f, "Change Name..", false);
        frame = f;
        setSize (200, 100);
        setLayout (null);
        
        okButton = new Button ("Ok");
        okButton.setSize (50, 20);
        cancelButton = new Button ("Cancel");
        cancelButton.setSize (50, 20);
        textArea = new TextField("", 1);
        textArea.setSize (150, 20);

        okButton.addActionListener (this);
        cancelButton.addActionListener (this);
        textArea.addActionListener (this);

        add (okButton);
        okButton.setLocation (40, 65);
        add (cancelButton);
        cancelButton.setLocation (110, 65);
        add (textArea);
        textArea.setLocation (25, 30);

    }

    public void actionPerformed (ActionEvent e) {

        String newName;

        if (e.getSource () == okButton)
            newName = new String (textArea.getText());
        else
            newName = null;
        setVisible (false);

        parentComp.setNewName (child, newName);
    }

    public void showNameDialog (BeanContainer b, Component c) {

        Point p = frame.getLocation();
        setLocation (p.x + 10, p.y + 50);
        setVisible (true);
 
        parentComp = b;
        child = c;
    }


}

