//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.12 com/java/src/com/ibm/beans/tools/debugger/BeanDbgFrame.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:00:42 [12/11/97 17:00:30]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;
import com.ibm.beans.tools.debugger.BeanDbgView;

public class BeanDbgFrame extends Frame 
{

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

private DebuggerResourceBundle DBResourceBundle;
private BeanDbgView beanDbgView;

public static final int TOP_MARGIN    = 20;
public static final int LEFT_MARGIN   = 5;
public static final int BOTTOM_MARGIN = 5;
public static final int RIGHT_MARGIN  = 5;

public BeanDbgFrame(String title, String argv[])
  {
   super(title);
   setLayout(null);

   createBeanBuggerView(argv, null);
  }


public BeanDbgFrame(String title, String argv[], BeanDebugger bdbg)
  {
   super(title);
   setLayout(null);

   createBeanBuggerView(argv, bdbg);
  }


public BeanDbgFrame(String title, BeanDbgView view)
  {
   super(title);
   setLayout(null);
   beanDbgView = view;
   initBeanBuggerView();
  }


private void createBeanBuggerView(String argv[], BeanDebugger bdbg)
  {
   beanDbgView = new BeanDbgView (argv, bdbg);
   initBeanBuggerView();
  }


private void initBeanBuggerView()
  {
   add(beanDbgView);

   Dimension d = beanDbgView.getPreferredSize();

   if (d.width == 0 && d.height == 0)
     d = new Dimension(700, 600);

   setSize(d);

   beanDbgView.setFrame(this);
  }


public void doLayout()
  {


   int hdiff = BOTTOM_MARGIN + TOP_MARGIN;
   int wdiff = LEFT_MARGIN + RIGHT_MARGIN;

   Dimension d = getSize();

   beanDbgView.setBounds(LEFT_MARGIN,
                         TOP_MARGIN,
                         d.width - wdiff,
                         d.height - hdiff);
  }

public int closeDebugger ()
  {

   return beanDbgView.Close();
  }


}
