//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.10 com/java/src/com/ibm/beans/tools/debugger/BeanDbgView.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:00:48 [12/11/97 17:00:31]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.ibm.beans.widgets.SplitPanelListener;
import com.ibm.beans.widgets.SplitPanel;
import com.ibm.beans.widgets.ToolTipCanvas;
import com.ibm.beans.widgets.ImageButton;
import com.ibm.beans.widgets.SplitPanelEvent;
import com.ibm.beans.util.BeanSystem;

import com.ibm.beans.tools.debugger.DebuggerPanel;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;
import com.ibm.beans.tools.debugger.TextDialog;


public class BeanDbgView extends Panel implements 
                                 ActionListener, SplitPanelListener
{
    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

protected DebuggerResourceBundle res;

public static final int MARGINS=5;
public static final int BUTTON_WIDTH=30;
public static final int BUTTON_HEIGHT=30;
public static final int BUTTON_MARGIN=BUTTON_HEIGHT+MARGINS;
protected static int TIP_HEIGHT=25;

protected ToolTipCanvas tip;
protected Frame frame;
protected SplitPanel splitPanel;
protected Vector debuggerPanels;
protected int buttonEnd;
protected TextDialog textDialog;

protected BeanDebugger beanDebugger;

/********************************************************
 Constructors
********************************************************/

public BeanDbgView ()
{
    super();
    internalInit();
}

public BeanDbgView (String argv[], BeanDebugger bdbg)
{
    super();
    internalInit();

    if (bdbg == null)
        beanDebugger = createBeanDebugger(argv); 
    else {
        beanDebugger = bdbg;
        beanDebugger.setBeanDbgView (this);
    }

    try {

        File ff = BeanSystem.getWorkingDirectory();
        String fName = ff.getAbsolutePath() + File.separator + 
                           getSavedFileName();
        FileInputStream f = new FileInputStream(fName);
        ObjectInput s = new ObjectInputStream(f);
  
        readState (s);
        f.close();

    } catch (Exception ex) {

       splitPanel = new SplitPanel();
       if (ex.getClass().getName().equals 
                        ("java.io.FileNotFoundException") == false)
           ex.printStackTrace();
    }

    {
        splitPanel.addSplitPanelListener(this);
        add(splitPanel);
        updateContext (beanDebugger.getThreadContext());
    }
}

protected void readState (ObjectInput s) throws Exception {

        splitPanel = (SplitPanel)s.readObject ();
        debuggerPanels = (Vector)s.readObject ();


}

/********************************************************
 Initialization
********************************************************/

protected void internalInit()
{

   setLayout(null);
   setBackground(new Color(200, 200, 200));

   debuggerPanels = new Vector();
   Image image;
   ImageButton b;

   frame = null;

   Rectangle tb = new Rectangle(1,1,1,1);

   URL urlWithImage;

   res = DebuggerResourceBundle.getRes();
   image = res.getImage(DebuggerResourceBundle.JH_GIF);

 tip = new ToolTipCanvas (tb,
                            Color.black,
                            new Color(200, 200, 200),
                            image);

  add(tip);

  int nextX = 0;

  nextX = createImageButton(DebuggerResourceBundle.SPLITV_GIF,
                            DebuggerResourceBundle.SPLITV_CMD, 
                            DebuggerResourceBundle.SPLITV_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.SPLITH_GIF,
                            DebuggerResourceBundle.SPLITH_CMD, 
                            DebuggerResourceBundle.SPLITH_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.CONSOLE_GIF,
                            DebuggerResourceBundle.CONSOLE_CMD, 
                            DebuggerResourceBundle.CONSOLE_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.SOURCE_GIF,
                            DebuggerResourceBundle.SOURCE_CMD, 
                            DebuggerResourceBundle.SOURCE_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.VARIABLE_GIF,
                            DebuggerResourceBundle.VARIABLE_CMD, 
                            DebuggerResourceBundle.VARIABLE_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.STACK_GIF,
                            DebuggerResourceBundle.STACK_CMD, 
                            DebuggerResourceBundle.STACK_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.THREAD_GIF,
                            DebuggerResourceBundle.THREAD_CMD, 
                            DebuggerResourceBundle.THREAD_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.DEBUG_GIF,
                            DebuggerResourceBundle.DEBUG_CMD, 
                            DebuggerResourceBundle.DEBUG_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.STEP_GIF,
                            DebuggerResourceBundle.STEP_CMD, 
                            DebuggerResourceBundle.STEP_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.NEXT_GIF,
                            DebuggerResourceBundle.NEXT_CMD, 
                            DebuggerResourceBundle.NEXT_TIP, nextX);
  nextX = createImageButton(DebuggerResourceBundle.CONTINUE_GIF,
                            DebuggerResourceBundle.CONTINUE_CMD, 
                            DebuggerResourceBundle.CONTINUE_TIP, nextX);
  buttonEnd = nextX;

}

public void setFrame(Frame newFrame)
{
    frame = newFrame;
    addMenus(frame);
}


protected int createImageButton(String img_key, String cmd, String tip_key,
                  int start_x)
{
   ImageButton b;
   Image image = res.getImage(img_key);
   b = new ImageButton(new Rectangle(start_x, 0, BUTTON_WIDTH, BUTTON_HEIGHT),
                 MARGINS, new Color(200, 200, 200), image,cmd, tip, 
                 res.getString(tip_key));
   add(b);
   b.addActionListener(this);
   return(start_x + BUTTON_WIDTH);
}

public Frame getBeanDbgFrame() {
    return frame;
}

protected void addMenus(Frame frame)
{

}

public synchronized void doLayout()
{
    Dimension d = getSize();

    tip.setBounds(0, d.height - TIP_HEIGHT, d.width, TIP_HEIGHT);
    tip.doLayout();

    splitPanel.setBounds(0,
                        BUTTON_HEIGHT + MARGINS,
                        d.width,
                        d.height - (BUTTON_HEIGHT + MARGINS * 2 + TIP_HEIGHT));


    repaint();
}

protected BeanDebugger createBeanDebugger (String argv[]) {

    BeanDebugger bdbg = new BeanDebugger (argv, this);
    return bdbg;

}

/********************************************************
 Listener Methods
********************************************************/

public synchronized void componentAdded(SplitPanelEvent event)
{
    debuggerPanels.addElement(event.getComponent());
}

public synchronized void componentRemoved(SplitPanelEvent event)
{
    debuggerPanels.removeElement(event.getComponent());
}

public void actionPerformed(ActionEvent event)
{

    String cmd = event.getActionCommand();

    if (cmd == null)
        return;


    if (cmd.equals(DebuggerResourceBundle.SPLITH_CMD))
        splitPanel.splitActiveFrameH(null);

    else if (cmd.equals(DebuggerResourceBundle.SPLITV_CMD))
        splitPanel.splitActiveFrameV(null);

    else if (cmd.equals(DebuggerResourceBundle.DEBUG_CMD))
        showTextDialog ();

    else if (cmd.equals(DebuggerResourceBundle.CONSOLE_CMD))
        addDebuggerPanel(new ConsolePanel(beanDebugger.getThreadContext()));

    else if (cmd.equals(DebuggerResourceBundle.THREAD_CMD))
        addDebuggerPanel(new ThreadPanel(beanDebugger.getThreadContext()));

    else if (cmd.equals(DebuggerResourceBundle.VARIABLE_CMD))
        addDebuggerPanel(new VariablePanel(beanDebugger.getThreadContext()));

    else if (cmd.equals(DebuggerResourceBundle.STACK_CMD))
        addDebuggerPanel(new StackPanel(beanDebugger.getThreadContext()));

    else if (cmd.equals(DebuggerResourceBundle.SOURCE_CMD))
        addDebuggerPanel(new SourcePanel(beanDebugger.getThreadContext()));

    else if (cmd.equals(DebuggerResourceBundle.STEP_CMD))
    {
        beanDebugger.Step(null);
        setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
    }

    else if (cmd.equals(DebuggerResourceBundle.NEXT_CMD))
    {
        beanDebugger.Next(null);
        setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
    }

    else if (cmd.equals(DebuggerResourceBundle.CONTINUE_CMD))
    {
        beanDebugger.Cont(null);
        setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
    }

}


public synchronized void showTextDialog()
{

    if (textDialog == null)
       textDialog = new TextDialog(frame, false, 
           res.getString(DebuggerResourceBundle.CLASS_NAME_LABEL), this);

    Dimension d = textDialog.getSize();
    Rectangle r = frame.getBounds();
    Point p  = new Point(r.x + (r.width - d.width) /2,
          r.y + (r.height - d.height) /2);

    textDialog.setLocation (p);
    textDialog.show();
}

public synchronized void setClassAndArgs (String clsString, String argString)
{
   beanDebugger.startDebugging (clsString, argString); 
}


public synchronized void addDebuggerPanel(DebuggerPanel panel)
{
    splitPanel.addToLastActiveFrame(panel);
}

/********************************************************
 Etc.. Methods
********************************************************/


protected String getSavedFileName()
{
   return("beanDbgSave");
}

public int Close()
{

   // save the state
   
   try {

      File ff = BeanSystem.getWorkingDirectory();
      String fName = ff.getAbsolutePath() + File.separator + 
                         getSavedFileName();
      FileOutputStream f = new FileOutputStream(fName);
      ObjectOutput s = new ObjectOutputStream(f);

      writeState (s);

      s.flush();
      f.close();

   } catch (Exception ex) {
      ex.printStackTrace ();
   }

   return beanDebugger.Close();
}

protected void writeState (ObjectOutput out) throws IOException {

      splitPanel.removeSplitPanelListener (this);
      out.writeObject (splitPanel);
      splitPanel.addSplitPanelListener (this);
      out.writeObject (debuggerPanels);

}

public Vector getDebuggerPanels () {
    return debuggerPanels;
}

public ToolTipCanvas getTip()
{
   return tip;
}


public synchronized void updateContext(ThreadContext newThreadContext)
{
    int s = debuggerPanels.size();

    for(int i = 0; i < s; i++)
    {
        DebuggerPanel panel = (DebuggerPanel) debuggerPanels.elementAt(i);
        panel.contextUpdated(newThreadContext);
    }
    setCursor(Cursor.getDefaultCursor());
}


public synchronized Object getDebugger()
{
    return null;
}


}











