//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/tools/debugger/ConsolePanel.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:11:02 [12/11/97 17:00:46]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.URL;

import com.ibm.beans.widgets.ImageButton;
import com.ibm.beans.widgets.ToolTipCanvas;

import com.ibm.beans.tools.debugger.DebuggerPanel;
import com.ibm.beans.tools.debugger.ThreadContext;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;

public class ConsolePanel extends DebuggerPanel implements ComponentListener, ActionListener, Serializable
{

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";
    private static final long serialVersionUID = 2000L;

private transient DebuggerResourceBundle res;
private transient URL urlWithImage;
private transient TextArea consoleList;


public ConsolePanel()
  {
   super();
   internalInit();
  }

public ConsolePanel(ThreadContext newThreadContext)
  {
   super(newThreadContext);
   internalInit();

  }

private void internalInit()
  {
   res = DebuggerResourceBundle.getRes();

   setLayout(null);
   setBackground(Color.white);

   Image image;
   ImageButton b;
   ToolTipCanvas tip = null;
   BeanDebugger bdbg = getBeanDebugger();

   if (bdbg != null)
       tip = bdbg.getBeanDbgView().getTip();
   int nextX = 0;

   {
     image = res.getImage(DebuggerResourceBundle.CLEAR_GIF);
     b = new ImageButton(new Rectangle(nextX, 0, BeanDbgView.BUTTON_WIDTH, BeanDbgView.BUTTON_HEIGHT),
                         5,
                         new Color(200, 200, 200),
                         image,
                         DebuggerResourceBundle.CLEAR_CMD,
                         tip,
                         res.getString(DebuggerResourceBundle.CLEAR_TIP));
     add(b);

     b.addActionListener(this);
     nextX += BeanDbgView.BUTTON_WIDTH;
   }


   {
     image = res.getImage(DebuggerResourceBundle.SAVE_CONSOLE_GIF);
     b = new ImageButton(new Rectangle(nextX,
                       0,
                       BeanDbgView.BUTTON_WIDTH,
                       BeanDbgView.BUTTON_HEIGHT),
                 BeanDbgView.MARGINS,
                 new Color(200, 200, 200),
                 image,
                 DebuggerResourceBundle.SAVE_CONSOLE_CMD,
                 tip,
                 res.getString(DebuggerResourceBundle.SAVE_CONSOLE_TIP));
     add(b);

     b.addActionListener(this);
     nextX += BeanDbgView.BUTTON_WIDTH;
   }


   consoleList = new TextArea(
        res.getString(DebuggerResourceBundle.CONSOLE_READY_MSG)
        +"\n", 132, 1, TextArea.SCROLLBARS_BOTH);
   add(consoleList);

   addComponentListener(this);
  }



public void actionPerformed(ActionEvent event)
  {

   String cmd = event.getActionCommand();

   if (cmd == null)
     return;


   if (cmd.equals(DebuggerResourceBundle.CLEAR_CMD))
     Clear();

  }


public synchronized void Clear()
  {
    consoleList.setText(res.getString(
       DebuggerResourceBundle.CONSOLE_READY_MSG)+"\n");
  }

public synchronized void print(String s)
  {
    consoleList.append(s);
  }


public void componentHidden(ComponentEvent event)
  {
  }

public void componentMoved(ComponentEvent event)
  {
  }

public void componentResized(ComponentEvent event)
  {


    Dimension d = getSize();

   consoleList.setBounds(0,
                         BeanDbgView.BUTTON_HEIGHT + BeanDbgView.MARGINS,
                         d.width,
                         d.height - (BeanDbgView.BUTTON_HEIGHT + BeanDbgView.MARGINS) );

  }

public void componentShown(ComponentEvent event)
  {
  }

  private void readObject (ObjectInputStream in) throws IOException {

      try {

          in.defaultReadObject ();
          internalInit ();
      }
      catch (Exception exp) {
          exp.printStackTrace();
      }
  }

}
