//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.5 com/java/src/com/ibm/beans/tools/debugger/ScrollSourceList.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:00:45 [12/11/97 17:00:30]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.net.*;

import com.ibm.beans.tools.debugger.SRCPanel;

public class ScrollSourceList extends List implements ActionListener 
{
    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

   private SRCPanel sourcePanel;
   int fLineCount;

   public ScrollSourceList( SRCPanel pan)
   {
      sourcePanel = pan;
      fLineCount = 0;
      addActionListener (this);
   }

   public void addLine(int line_no, String line_str)
   {
      String beg = new String ("  " + line_no);
      char[] line_array = beg.toCharArray();

      int i = 0;
      char [] new_array = new char [10];
      for (i = 0; i < line_array.length; i++) 
          new_array[i] = line_array[i];
      for (int j = i; j < 10; j++)
          new_array[j] = ' ';

      String new_str = new String(new_array);
      addItem(new_str.concat(line_str));

      fLineCount += 1;
   }

   public void selectLine (int num) {
       select(num-1);
   }

   public void actionPerformed(ActionEvent evt) {

       changeBreakPoint (getSelectedIndex());
   }

   public void changeBreakPoint (int index) {

      String str = getItem (index);

      boolean bSet = true;

      char [] arr = str.toCharArray();
      if (arr[0] == '<')
          bSet = false; 

      boolean bSuccess = sourcePanel.changeBreakPoint (this, index+1, bSet);

      if (bSuccess) {
          if (bSet) { 
              arr[0] = arr[1] = '<';
              arr[8] = arr[9] = '>';
          }
          else { 
              arr[0] = arr[1] = arr[8] = arr[9] = ' ';
          }

          replaceItem(str.copyValueOf (arr), index);
      }
   }

}



