//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.18 com/java/src/com/ibm/beans/tools/debugger/SourcePanel.java, bbDebugger, bb97c, bb97c9750e 12/3/97 11:08:30 [12/11/97 17:00:37]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.awt.event.*;
import sun.tools.debug.*;

import com.ibm.beans.widgets.ImageButton;
import com.ibm.beans.tools.debugger.*;

public class SourcePanel extends SRCPanel 
      implements ActionListener
{

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

    private transient ImageButton sourceButton;
    private transient SourceFileDialog sourceDialog;
    private transient Vector remoteClasses;
    
    private static final int BUTTON_WIDTH=20;
    private static final int BUTTON_HEIGHT=20;


    public SourcePanel()
    {
        super();
    }

    public SourcePanel(ThreadContext thread_context)
    {
        super(thread_context);
    }

    protected void initData () {
        remoteClasses = new Vector();
        super.initData();
    }

    protected void createPanel()
    {
        super.createPanel();
        DebuggerResourceBundle res = DebuggerResourceBundle.getRes();
        Image image = res.getImage(DebuggerResourceBundle.SOURCE_GIF);

        sourceButton = new ImageButton (
                           new Rectangle(0, 0, BUTTON_WIDTH, BUTTON_HEIGHT),
                           5,
                           new Color(200, 200, 200),
                           image,
                           DebuggerResourceBundle.SOURCE_CMD,
                           null,
                           res.getString(DebuggerResourceBundle.SOURCE_TIP)); 
        add (sourceButton);
        sourceButton.addActionListener (this);
    }

    protected int getChoiceOffset()
    {
        return(BUTTON_WIDTH + 1);        
    }


    public void contextUpdate(RemoteClass cls, int line_no) {

        try
	{
           String str = cls.getSourceFileName();

           // case 1: same file is being shown

           if (str.equals(choices.getSelectedItem()) == true) 
           {

               currentSourceList.selectLine (line_no);
               return;
           }

           int index = remoteClasses.indexOf (cls);
   
           if (index == -1) { 

               ScrollSourceList list;
               Frame mainFrame = getThreadContext().getBeanDebugger().
                              getBeanDbgView().getBeanDbgFrame();

               list = createSourceList (mainFrame, cls, str);

               if (list == null)
                  return;

               sourceLists.addElement(list);
               choices.add (str);
               remoteClasses.addElement (cls);

               if (breakPoints != null)
                  restoreBreakPoints (list, cls);
               index = remoteClasses.size()-1;
           }
 
           changeChoice (index, line_no);
           choices.select(index);
        }
        catch(Exception e)
	{
           e.printStackTrace();
        }
    }

    protected void createSourceLists()
    {
        currentSourceList = new ScrollSourceList (this);
        add (currentSourceList);
        currentSourceList.setLocation (0, LISTHEIGHT);
    }

    protected ScrollSourceList createSourceList( Frame mainFrame,
              RemoteClass cls, String name) 
    {
        InputStream in = null;
        ThreadContext context = getThreadContext();
        String s = null;
 
        try {
            s = cls.getName();
            in = cls.getSourceFile();
        }
        catch (Exception e) {
            showTip (context, 
                mf.format(DebuggerResourceBundle.NO_SOURCE_ERROR, s));
            return null;
        }

        if (in == null) {

            // file is not in class path, so open a dialog


            FileDialog fd = new FileDialog(mainFrame, 
                res.getString(DebuggerResourceBundle.LOAD_SOURCE_LABEL),
                                FileDialog.LOAD);
            fd.setDirectory(System.getProperty("user.dir"));
            fd.setFile(name);
            fd.show();

            if (fd.getFile() == null) {
                showTip (context, 
                   mf.format(DebuggerResourceBundle.NO_SOURCE_ERROR, s));
                return null;
            }
            String fname = fd.getDirectory() + fd.getFile();

            try {
                FileInputStream fin = new FileInputStream (fname);
                in = fin;
            }
            catch (Exception e) {
                showTip (context, 
                   mf.format(DebuggerResourceBundle.NO_SOURCE_ERROR, s));
                return null;
            }
        }

        if (in == null) {
            showTip (getThreadContext(), 
                   mf.format(DebuggerResourceBundle.NO_SOURCE_ERROR, s));
            return null;
        }

        BufferedReader d = null;

        try {

            d = new BufferedReader(new InputStreamReader(in));
            ScrollSourceList list = new ScrollSourceList (this);

            int i = 1;
            String str = d.readLine();
            while (str != null) {
                list.addLine (i, str);
                i++;
                str = d.readLine();
            }

            return list;
        }
        catch (Exception e) {
            if (d != null) {
                try {
                    d.close();
                }
                catch (Exception exp) {}
            }
        }
        return null;
    }

    public void actionPerformed (ActionEvent evt) {

        if (sourceDialog == null)
            sourceDialog = new SourceFileDialog (
              res.getString(DebuggerResourceBundle.NEW_SOURCE_LABEL), this);

        Rectangle r = getThreadContext().getBeanDebugger().getBeanDbgView().
                getBeanDbgFrame().getBounds();
                   
        Dimension d = sourceDialog.getSize();
        Point p  = new Point(r.x + (r.width - d.width) /2, 
              r.y + (r.height - d.height) /2);
        sourceDialog.setLocation (p);
        sourceDialog.show ();
    } 

    public void textEntered (String clsName) {

        if (clsName == null)
            return;

        try {
            RemoteClass cls = getThreadContext().getBeanDebugger().
                     getDebugger().findClass (clsName);

            int index = remoteClasses.indexOf (cls);

            if (index == -1) {

                ScrollSourceList list;
                Frame mainFrame = getThreadContext().getBeanDebugger().
                              getBeanDbgView().getBeanDbgFrame();

                String str = cls.getSourceFileName ();
                list = createSourceList (mainFrame, cls, str);

                if (list == null)
                    return;

                sourceLists.addElement(list);
                choices.add (str);
                remoteClasses.addElement (cls);

                if (breakPoints != null)
                    restoreBreakPoints (list, cls);

                index = remoteClasses.size()-1;
            }

            changeChoice (index, -1);
            choices.select(index);

        }

        catch (Exception exp) {
       
            System.out.println(mf.format(DebuggerResourceBundle.LOAD_CLASS_ERROR,
                     clsName));
        }

    }

    protected RemoteClass getRemoteClass(int index)
    {
       return((RemoteClass)remoteClasses.elementAt(index));
    }

    protected void restoreBreakPoints (ScrollSourceList l, RemoteClass cls) 
                                               throws Exception
    {

        String s = cls.getName() + ":";
        int len = s.length();


        for  (int i = 0; i < breakPoints.length; i++) {

            if (breakPoints[i].startsWith (s)) {

                Integer intObject = new Integer (breakPoints[i].substring (len));
                l.changeBreakPoint (intObject.intValue() - 1); // scroll list
                                                        // index starts from 0
            }
        }

    }
}


class SourceFileDialog extends Frame implements ActionListener, WindowListener {

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

    private TextField textField;
    private Label label;
    private Button okButton;
    private Button cancelButton;
    private DebuggerResourceBundle res;

    public String textString;
    private SourcePanel client;

    public SourceFileDialog (String title, SourcePanel v) 
    {

        super (title);
        res = DebuggerResourceBundle.getRes();
        client = v;
        setSize (185, 175);

        setLayout(null);

        label = new Label(res.getString(
                   DebuggerResourceBundle.CLASS_NAME_LABEL));
        add(label);
        label.setBounds(20,50, 140, 25);

        textField = new TextField(20);
        add(textField);
        textField.setBounds (20, 90, 140, 25);

        okButton = new Button (res.getString(
                   DebuggerResourceBundle.OK_LABEL));
        add (okButton);
        okButton.setBounds (20, 130, 50, 25);

        cancelButton = new Button (res.getString(
                   DebuggerResourceBundle.CANCEL_LABEL));
        add (cancelButton);
        cancelButton.setBounds (90, 130, 50, 25);

        setResizable (false);

        okButton.addActionListener (this);
        cancelButton.addActionListener (this);
        addWindowListener (this);
    }

    public void actionPerformed (ActionEvent evt) {

        String cmd = evt.getActionCommand();

        if (cmd.equals(res.getString(
                   DebuggerResourceBundle.CANCEL_LABEL)))
        {
            String str1 = textField.getText();
            if ((str1 != null) && (str1.trim().equals("") == false))
                    textString = new String (str1);

            if (client != null)
                client.textEntered (textString);
        }     
       
        setVisible (false);
    }

    public void windowClosed(WindowEvent event)
    {
    }

    public void windowClosing(WindowEvent event)
    {
        setVisible(false);
    }

    public void windowDeiconified(WindowEvent event)
    {
    }

    public void windowIconified(WindowEvent event)
    {
    }
    
    public void windowOpened(WindowEvent event)
    {
    }

    public void windowActivated(WindowEvent event)
    {
    }

    public void windowDeactivated(WindowEvent event)
    {
    }


}










