//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/com/ibm/beans/tools/debugger/StackPanel.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:10:49 [12/11/97 17:00:32]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import sun.tools.debug.*;

import com.ibm.beans.widgets.ImageButton;

import com.ibm.beans.tools.debugger.DebuggerPanel;
import com.ibm.beans.tools.debugger.ThreadContext;


public class StackPanel extends DebuggerPanel implements ComponentListener,
  ActionListener, ItemListener, Serializable
{
    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";
    private static final long serialVersionUID = 2000L;

public StackPanel(ThreadContext newThreadContext)
  {
	super(newThreadContext);
	internalInit();
	contextUpdated (newThreadContext);
  }

public StackPanel()
  {
	super();
	internalInit();
  }


private void internalInit()
  {
	setLayout(null);


	stackFrameList = new List();

	stackFrameList.setBackground(Color.white);
	

	add(stackFrameList);

	stackFrameList.addItemListener(this);

	addComponentListener(this);

  }

public synchronized void contextUpdated(ThreadContext context)
  {
        super.contextUpdated(context);

	stackFrameList.removeAll();

	try
	  {

		RemoteThread rt = context.getRemoteThread();
		RemoteStackFrame sf = context.getStackFrame();
		String sfStr = sf != null ? sf.toString() : null;
		

		if (rt != null)
		  {
			RemoteStackFrame stack[] = rt.dumpStack();
			int selected = -1;

			for (int i = stack.length -1 ; i >= 0 ; i--)
			  {
				String s = stack[i].toString();

				if (sfStr != null && sfStr.equals(s))
				  selected = i;
				
				stackFrameList.add(s);
			  }

			if (selected != -1)
			  stackFrameList.select(stack.length - 1 - selected);
		  }

	  }
	catch(Exception e)
	  {
	  }

  }


public void actionPerformed(ActionEvent event)
  {
  }

public synchronized void itemStateChanged(ItemEvent event)
  {

	ThreadContext context = getThreadContext();

	if (context != null && event.getStateChange() == ItemEvent.SELECTED)
	  {

		int i = ((Integer) event.getItem()).intValue();

		try
		  {
			
			RemoteThread rt = context.getRemoteThread();
			
			if (rt != null)
			  {
				RemoteStackFrame stack[] = rt.dumpStack();
				
				if (i < stack.length)
				  {
					int p = stack.length - 1 - i;

					if (stack[p] != null)
					  {
						context.getBeanDebugger().viewStackFrame(stack[p], rt);
					  }
				  }
			  }

		  }
		catch(Exception e)
		  {
		  }

	  }
  }


public void componentHidden(ComponentEvent event)
  {
  }

public void componentMoved(ComponentEvent event)
  {
  }

public void componentResized(ComponentEvent event)
  {
    Dimension d = getSize();


	stackFrameList.setBounds(5, 5, d.width - 10, d.height - 10);

	repaint();

	stackFrameList.repaint();

  }

public void componentShown(ComponentEvent event)
  {
  }

    private void writeObject (ObjectOutputStream out) throws IOException {

        try {

            removeComponentListener(this);
            out.defaultWriteObject ();
            addComponentListener(this);
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }

    private void readObject (ObjectInputStream in) throws IOException {

        try {

            in.defaultReadObject ();
            internalInit ();
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }


private transient List stackFrameList;
}


