//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.5 com/java/src/com/ibm/beans/tools/debugger/TextDialog.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:01:09 [12/11/97 17:00:41]
package com.ibm.beans.tools.debugger;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;

public class TextDialog extends Dialog implements ActionListener, WindowListener {

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

    private TextField clsName;
    private TextField args;
    private Button okButton;
    private Button cancelButton;

    public String clsString;
    public String argString;
    private BeanDbgView client;
    private DebuggerResourceBundle res;

    public TextDialog (Frame frame, boolean bModal, String title, BeanDbgView v) {

        super (frame, title, bModal);
        res = DebuggerResourceBundle.getRes();
        client = v;
        setSize (225, 175);

        setLayout(null);

        Label lbl1 = new Label(
                 res.getString(DebuggerResourceBundle.CLASS_LABEL));

        add(lbl1);
        lbl1.setBounds(20,50, 30, 25);

        Label lbl2 = new Label(
                 res.getString(DebuggerResourceBundle.ARG_LABEL));
        add(lbl2);
        lbl2.setBounds(20,90, 30, 25);

        clsName = new TextField(100);
        add(clsName);
        clsName.setBounds (60, 50, 140, 25);

        args = new TextField(100);
        add(args);
        args.setBounds (60, 90, 140, 25);

        okButton = new Button (
                 res.getString(DebuggerResourceBundle.OK_LABEL));

        add (okButton);
        okButton.setBounds (60, 130, 50, 25);

        cancelButton = new Button (
                 res.getString(DebuggerResourceBundle.CANCEL_LABEL));

        add (cancelButton);
        cancelButton.setBounds (130, 130, 50, 25);

        setResizable (false);

        okButton.addActionListener (this);
        cancelButton.addActionListener (this);

    }

    public void actionPerformed (ActionEvent evt) {

        String cmd = evt.getActionCommand();

        if (cmd.equals(
                 res.getString(DebuggerResourceBundle.OK_LABEL)))
        {
            String str1 = clsName.getText();
            if (str1 != null) {
                if (str1.trim().equals("") == false) {
                    clsString = new String (str1);
                }
            }
            String str2 = args.getText();
            if (str2 != null) {
                if (str2.trim().equals("") == false) {
                    argString = new String (str2);
                }
            }

            if (client != null)
                client.setClassAndArgs (clsString, argString);
        }     
       
        setVisible (false);

    }

    public void windowClosed(WindowEvent event)
    {
    }

    public void windowClosing(WindowEvent event)
    {
        setVisible(false);
    }

    public void windowDeiconified(WindowEvent event)
    {
    }

    public void windowIconified(WindowEvent event)
    {
    }
    
    public void windowOpened(WindowEvent event)
    {
    }

    public void windowActivated(WindowEvent event)
    {
    }

    public void windowDeactivated(WindowEvent event)
    {
    }


}





