//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.12 com/java/src/com/ibm/beans/tools/debugger/ThreadContext.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:00:54 [12/11/97 17:00:33]
package com.ibm.beans.tools.debugger;

import java.util.*;
import java.io.*;
import java.net.*;

import sun.tools.debug.*;

import com.ibm.beans.util.MessageFormatter;
import com.ibm.beans.tools.debugger.BeanDebugger;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;

public class ThreadContext
{
    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";
   private BeanDebugger bdbg;
   private RemoteClass fRemoteClass;
   private RemoteThread fRemoteThread;
   private RemoteStackFrame stackFrame;
   private DebuggerResourceBundle res;

   public ThreadContext(BeanDebugger newBdbg)
   {
      bdbg = newBdbg;
      fRemoteClass = null;
      fRemoteThread = null;
      stackFrame = null;
      res = DebuggerResourceBundle.getRes();
   }

   public synchronized void setStackFrame(RemoteStackFrame newStackFrame)
   {
       stackFrame = newStackFrame;
   }

   public synchronized RemoteStackFrame getStackFrame()
   {
       return stackFrame;
   }


   public BeanDebugger getBeanDebugger ()
   {
      return bdbg;
   }

   public void setRemoteThread(RemoteThread thread)
   {
      fRemoteThread = thread;
   }
   public boolean setRemoteClass(String class_name)
   {
      try
      {
	 fRemoteClass = getClassFromToken(class_name);
      } catch (IllegalArgumentException e)
      {
         // Try stripping method from class.method token.
         int idot = class_name.lastIndexOf(".");
         if (idot == -1)
         {
            MessageFormatter mf = new MessageFormatter(
                     "com.ibm.beans.tools.debugger.DebuggerResourceBundle");
            bdbg.printToConsole(mf.format(DebuggerResourceBundle.INVALID_ID_ERROR,
                 "\"" + class_name + "\""));
            return(false);
         }
      } catch (Exception e)
      {
         e.printStackTrace();
         return(false);
      }
      return(true);
   }
   private RemoteClass getClassFromToken(String idToken) throws Exception
   {
	RemoteObject obj;
	if (idToken.startsWith("0x") ||
	    Character.isDigit(idToken.charAt(0))) {
	    /* It's an object id. */
	    int id;
	    try {
		id = RemoteObject.fromHex(idToken);
	    } catch (NumberFormatException e) {
		id = 0;
	    }
	    if (id == 0 || (obj = bdbg.getDebugger().get(new Integer(id))) == null) {
		throw new IllegalArgumentException();
	    } else if (!(obj instanceof RemoteClass)) {
		throw new IllegalArgumentException();
	    }
	} else {
	    /* It's a class */
	    obj = bdbg.getDebugger().findClass(idToken);
	    if (obj == null) {
		throw new IllegalArgumentException();
	    }
	}
	return (RemoteClass)obj;
    }
   public RemoteThread getRemoteThread()
   {
      return(fRemoteThread);
   }
   public void setRemoteClass(RemoteClass cls)
   {
      fRemoteClass = cls;
   }
   public RemoteClass getRemoteClass()
   {
      return(fRemoteClass);
   }

}


