//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.8 com/java/src/com/ibm/beans/tools/debugger/ThreadTree.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:01:28 [12/11/97 17:00:45]
package com.ibm.beans.tools.debugger;

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;

import sun.tools.debug.*;

import com.ibm.beans.tools.debugger.ThreadPanel;
import com.ibm.beans.tools.debugger.DbgTreeNode;


public class ThreadTree extends DbgTreeNode {

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

    public ThreadTree (ThreadPanel tPanel, RemoteThreadGroup rGroup) {

        super(tPanel, null);
        try {
            setLabel (new String (rGroup.getName()));
        } catch (Exception e) {}

        rtGroup = rGroup;
        rThread = null;

        addThreads(tPanel);
    }

    public ThreadTree (ThreadPanel tPanel, RemoteThread rthread) {

        super(tPanel, null);
        try {
            setLabel (new String (rthread.getName() + " : " +
                      rthread.description() + " : " + rthread.getStatus()));
        } catch (Exception e) {}

        rtGroup = null;
        rThread = rthread;

    }

    private synchronized void addThreads(ThreadPanel tPanel) {

        try {
            RemoteThread [] rt = rtGroup.listThreads(true);
            for (int i = 0; i < rt.length; i++)
            {
                ThreadTree child = new ThreadTree (tPanel, rt[i]);
                addChild (child);
            }
        } catch (Exception e) {}

    }

    public ThreadTree (ThreadPanel tPanel, String label) {

        super(tPanel, label);
    }

    public synchronized RemoteThreadGroup getThreadGroup() {
        return rtGroup;
    }

    public synchronized RemoteThread getThread() {
        return rThread;
    }

    public synchronized boolean handleMouseClickInView (int x, int y) {

        if ((rThread != null) && (children == null) && (rtGroup == null) && 
            (Math.abs (y - lastDrawY) <= fBoxHeight / 2)) {

            // this is not a threadgroup

            ((ThreadPanel)dbgPanel).getPopup(this).show(dbgPanel, x, y);

            return false; 
        }
        else
            return super.handleMouseClickInView (x, y);
    }

    private RemoteThreadGroup rtGroup;
    private RemoteThread rThread;
}
