//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.13 com/java/src/com/ibm/beans/tools/debugger/VariablePanel.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:10:59 [12/11/97 17:00:43]
package com.ibm.beans.tools.debugger;

import java.lang.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;
import sun.tools.debug.*;

import com.ibm.beans.tools.debugger.DebuggerPanel;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;

public class VariablePanel extends DbgTreePanel implements Serializable {

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";
    private static final long serialVersionUID = 2000L;

private transient DebuggerResourceBundle res;

    public VariablePanel (ThreadContext threadContext) {

        super(threadContext);
        res = DebuggerResourceBundle.getRes();
        contextUpdated (threadContext);
    }

    public VariablePanel () {

        super();
        res = DebuggerResourceBundle.getRes();
    }

    public synchronized void contextUpdated(ThreadContext newThreadContext)
    {

        super.contextUpdated(newThreadContext);
        RemoteStackFrame newFrame = newThreadContext.getStackFrame();

        // Add the default ones
        Vector topLevels = getTreeList();
        topLevels.removeAllElements();

        if (newFrame == null) {
        VariableTree errMsg = new VariableTree (this, 
            res.getString(DebuggerResourceBundle.NO_DEF_THREAD_MSG));
            topLevels.addElement (errMsg);
        }

        else {

            VariableTree methodArgs = new VariableTree (this, 
            res.getString(DebuggerResourceBundle.METHOD_ARGUMENT_MSG));
            topLevels.addElement(methodArgs);

            VariableTree localVars = new VariableTree (this, 
            res.getString(DebuggerResourceBundle.LOCAL_VARIABLE_MSG));
            topLevels.addElement (localVars);


            try {
                addVarInfo (methodArgs, localVars, newFrame);
            } catch(Exception e) {
               e.printStackTrace();
            }
       }

       adjustScrollbars();
    }


  /**
   * Add Var info
   * @exception Exception my be thrown
   */
    private synchronized void addVarInfo(VariableTree methodArgs, VariableTree localVars, RemoteStackFrame newFrame) throws Exception {

        RemoteStackVariable rsv[] = newFrame.getLocalVariables();
        if (rsv == null || rsv.length == 0) {
            methodArgs.setLabel(
             res.getString(DebuggerResourceBundle.NO_ARGUMENT_MSG));
            localVars.setLabel(
             res.getString(DebuggerResourceBundle.NO_LOCAL_VAR_MSG));
            return;
        }

        for (int i = 0; i < rsv.length; i++) {

            VariableTree newElement = new VariableTree (this, rsv[i]);

            if (rsv[i].methodArgument())
                methodArgs.addChild(newElement);
            else
                localVars.addChild(newElement);
        }

        if (methodArgs.hasChildren())
            methodArgs.setExpansionState(true);
        if (localVars.hasChildren())
            localVars.setExpansionState(true);

    }

    private void readObject (ObjectInputStream in) throws IOException {

        try {

            in.defaultReadObject ();
            res = DebuggerResourceBundle.getRes();
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }


}

