//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.12 com/java/src/com/ibm/beans/tools/debugger/VariableTree.java, bbDebugger, bb97c, bb97c9750e 11/18/97 17:01:03 [12/11/97 17:00:38]
package com.ibm.beans.tools.debugger;

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;
import java.util.*;
import sun.tools.debug.*;

import com.ibm.beans.tools.debugger.VariablePanel;
import com.ibm.beans.tools.debugger.DbgTreeNode;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;
import com.ibm.beans.util.MessageFormatter;

public class VariableTree extends DbgTreeNode {

    private final static String kBeanExtenderIBMCopyright =
                               "(c) Copyright IBM Corporation 1997";

private DebuggerResourceBundle DBResourceBundle;
private MessageFormatter mf;

    public VariableTree (VariablePanel newVarPanel, String newLabel) {

        super(newVarPanel, newLabel);
        remoteVar = null;
        remoteVal = null;
        DBResourceBundle = (DebuggerResourceBundle)
            ResourceBundle.getBundle("com.ibm.beans.tools.debugger.DebuggerResourceBundle");
        mf = new MessageFormatter("com.ibm.beans.tools.debugger.DebuggerResourceBundle");
    }

    public VariableTree (VariablePanel newVarPanel, RemoteStackVariable rVar) {

        super (newVarPanel, null);
        remoteVar = rVar;
        remoteVal = rVar.getValue();

        DBResourceBundle = (DebuggerResourceBundle)
            ResourceBundle.getBundle("com.ibm.beans.tools.debugger.DebuggerResourceBundle");
        mf = new MessageFormatter("com.ibm.beans.tools.debugger.DebuggerResourceBundle");

        String newLabel = new String(remoteVar.getName());

        if (remoteVar.inScope()) {
            newLabel = newLabel + " = ";
            newLabel = computeRHSLabel(newLabel);
        }
        else
            newLabel = mf.format(DBResourceBundle.NOT_IN_SCOPE_ERROR, 
                             newLabel);

        setLabel(newLabel);
    }

    public VariableTree (VariablePanel newVarPanel, String origLabel, RemoteValue rVal) {

        super (newVarPanel, null);
        remoteVal = rVal;

        DBResourceBundle = (DebuggerResourceBundle)
            ResourceBundle.getBundle("com.ibm.beans.tools.debugger.DebuggerResourceBundle");
        mf = new MessageFormatter("com.ibm.beans.tools.debugger.DebuggerResourceBundle");

        String newLabel = new String (origLabel + " = ");
        newLabel = computeRHSLabel(newLabel);
        setLabel(newLabel);

    }

    private synchronized String computeRHSLabel (String oldLabel) {

        String str = (String)DBResourceBundle.getRes().getString(
                           DBResourceBundle.ARRAY_MSG);
        String label = new String (oldLabel);

        if (remoteVal == null)
            label = label + " null";

        else {

            try {
                if (remoteVal.isObject()) {
                    label = label + remoteVal.description();
                    addObjectInfo();
                }
                else if (remoteVal.typeName().equalsIgnoreCase(str)) {
                   RemoteArray rArr  = (RemoteArray)remoteVal;
                   label = label + mf.format(DebuggerResourceBundle.ARRAY_ALL_MSG,
                               String.valueOf(rArr.getSize()), 
                               rArr.arrayTypeName(rArr.getElementType()));

                   addArrayInfo();
                }
                else {
                   label = label + remoteVal.toString();
                }
            } catch (Exception e) {}
        }

        return label;

     }

    private synchronized void addObjectInfo () throws Exception {

        RemoteObject rObj = (RemoteObject)remoteVal;
        String className = mf.format("db_ClassEql" + rObj.getClazz().getName());
        VariableTree newElement = new VariableTree ((VariablePanel)getDbgPanel(), className);
        addChild (newElement);

        String desc = remoteVal.toString();
        int pos = desc.indexOf("[");
        if (pos != -1) {
            String attr = mf.format("db_Attrib" + desc.substring(pos, desc.length()));
            VariableTree newAttr = new VariableTree ((VariablePanel)getDbgPanel(), attr);
            addChild (newAttr);

        }
    }

    private synchronized void addArrayInfo () throws Exception {

        RemoteArray rArr  = (RemoteArray)remoteVal;
        String tempLabel = null;

        if (remoteVar != null)
            tempLabel = new String(remoteVar.getName());
        else {
            int pos = label.indexOf("=");
            if (pos == -1)
                tempLabel = new String(getLabel());
            else
                tempLabel = new String (getLabel().substring(0, pos-1));
        }

        for (int i = 0; i < rArr.getSize(); i++) {

            RemoteValue rVal = rArr.getElement(i);
            String anotherLabel = new String(tempLabel + "[" + i + "]");
            VariableTree newNode = new VariableTree ((VariablePanel)getDbgPanel(), anotherLabel, rVal);
            addChild(newNode);
        }

    }

    public RemoteStackVariable remoteVar;
    public RemoteValue remoteVal;
}
