//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.2 com/java/src/COM/ibm/beans/debugger/BeanDbgView.java, bbUtils, bb97a, bb97a9724c 6/9/97 14:57:09 [6/16/97 04:06:16]
package com.ibm.beans.tools.debugger.scrdbg;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import sun.tools.debug.*;

import com.ibm.beans.widgets.ImageButton;

import com.ibm.beans.tools.debugger.BeanDbgView;
import com.ibm.beans.tools.debugger.BeanDebugger;
import com.ibm.beans.tools.debugger.ThreadContext;
import com.ibm.beans.tools.debugger.DebuggerPanel;
import com.ibm.beans.tools.debugger.DebuggerResourceBundle;

import com.ibm.beans.tools.debugger.scrdbg.SCRDbgResourceBundle;
import com.ibm.beans.tools.debugger.scrdbg.SCRSourcePanel;

import com.ibm.beans.script.comps.java.SCRJavaEditableObj;


public class SCRBeanDbgView extends BeanDbgView
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
protected SCRJavaEditableObj[] editableObjs;
protected String className;

/********************************************************
 Constructors
********************************************************/

public SCRBeanDbgView ()
{
    super();
    editableObjs = null;
    className = null;
}

public SCRBeanDbgView (String argv[], BeanDebugger bdbg)
{
    super(argv, bdbg);
    editableObjs = null;
    className = null;
}

/*
protected URL  getImgURLResource(DebuggerResourceBundle rb, String img_key)
{
    return(this.getClass().getSuperclass().getResource(
          (String)rb.handleGetObject(img_key)));
}
*/

protected void internalInit()
{
   super.internalInit();

   SCRDbgResourceBundle rb = SCRDbgResourceBundle.getRes();

   Image image = rb.getImage(SCRDbgResourceBundle.SCRIPT_GIF);
   ImageButton b = new ImageButton(
                         new Rectangle(buttonEnd, 0, BUTTON_WIDTH, BUTTON_HEIGHT),
                         MARGINS,
                         new Color(200, 200, 200),
                         image,
                         SCRDbgResourceBundle.SCRIPT_CMD,
                         tip,
			 rb.getString(SCRDbgResourceBundle.SCRIPT_TIP));
   add(b);

   b.addActionListener(this);
   buttonEnd += BUTTON_WIDTH;
}



public void actionPerformed(ActionEvent event)
{
    String cmd = event.getActionCommand();
    if (cmd == null)
        return;
    if (cmd.equals(SCRDbgResourceBundle.SCRIPT_CMD))
        startScriptPanel();
    else 
        super.actionPerformed(event);
}

public void startScriptPanel()
{
   addDebuggerPanel(new SCRSourcePanel(getRemoteClass(), editableObjs,
		     beanDebugger.getThreadContext() ));
}

public synchronized void updateContext(ThreadContext newThreadContext)
{
    int s = debuggerPanels.size();

    for(int i = 0; i < s; i++)
    {
        DebuggerPanel panel = (DebuggerPanel) debuggerPanels.elementAt(i);
        if(panel instanceof SCRSourcePanel)
	{
           if(className == null)
              continue;
           SCRSourcePanel scr_panel = (SCRSourcePanel)panel;
           scr_panel.init(getRemoteClass(), editableObjs, beanDebugger);
        }
        panel.contextUpdated(newThreadContext);
    }
    setCursor(Cursor.getDefaultCursor());
}



public void setClassName(String cls_name)
{
   className = cls_name;
}

public void setEditableObjs(SCRJavaEditableObj[] edit_objs)
{
   editableObjs = edit_objs;
   setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
}

protected RemoteClass getRemoteClass()
{
  try
  {
     return(beanDebugger.getDebugger().findClass (className));
  }
  catch(Exception e)
  {
     e.printStackTrace();
  }  
  return(null);
}

protected void readState (ObjectInput s) throws Exception {

        super.readState(s);
	//editableObjs = (SCRJavaEditableObj[])s.readObject();
        //className = (String)s.readObject();
}

protected void writeState (ObjectOutput out) throws IOException {

      super.writeState(out);
      //out.writeObject (editableObjs);
      //out.writeObject (className);
}

public void setBeanDebugger(BeanDebugger bdbg)
  {
     beanDebugger = bdbg;
  }

protected String getSavedFileName()
{
   return("SCRDbgSave");
}

protected void removeBreakpoints()
{
    try
    {
    RemoteDebugger dbg = beanDebugger.getDebugger();
    String [] bps = dbg.listBreakpoints(); 
    if(bps == null)
       return;
    for(int i = 0; i < bps.length; i++)
    {
       int index = bps[i].indexOf(':');
       String cls_name = bps[i].substring(0, index);
       Integer l = new Integer(bps[i].substring(index + 1));
       int line_no = l.intValue();
       RemoteClass cls = dbg.findClass(cls_name);
       cls.clearBreakpointLine(line_no);
    }
    }
    catch(Exception e)
    {
       e.printStackTrace();
    }
}
}



