//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/COM/ibm/beans/debugger/SourcePanel.java, bbUtils, bb97a, bb97a9724c 6/9/97 14:57:16 [6/16/97 04:04:17]
package com.ibm.beans.tools.debugger.scrdbg;

import java.lang.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.beans.util.StreamThread;
import com.ibm.beans.util.StreamViewer;
import com.ibm.beans.tools.debugger.BeanDebugger;
import com.ibm.beans.tools.debugger.BeanDbgFrame;
import com.ibm.beans.tools.debugger.scrdbg.SCRDbgResourceBundle;
import com.ibm.beans.tools.debugger.scrdbg.SCRBeanDbgView;
import com.ibm.beans.tools.debugger.scrdbg.SCRConnectionConstants;
import com.ibm.beans.script.comps.java.SCRJavaEditableObj;

public class SCRJavaDBGClient implements WindowListener
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    protected BeanDebugger bdbg;
    protected BeanDbgFrame dbgFrame;
    protected SCRBeanDbgView view;
    protected String serverName;
    protected Socket outSocket;

    protected SCRClientConnection clientConnection;

    public SCRJavaDBGClient (String hostName, String passwordString)

    { 

        try
	{        
           bdbg =  new BeanDebugger (hostName, passwordString);

           Socket inSocket = new Socket (
                        InetAddress.getLocalHost (), 8189);
           if(bdbg.getDebugger() != null)
	   {
              view = new SCRBeanDbgView(null, bdbg);
              view.setBeanDebugger(bdbg);
              SCRDbgResourceBundle res = SCRDbgResourceBundle.getRes();
              dbgFrame = new BeanDbgFrame (
                res.getString(SCRDbgResourceBundle.SCR_DBG_LABEL), view);
              dbgFrame.addWindowListener(this);
              dbgFrame.setVisible (true);
           }
           else
              dbgFrame = null;
           clientConnection = new SCRClientConnection (this, inSocket);
           clientConnection.start ();
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }
    }

    public boolean debuggerReady()
    {
       if(bdbg != null && dbgFrame != null)
          return(bdbg.getDebugger() != null);
       return(false);
    }

    public static void main (String [] argv) {
        try
	{
          PipedInputStream inOut    = new PipedInputStream();
          PrintStream      printOut = new PrintStream(
                                      new PipedOutputStream( inOut ), true );
          System.setOut( printOut );
          System.setErr( printOut );
           (new StreamThread( inOut, new StreamViewer( "Remote Debugger") ))
            .start();
        }
        catch(Exception e)
        {
        }
        if (argv.length < 2)
            System.exit(0);

        SCRJavaDBGClient c = new SCRJavaDBGClient (argv[0], argv[1]);
    }

    public void closeDebugger ()
    {
        try
	{
        if (dbgFrame != null) {
            view.removeBreakpoints();
            dbgFrame.closeDebugger ();
            dbgFrame.setVisible (false);
            dbgFrame.dispose();
            System.gc();
        }
        //clientConnection.destroy();
        outSocket.close();
        System.exit(0);
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }
    }

    public void setBreakpointLine (String clsName, int num)
    {
        if (bdbg != null) 
            bdbg.setBreakpointLine (clsName, num);
    }

    public void setBreakpointMethod (String clsName, String methodName)
    {
        try
	{
           if (bdbg != null) 
	   {
              bdbg.setBreakpointMethod (clsName, methodName);
           }
	}
        catch(Exception e)
	{
           e.printStackTrace();
        }
    }

    public SCRBeanDbgView getView()
    {
       return(view);
    }

    public void windowDeiconified(WindowEvent event)
    {
    }

    public void windowIconified(WindowEvent event)
    {
    }

    public void windowOpened(WindowEvent event)
    {
    }

    public void windowActivated(WindowEvent event)
    {
    }

    public void windowDeactivated(WindowEvent event)
    {
    }

    public void windowClosed(WindowEvent event)
    {
    }

    public void windowClosing(WindowEvent event)
    {
       messageOutput(SCRConnectionConstants.SCRClientCloseRequest);
    }

    public void createOutSocket()
    {
       try
       {
          outSocket = new Socket (InetAddress.getLocalHost (), 8189);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
    }

    public void messageOutput(int msg)
    {
       try
       {
       outSocket.getOutputStream().write(msg);
       outSocket.getOutputStream().flush();
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
    }
} 

class SCRClientConnection extends Thread {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    SCRJavaDBGClient dbgClient;
    Socket socket;
    protected ObjectInputStream in;

    public SCRClientConnection (SCRJavaDBGClient c, Socket in) {

        super();
        dbgClient = c;
        socket = in;
    }


    public void run () {

        try {

            int outmsg = SCRConnectionConstants.SCRClientReady;

            while (true) {
               in = new ObjectInputStream(socket.getInputStream()); 
               int cmd = in.readInt();
               outmsg = processCmd (cmd);
               if(outmsg != -1)
	       {
                  dbgClient.messageOutput(outmsg);
               }
               if(outmsg == SCRConnectionConstants.SCRClientClosed)
	       {
      		 // sleep(2000);
                  socket.close();
                  dbgClient.closeDebugger();    
                  break;
               }
            } 

        }

        catch (Exception e) {

            System.out.println (" Exception from client " + e);
            e.printStackTrace ();
        }
    }

    private int processCmd(int cmd) {
 
        int rtn = -1;   
        try
	{
           if(cmd == SCRConnectionConstants.SCRServerCloseClient)
	   {
                 rtn = SCRConnectionConstants.SCRClientClosed;
           }
           else if(cmd == SCRConnectionConstants.SCRServerWaitForInSocket)
	   {
                dbgClient.createOutSocket();
                if(dbgClient.debuggerReady())
                   rtn = SCRConnectionConstants.SCRClientReady;
                else
                   rtn = SCRConnectionConstants.SCRClientFailed;
           }
           else if(cmd == SCRConnectionConstants.SCRServerSetDBGInfo)
	   {
                 String cls_name = (String)in.readObject();
                 SCRBeanDbgView view = dbgClient.getView();
                 view.setClassName(cls_name);
                 SCRJavaEditableObj[] editableObjs =
                       (SCRJavaEditableObj[])in.readObject();
                 view.setEditableObjs(editableObjs);
                 String methodName = (String)in.readObject();
                 dbgClient.setBreakpointMethod (cls_name, methodName);
                 rtn = SCRConnectionConstants.SCRClientBreakPointSet;
           }
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }
        return(rtn);
    }
   
    public Socket getSocket () {
        return socket;
    }

}








