//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/COM/ibm/beans/debugger/SourcePanel.java, bbUtils, bb97a, bb97a9724c 6/9/97 14:57:16 [6/16/97 04:04:17]
package com.ibm.beans.tools.debugger.scrdbg;

import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.*;
import com.ibm.beans.util.MessageFormatter;
import com.ibm.beans.tools.debugger.scrdbg.SCRConnectionConstants;
import com.ibm.beans.tools.debugger.scrdbg.SCRDbgResourceBundle;
import com.ibm.beans.script.comps.java.SCRJavaDBGRTComponent;
import com.ibm.beans.script.comps.java.SCRJavaEditableObj;

public class SCRJavaDBGServer 
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    private Vector clients;
    private SCRJavaDBGRTComponent scriptingApp;
    private ObjectOutputStream out;
    private Socket outSocket;
    private SCRServerThread serverThread;
    private ServerSocket srvSocket;
    private String initName = null;

    public SCRJavaDBGServer (SCRJavaDBGRTComponent myApp, String password) {

        scriptingApp = myApp;
        clients = new Vector ();

        try
	{
           srvSocket = new ServerSocket (8189);
           serverThread = new SCRServerThread (this, srvSocket);
           serverThread.start ();
           createDebugger ("localhost",  password);
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }
    }

    public void setOutSocket(Socket out_socket)
    {
       try
       {
       outSocket = out_socket;
       out = new ObjectOutputStream(outSocket.getOutputStream());
       out.writeInt(SCRConnectionConstants.SCRServerWaitForInSocket);
       out.flush();
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
    }
    public ServerSocket getSrvSocket()
    {
       return srvSocket;
    }
    public Process createDebugger ( String hostName, String passwordString)
    {
     
        SCRDbgResourceBundle res = SCRDbgResourceBundle.getRes();
        try {
            String str = new String (
             "java com.ibm.beans.tools.debugger.scrdbg.SCRJavaDBGClient " + 
                                      hostName + " " + passwordString);
            System.out.println (
              res.getString(SCRDbgResourceBundle.START_DBG_MSG));
            Process p = Runtime.getRuntime().exec(str);
            return p;
        }

        catch (java.io.IOException e) {
            System.out.println (
             res.getString(SCRDbgResourceBundle.START_DBG_EXC));
            e.printStackTrace();
        }
        return null;
    }

    public void setDBGInfo(String clsName, SCRJavaEditableObj[] editableObjs,
                       String methodName)
    {

        try {
            initName = methodName;
            out = new ObjectOutputStream(outSocket.getOutputStream());
            int msg = SCRConnectionConstants.SCRServerSetDBGInfo;
            out.writeInt(msg);
            out.flush(); 
            out.writeObject(clsName);
            out.writeObject(editableObjs);
            out.writeObject(methodName);
            out.flush(); 
        }
        catch (Exception exp) {
            exp.printStackTrace ();
        }

    }

    public void debuggerReady ()
    {
        SCRDbgResourceBundle res = SCRDbgResourceBundle.getRes();
        System.out.println (
              res.getString(SCRDbgResourceBundle.START_DBG_MSG));
        scriptingApp.debuggerReady ();
    }

    public void debuggerFailed ()
    {
        SCRDbgResourceBundle res = SCRDbgResourceBundle.getRes();

        System.out.println (
              res.getString(SCRDbgResourceBundle.START_DBG_ERROR));
        scriptingApp.debuggerFailed ();
    }

    public void debuggerBreakPointSet ()
    {
        MessageFormatter mf = new MessageFormatter(
                     "com.ibm.beans.tools.debugger.scrdbg.SCRDbgResourceBundle");
        System.out.println(mf.format(
           SCRDbgResourceBundle.CONN_FINISH_MSG, initName));
        scriptingApp.debuggerBreakPointSet ();
    }

    public void debuggerCloseRequest ()
    {
        scriptingApp.debuggerCloseRequest ();
    }

    public void closeDebugger ()
    {
        try {
            out = new ObjectOutputStream(outSocket.getOutputStream());
            out.writeInt(SCRConnectionConstants.SCRServerCloseClient);
            out.flush();
        }
        catch (Exception exp) {
            exp.printStackTrace ();
        }

    }

    public void clientClosed ()
    {
        try {
            outSocket.close();
            srvSocket.close();
        }
        catch (Exception exp) {
            exp.printStackTrace ();
        }

    }


  /* 
    public void closeAllDebuggers ()
    {
        
        for (int i = 0; i < clients.size(); i++) {

            Socket s = (Socket) clients.elementAt (i);

            try {
                String a = new String (
                         SCRConnectionConstants.SCRServerCloseClient + " ");
                byte []b = a.getBytes();
                s.getOutputStream(). write (b);
                s.getOutputStream().flush();
            }

            catch (Exception exp) {
                exp.printStackTrace ();
            }
        }

        clients.removeAllElements();
    }
    */

}

class SCRServerThread extends Thread  {
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    SCRJavaDBGServer dbgServer;
    ServerSocket serverSocket;
    Socket in;

    public SCRServerThread (SCRJavaDBGServer server, ServerSocket srvSocket) {
   
        super();
        try
	{
        dbgServer = server;
        }
        catch(Exception e)
        {
           e.printStackTrace();
        }
    }

    public void run () {

        try {
            Socket s = dbgServer.getSrvSocket().accept ();
            dbgServer.setOutSocket(s);
            ServerSocket ss = dbgServer.getSrvSocket();
            in = ss.accept ();
            for (;;) {
                    int val = in.getInputStream().read();
                    if (val == SCRConnectionConstants.SCRClientClosed)
                    { 
                        in.close();
                        dbgServer.clientClosed ();
                        break;
                    }
                    if (val == SCRConnectionConstants.SCRClientReady)
                        dbgServer.debuggerReady ();
                    else if (val == SCRConnectionConstants.SCRClientFailed)
                        dbgServer.debuggerFailed ();
                    else if(val == 
                       SCRConnectionConstants.SCRClientCloseRequest)
                        dbgServer.debuggerCloseRequest ();
                    else if (val == 
                            SCRConnectionConstants.SCRClientBreakPointSet)
		    {
                        dbgServer.debuggerBreakPointSet ();
                    }
            }
        }
        catch (Exception e) {
            e.printStackTrace ();       
        }
    }
    void close()
    {
      //       serverSocket.close();
       destroy();
    }
}



















