//====START_GENERATED_PROLOG======================================
//
//
//   COMPONENT_NAME: bbUtils
//
//   CLASSES: none
//
//   ORIGINS: 27
//
//
//   (C) COPYRIGHT International Business Machines Corp. 1997
//   All Rights Reserved
//   Licensed Materials - Property of IBM
//   US Government Users Restricted Rights - Use, duplication or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//   	
//   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
//   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
//   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
//   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
//   OR PERFORMANCE OF THIS SOFTWARE.
//
//====END_GENERATED_PROLOG========================================
//
// @(#) 1.11 com/java/src/COM/ibm/beans/debugger/SourcePanel.java, bbUtils, bb97a, bb97a9724c 6/9/97 14:57:16 [6/16/97 04:04:17]
package com.ibm.beans.tools.debugger.scrdbg;

import java.awt.*;
import java.awt.event.*;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.awt.event.*;
import sun.tools.debug.*;
import com.ibm.beans.tools.debugger.SRCPanel;
import com.ibm.beans.tools.debugger.BeanDebugger;
import com.ibm.beans.tools.debugger.ThreadContext;
import com.ibm.beans.tools.debugger.ScrollSourceList;
import com.ibm.beans.script.comps.java.SCRJavaEditableObj;

public class SCRSourcePanel extends SRCPanel 
{
   private static final String kBeanExtenderIBMCopyright=
                 "(c) Copyright IBM Corporation 1997";
    private static final int LISTHEIGHT = 20;

    private RemoteClass remoteClass;
    private SCRJavaEditableObj[] editableObjs;

    public SCRSourcePanel()
    {
        super();
        remoteClass = null;
        editableObjs = null;
    }
    public SCRSourcePanel(RemoteClass remote_class, 
                          SCRJavaEditableObj[] editable_objs,
                          BeanDebugger bdbg)
    {
        super();
        init(remote_class, editable_objs, bdbg);
    }

    protected void initData () {
        remoteClass = null;
        editableObjs = null;
        super.initData();
    }

    public SCRSourcePanel(RemoteClass remote_class, 
                          SCRJavaEditableObj[] editable_objs,
                          ThreadContext thread_context)
    {
        super();
        remoteClass = null;
        threadContext = thread_context;
        init(remote_class, editable_objs, threadContext.getBeanDebugger());
        contextUpdated (thread_context);
    }

    void init(RemoteClass remote_class, SCRJavaEditableObj[] editable_objs,
              BeanDebugger bdbg) 
    {
        if(remoteClass == null)
	{
           remoteClass = remote_class;
           editableObjs = editable_objs;
           beanDebugger = bdbg;
           createMySourceLists();
           restoreBreakPoints();
        }
    }

    public void contextUpdate(RemoteClass cls, int line_no)
    {
        if (cls == remoteClass) 
        {
            for(int i = 0; i < editableObjs.length; i++)
	    {
               if(line_no >= editableObjs[i].getBeginLine() &&
                  line_no <= editableObjs[i].getEndLine())
	       {
                  changeChoice(i, line_no - 
                               editableObjs[i].getBeginLine() + 1);
                  break;
               }
            }
        }
    }


    protected void createSourceLists()
    {
       ScrollSourceList src_list = new ScrollSourceList(this);
       currentSourceList = src_list;
       sourceLists.addElement(src_list);
       choices.add(" "); 
       //       src_list.addLine(0, "   ");
       add (currentSourceList);
       //currentSourceList.setVisible (true);
    }

    protected void createMySourceLists()
     {
       remove (currentSourceList);
       currentSourceList.setVisible (true);
       choices.removeAll();
       sourceLists.removeAllElements();

       for(int i = 0; i < editableObjs.length; i++)
       {
          ScrollSourceList src_list;
          src_list = new ScrollSourceList(this);
          sourceLists.addElement(src_list);
          if(i == 0)
             currentSourceList = src_list;
          choices.add(editableObjs[i].getTitle()); 
          String code = editableObjs[i].getCode();
          int start = 0, line_no = 0;
          int end;
          do
          {
             end = code.indexOf('\n', start);
             if(end == -1)
                src_list.addLine(line_no, code.substring(start));
             else
                src_list.addLine(line_no, code.substring(start, end));
             start = end + 1;
             line_no++;
          }while(end != -1);
       }
    }

    protected int getRealSourceLineNum(int num, int index)
    {
       return(editableObjs[index].getBeginLine() + num - 1);
    }

    protected RemoteClass getRemoteClass(int index)
    {
       return(remoteClass);
    }


    protected void restoreBreakPoints () 
    {
        try
        {
           String s = remoteClass.getName() + ":";
           int len = s.length();

           breakPoints = beanDebugger.getDebugger().listBreakpoints();

           if(breakPoints != null)
           for  (int i = 0; i < breakPoints.length; i++) 
           {

               if (breakPoints[i].startsWith (s)) 
               {

                Integer intObject = new Integer (breakPoints[i].substring (len));
                int line_no = intObject.intValue();
                for(int j = 0; j < editableObjs.length; j++)
		{
                   SCRJavaEditableObj edit_obj = editableObjs[j];
                   if(edit_obj.getBeginLine() <= line_no &&
                      edit_obj.getEndLine() >= line_no)
		   {
                      ScrollSourceList list = 
                            (ScrollSourceList)sourceLists.elementAt(j);
                      list.changeBreakPoint (line_no - 
                               edit_obj.getBeginLine()); // scroll list
                                                        // index starts from 0
                   }
                }
               }
           }
        }
        catch(Exception e)
        {
           e.printStackTrace();
	} 
    }

  /*
    public void writeExternal (ObjectOutput out) throws IOException {

        try {

            super.writeExternal (out);
            out.writeObject(remoteClass);
            out.writeObject(editableObjs);
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }


    public void readExternal (ObjectInput in) throws IOException {

        try {

            super.readExternal (in);
            remoteClass = (RemoteClass)in.readObject();
            editableObjs = (SCRJavaEditableObj[])in.readObject();
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }
	*/

}





